<?php

namespace Service;

class WebSocketService {

	protected $entityManager;
	protected $util;

	public function __construct(
		\Doctrine\ORM\EntityManager $entityManager,
		\Util\Util $util,
		$pos0000196913) {

		$this->entityManager = $entityManager;
		$this->util = $util;
        $this->pos0000196913 = $pos0000196913;
        $this->INSERT_KDSOPERACAOTEMP = $this->pos0000196913 ? "INSERT INTO KDSOPERACAOTEMP	(DSOPERACAO) VALUES (:DSOPERACAO)" : "INSERT INTO KDSOPERACAOTEMP (DSOPERACAO, NRSEQOPERACAO) VALUES (:DSOPERACAO, :NRSEQOPERACAO)";
	}

	public function playItem($CDFILIAL, $NRPEDIDOFOS, $NRITPEDIDOFOS) {
		$operationParams = array(
			'CDFILIAL'      => $CDFILIAL,
			'NRPEDIDOFOS'   => $NRPEDIDOFOS,
			'NRITPEDIDOFOS' => $NRITPEDIDOFOS
		);
		$operation = array(
			'operation' => 'playItem',
			'params'   => $operationParams
		);
		$operation = json_encode($operation);
		
        if($this->pos0000196913){
            $params = array(
                ':DSOPERACAO'    => $operation
            );
        } else {
            $params = array(
                ':NRSEQOPERACAO' => $this->getNewKDSOPERACAOTEMP(),
                ':DSOPERACAO'    => $operation
            );
        }
        
		$this->entityManager->getConnection()->executeQuery($this->INSERT_KDSOPERACAOTEMP, $params);
	}

    public function getStatisticsFromOneClient($CDFILIAL, $CDSETOR){
		// envia estatisticas
		$params = array(
			':CDFILIAL' => $CDFILIAL, // T de todos
			':CDSETOR'  => $CDSETOR, // T de todos
            ':IDTIPOSETOR' => 'E'// T de todos
		);
		$newStatistics = $this->entityManager->getConnection()->fetchAll(\Util\Query::GET_STATISTICS, $params);

        // Na primeira expedição, o array $newStatistics retorna vazio.
        // A partir da terceira, acontece a atualização.

        $GET_SETOREST = 'SELECT * FROM KDS_TEMP_SETOREST';
        $newVar = $this->entityManager->getConnection()->fetchAll($GET_SETOREST, []);

		return $newStatistics;
	}

	public function concludeZoomEvent($CDFILIAL, $NRPEDIDOFOS, $NRITPEDIDOFOS, $IDSITITPEDFOS) {
		$operationParams = array(
			'CDFILIAL'      => $CDFILIAL,
			'NRPEDIDOFOS'   => $NRPEDIDOFOS,
			'NRITPEDIDOFOS' => $NRITPEDIDOFOS,
			'IDSITITPEDFOS' => $IDSITITPEDFOS
		);
		$operation = array(
			'operation' => 'concludeZoomEvent',
			'params'   => $operationParams
		);
		$operation = json_encode($operation);

		if($this->pos0000196913){
            $params = array(
                ':DSOPERACAO'    => $operation
            );
        } else {
            $params = array(
                ':NRSEQOPERACAO' => $this->getNewKDSOPERACAOTEMP(),
                ':DSOPERACAO'    => $operation
            );
        }

		$this->entityManager->getConnection()->executeQuery($this->INSERT_KDSOPERACAOTEMP, $params);
 	}

	public function concludeItem($CDFILIAL, $NRPEDIDOFOS, $NRITPEDIDOFOS, $IDSITITPEDFOS, $CDSETOR = null) {
		$operationParams = array(
			'CDFILIAL'      => $CDFILIAL,
			'NRPEDIDOFOS'   => $NRPEDIDOFOS,
			'NRITPEDIDOFOS' => $NRITPEDIDOFOS,
			'IDSITITPEDFOS' => $IDSITITPEDFOS,
			'CDSETOR'		=> $CDSETOR
		);
		$operation = array(
			'operation' => 'concludeItem',
			'params'   => $operationParams
		);
		$operation = json_encode($operation);

		if($this->pos0000196913){
            $params = array(
                ':DSOPERACAO'    => $operation
            );
        } else {
            $params = array(
                ':NRSEQOPERACAO' => $this->getNewKDSOPERACAOTEMP(),
                ':DSOPERACAO'    => $operation
            );
        }

		$this->entityManager->getConnection()->executeQuery($this->INSERT_KDSOPERACAOTEMP, $params);
 	}

	public function expediteOrder($CDFILIAL, $CDSETOR, $itemsArray) {
		$operationParams = array(
			'CDFILIAL'   => $CDFILIAL,
			'CDSETOR'    => $CDSETOR,
			'itemsArray' => $itemsArray
		);
		$operation = array(
			'operation' => 'expediteOrder',
			'params'   => $operationParams
		);
		$operation = json_encode($operation);

		if($this->pos0000196913){
            $params = array(
                ':DSOPERACAO'    => $operation
            );
        } else {
            $params = array(
                ':NRSEQOPERACAO' => $this->getNewKDSOPERACAOTEMP(),
                ':DSOPERACAO'    => $operation
            );
        }

		$this->entityManager->getConnection()->executeQuery($this->INSERT_KDSOPERACAOTEMP, $params);
 	}

 	public function getDataFromOneClient($CDFILIAL, $CDSETOR, $IDTIPOSETOR) {
		$operationParams = array(
			'CDFILIAL'   => $CDFILIAL,
			'CDSETOR'    => $CDSETOR,
			'IDTIPOSETOR' => $IDTIPOSETOR
		);
		$operation = array(
			'operation' => 'getDataFromOneClient',
			'params'   => $operationParams
		);
		$operation = json_encode($operation);
		$params = array(
			':DSOPERACAO'    => $operation
		);
		$notExists = empty($this->entityManager->getConnection()->fetchAssoc(self::GET_KDSOPERACAOTEMP_BY_DSOPERACAO, $params));
		if($notExists){

            if (!$this->pos0000196913){
                $params[':NRSEQOPERACAO'] = $this->getNewKDSOPERACAOTEMP();
            }
			
			$this->entityManager->getConnection()->executeQuery($this->INSERT_KDSOPERACAOTEMP, $params);
		}
	 } 

 	private function getNewKDSOPERACAOTEMP() {
        $this->util->newCode('KDSOPERACAOTEMP');
		return $this->util->getNewCode('KDSOPERACAOTEMP', 10);
    }

	public function clearRequestsScreen($CDFILIAL, $CDSETOR, $NRHORA) {
		$operationParams = array(
			'CDFILIAL' => $CDFILIAL,
			'CDSETOR' => $CDSETOR,
			'NRHORA' => $NRHORA
		);
		$operation = array(
			'operation' => 'clearRequestsScreen',
			'params' => $operationParams
		);
		$operation = json_encode($operation);
		$params = array(
			':DSOPERACAO'    => $operation
		);

		$notExists = empty($this->entityManager->getConnection()->fetchAssoc(self::GET_KDSOPERACAOTEMP_BY_DSOPERACAO, $params));
		if($notExists){

			if (!$this->pos0000196913){
                $params[':NRSEQOPERACAO'] = $this->getNewKDSOPERACAOTEMP();
            }

			$this->entityManager->getConnection()->executeQuery($this->INSERT_KDSOPERACAOTEMP, $params);
		}
 	}

	 public function updateNotificationTime($CDFILIAL, $NRPEDIDOFOS) {
		$operationParams = array(
			'CDFILIAL'      => $CDFILIAL,
			'NRPEDIDOFOS'   => $NRPEDIDOFOS
		);
		$operation = array(
			'operation' => 'updateNotificationTime',
			'params'   => $operationParams
		);
		$operation = json_encode($operation);

		if($this->pos0000196913){
            $params = array(
                ':DSOPERACAO'    => $operation
            );
        } else {
            $params = array(
                ':NRSEQOPERACAO' => $this->getNewKDSOPERACAOTEMP(),
                ':DSOPERACAO'    => $operation
            );
        }

		$this->entityManager->getConnection()->executeQuery($this->INSERT_KDSOPERACAOTEMP, $params);
	} 

	public function getSenhapedMesa($nrpedidofos){
		$params = array(
			':NRPEDIDOFOS' => $nrpedidofos
		);

		return $this->entityManager->getConnection()->fetchAll(self::GET_CDSENHAPEDMESA_BY_NRPEDIDOFOS, $params)[0];
	}

	public function getPedidoToConclude($CDFILIAL, $CDSENHAPED, $CDSETOR, $NRMESA){
		$params = array(
			':CDFILIAL'   => $CDFILIAL,
			':CDSENHAPED' => $CDSENHAPED,
			':CDSETOR'	  => $CDSETOR,
			':NRMESA'	  => $NRMESA
		);

	   $result = $this->entityManager->getConnection()->fetchAll(self::GET_PEDIDOS_TO_CONCLUDE, $params);	
	   
	   
	   
		return $result;
	}

	const GET_CDSENHAPEDMESA_BY_NRPEDIDOFOS = "
		SELECT CDSENHAPED, NRMESA
			FROM PEDIDOFOS
		   WHERE NRPEDIDOFOS = :NRPEDIDOFOS
	";

	const GET_PEDIDOS_TO_CONCLUDE = "
		SELECT P.NRPEDIDOFOS, IT.NRITPEDIDOFOS
		  FROM PEDIDOFOS P, ITPEDIDOFOS IT
		 WHERE P.CDFILIAL 		= :CDFILIAL
		   AND P.CDFILIAL 		= IT.CDFILIAL
		   AND P.NRPEDIDOFOS 	= IT.NRPEDIDOFOS
		   AND ( CDSENHAPED 		= :CDSENHAPED  OR CDSENHAPED IS NULL)
		   AND ( NRMESA 		= :NRMESA OR NRMESA IS NULL)
		   AND IT.CDSETOR   	= :CDSETOR
	";

	const GET_KDSOPERACAOTEMP_BY_DSOPERACAO = "
		SELECT NRSEQOPERACAO, DSOPERACAO
		  FROM KDSOPERACAOTEMP
		 WHERE DSOPERACAO = :DSOPERACAO
	";
}