<?php

namespace Util;

class Query {

	public static function getConst($const){
        return constant('self::'.$const);
    }

	const GET_ITEM_FROM_KDS_TEMP_SETOREST = 'SELECT * FROM KDS_TEMP_SETOREST WHERE CDFILIAL = :CDFILIAL AND CDSETOR = :CDSETOR AND NRPEDIDOFOS = :NRPEDIDOFOS';

	const GET_KDS_SECTORS = "
		SELECT DISTINCT SF.CDFILIAL, SE.CDSETOR, NMSETOR + ' ' + ISNULL(LP.NMLINHAPROD,'') AS NMSETOR, SE.CDSETOR + '-' + NMSETOR + ' ' + ISNULL(LP.NMLINHAPROD,'') AS LABELSETOR, IDTIPOSETOR
		FROM SETOR SE
		JOIN CAIXA CX
		ON SE.CDSETOR = CX.CDSETOR
		JOIN SETORFILIAL SF
		ON SF.CDSETOR = SE.CDSETOR
		LEFT JOIN LINHAPRODSETOR LPS
			ON LPS.CDSETOR = SF.CDSETOR
		LEFT JOIN LINHAPROD LP
			ON LP.CDLINHAPROD = LPS.CDLINHAPROD
		WHERE IDHABCAIXAVENDA = 'CTL'
		AND (SF.IDATIVO = 'S'
		OR SF.IDATIVO IS NULL)
	";

	const GET_OPERADOR_BY_EMAIL = "
		SELECT NMOPERADOR, CDOPERADOR, CDSENHAOPERMD5, DSEMAILOPER
		  FROM OPERADOR
		  WHERE DSEMAILOPER = :DSEMAILOPER
	";

	const GET_TRIGGER_PEDIDOFOS = "
		SELECT NAME, object_name(parent_obj) TABLENAME
		  FROM SYS.SYSOBJECTS
		 WHERE XTYPE = 'TR'
		   AND NAME = 'TGR_PEDIDOFOS'
	";


	const GET_TRIGGER_ITPEDIDOFOS = "
		SELECT NAME, object_name(parent_obj) TABLENAME
		  FROM SYS.SYSOBJECTS
		 WHERE XTYPE = 'TR'
		   AND NAME = 'TGR_ITPEDIDOFOS'
	";

	const GET_TRIGGER_ITPEDIDOFOSREL = "
		SELECT NAME, object_name(parent_obj) TABLENAME
		  FROM SYS.SYSOBJECTS
		 WHERE XTYPE ='TR'
		   AND NAME = 'TGR_ITPEDIDOFOSREL'
	";

	const TGR_PEDIDOFOS = "
		CREATE TRIGGER TGR_PEDIDOFOS
		ON PEDIDOFOS
		FOR INSERT, UPDATE AS
		BEGIN
			UPDATE PEDIDOFOS
			   SET DTULTATU = GETDATE()
			  FROM INSERTED
			 WHERE (ISNULL(PEDIDOFOS.NRPEDIDOFOS,0) = ISNULL(INSERTED.NRPEDIDOFOS,0))
			   AND (ISNULL(PEDIDOFOS.CDFILIAL,0) = ISNULL(INSERTED.CDFILIAL,0));
		END;
	";

	const GET_TGR_MOVCAIXADLV = "
		SELECT NAME, object_name(parent_obj) TABLENAME
		  FROM SYS.SYSOBJECTS
		 WHERE XTYPE ='TR'
		   AND NAME = 'TGR_MOVCAIXADLV'
    ";
		
    const GET_TGR_MOVCAIXADLV062021 = "
        SELECT NAME, object_name(parent_obj) TABLENAME
		    FROM SYS.SYSOBJECTS
		WHERE XTYPE ='TR'
		  AND NAME = 'TGR_MOVCAIXADLV062021'
	";

    const GET_TGR_MOVCAIXA082021 = "
        SELECT NAME, object_name(parent_obj) TABLENAME
          FROM SYS.SYSOBJECTS
         WHERE XTYPE = 'TR'
           AND NAME = 'TGR_MOVCAIXA082021'
    ";

    const GET_TGR_MOVCAIXADLV082021 = "
        SELECT NAME, object_name(parent_obj) TABLENAME
          FROM SYS.SYSOBJECTS
         WHERE XTYPE ='TR'
           AND NAME = 'TGR_MOVCAIXADLV082021'
    ";

    const DROP_TGR_MOVCAIXA082021 = "
        DROP TRIGGER TGR_MOVCAIXA082021;
    ";

    const DROP_TGR_MOVCAIXADLV062021 = "
		DROP TRIGGER TGR_MOVCAIXADLV062021;
    ";

    const DROP_TGR_MOVCAIXADLV = "
        DROP TRIGGER TGR_MOVCAIXADLV;
    ";

    const DROP_TGR_MOVCAIXADLV082021 = "
        DROP TRIGGER TGR_MOVCAIXADLV082021;
    ";

    const DROP_TGR_MOVCAIXA = "
        DROP TRIGGER TGR_MOVCAIXA;
    ";

    const GET_FIELD_NRSEQOPERACAOPK = "
        SELECT NAME, c.name
          FROM SYS.SYSCOLUMNS c
         WHERE NAME = 'NRSEQOPERACAOPK'
    ";

    const GET_FIELD_IDIMPRPRODPICK = "
        SELECT NAME, c.name
          FROM SYS.SYSCOLUMNS c
         WHERE NAME = 'IDIMPRPRODPICK'
    ";

    const GET_FIELD_IDEXIBESTATIS = "
        SELECT NAME, c.name
          FROM SYS.SYSCOLUMNS c
         WHERE NAME = 'IDEXIBESTATIS'
    ";

    const CREATE_FIELD_IDIMPRPRODPICK = "
        ALTER TABLE SETORPRODUTO ADD IDIMPRPRODPICK VARCHAR (1) NOT NULL DEFAULT ('S');
    ";

    const CREATE_FIELD_IDEXIBESTATIS = "
        ALTER TABLE PARAVEND ADD IDEXIBESTATIS VARCHAR (1) NOT NULL DEFAULT ('S');
    ";

	const GET_TGR_MOVCAIXA = "
	    SELECT NAME, object_name(parent_obj) TABLENAME
		  FROM SYS.SYSOBJECTS
		 WHERE XTYPE ='TR'
		   AND NAME = 'TGR_MOVCAIXA'
	";
	
    const ALTERA_PK_KDSOPERACAOTEMP ="
        ALTER TABLE KDSOPERACAOTEMP ADD CONSTRAINT PK_KDSOPERACAOTEMP PRIMARY KEY (NRSEQOPERACAOPK);
    ";

    const DROP_PK_KDSOPERACAOTEMP = "
        ALTER TABLE KDSOPERACAOTEMP DROP CONSTRAINT PK_KDSOPERACAOTEMP;
    ";

    const ALTERA_NRSEQOPERACAO_KDSOPERACAOTEMP = "
	   ALTER TABLE KDSOPERACAOTEMP ALTER COLUMN NRSEQOPERACAO VARCHAR(10) NULL
	";

    const CRIA_CAMPO_PK_KDSOPERACAOTEMP = "
		ALTER TABLE KDSOPERACAOTEMP ADD NRSEQOPERACAOPK INT IDENTITY(1, 1);
	";

	const TGR_MOVCAIXADLV = "
		CREATE TRIGGER TGR_MOVCAIXADLV
		ON MOVCAIXADLV
		FOR INSERT, UPDATE AS
		BEGIN
			DECLARE @NRVENDAREST  VARCHAR(MAX);
			DECLARE @NRSEQOPERACAO VARCHAR(MAX);

			DECLARE C_CURSOR CURSOR FOR
				SELECT NRVENDAREST FROM INSERTED 
				WHERE NOT EXISTS ( 
					SELECT 1 FROM DELETED 
					WHERE 
						DELETED.CDFILIAL = INSERTED.CDFILIAL AND
						DELETED.NRVENDAREST = INSERTED.NRVENDAREST AND
						DELETED.NRSEQMOVDLV = INSERTED.NRSEQMOVDLV
				)
				UNION ALL 

				SELECT INSERTED.NRVENDAREST FROM DELETED, INSERTED 
					WHERE 
						DELETED.CDFILIAL = INSERTED.CDFILIAL AND
						DELETED.NRVENDAREST = INSERTED.NRVENDAREST AND
						DELETED.NRSEQMOVDLV = INSERTED.NRSEQMOVDLV

			OPEN C_CURSOR;
			FETCH NEXT FROM C_CURSOR INTO @NRVENDAREST;
			WHILE @@FETCH_STATUS = 0
			BEGIN
                EXECUTE NOVO_CODIGO 'KDSOPERACAOTEMP', @NRSEQOPERACAO OUTPUT , 1;
				IF @NRVENDAREST IS NOT NULL
				BEGIN
					INSERT INTO KDSOPERACAOTEMP (NRSEQOPERACAO, DSOPERACAO)
						VALUES (RIGHT(@NRSEQOPERACAO, 10),  '{\"operation\": \"refreshOrderItem\",\"params\": {\"NRVENDAREST\": \"'+@NRVENDAREST+'\"}}');
				END;
				FETCH NEXT FROM C_CURSOR INTO @NRVENDAREST;
			END;
			CLOSE C_CURSOR;
			DEALLOCATE C_CURSOR;			
		END
	";

	const TGR_MOVCAIXA = "
		CREATE TRIGGER TGR_MOVCAIXA
		ON MOVCAIXA
		FOR INSERT, UPDATE AS
		BEGIN
			DECLARE @NRSEQVENDA  VARCHAR(MAX);
			DECLARE @NRSEQOPERACAO VARCHAR(MAX);			

			DECLARE C_CURSOR CURSOR FOR
				SELECT NRSEQVENDA FROM INSERTED 
				WHERE NOT EXISTS ( 
					SELECT 1 FROM DELETED 
					WHERE 
						DELETED.CDFILIAL = INSERTED.CDFILIAL AND
						DELETED.CDCAIXA = INSERTED.CDCAIXA AND
						DELETED.DTABERCAIX = INSERTED.DTABERCAIX AND
						DELETED.NRSEQUMOVI = INSERTED.NRSEQUMOVI
				)
				UNION ALL 

				SELECT INSERTED.NRSEQVENDA FROM DELETED, INSERTED 
					WHERE 
						DELETED.CDFILIAL = INSERTED.CDFILIAL AND
						DELETED.CDCAIXA = INSERTED.CDCAIXA AND
						DELETED.DTABERCAIX = INSERTED.DTABERCAIX AND
						DELETED.NRSEQUMOVI = INSERTED.NRSEQUMOVI;

			OPEN C_CURSOR;
			FETCH NEXT FROM C_CURSOR INTO @NRSEQVENDA;
			WHILE @@FETCH_STATUS = 0
			BEGIN
				EXECUTE NOVO_CODIGO 'KDSOPERACAOTEMP', @NRSEQOPERACAO OUTPUT , 1;
				IF @NRSEQVENDA IS NOT NULL
				BEGIN
					INSERT INTO KDSOPERACAOTEMP (NRSEQOPERACAO, DSOPERACAO)
						VALUES (RIGHT(@NRSEQOPERACAO, 10),  '{\"operation\": \"refreshOrderItem\",\"params\": {\"NRVENDAREST\": \"'+@NRSEQVENDA+'\"}}');
				END;
				FETCH NEXT FROM C_CURSOR INTO @NRSEQVENDA;
			END;
			CLOSE C_CURSOR;
			DEALLOCATE C_CURSOR;			
		END
	";

	const TGR_ITPEDIDOFOS = "
        CREATE TRIGGER TGR_ITPEDIDOFOS
        ON ITPEDIDOFOS
        FOR INSERT, UPDATE AS
        BEGIN
            UPDATE ITPEDIDOFOS
               SET DTULTATU = GETDATE()
              FROM INSERTED LEFT JOIN DELETED ON DELETED.CDFILIAL = INSERTED.CDFILIAL
                                             AND DELETED.NRPEDIDOFOS = INSERTED.NRPEDIDOFOS
                                             AND DELETED.NRITPEDIDOFOS = INSERTED.NRITPEDIDOFOS
             WHERE (INSERTED.CDFILIAL IS NOT NULL      AND ITPEDIDOFOS.CDFILIAL = INSERTED.CDFILIAL          )
               AND (INSERTED.NRPEDIDOFOS IS NOT NULL   AND ITPEDIDOFOS.NRPEDIDOFOS = INSERTED.NRPEDIDOFOS    )
               AND (INSERTED.NRITPEDIDOFOS IS NOT NULL AND ITPEDIDOFOS.NRITPEDIDOFOS = INSERTED.NRITPEDIDOFOS)
        END;
	";

	const TGR_ITPEDIDOFOSREL = "
		CREATE TRIGGER TGR_ITPEDIDOFOSREL
        ON ITPEDIDOFOSREL
        FOR INSERT, UPDATE AS
        BEGIN
            UPDATE ITPEDIDOFOSREL
               SET DTULTATU = GETDATE()
              FROM INSERTED LEFT JOIN DELETED ON DELETED.CDFILIAL = INSERTED.CDFILIAL
                                             AND DELETED.NRPEDIDOFOS = INSERTED.NRPEDIDOFOS
                                             AND DELETED.NRITPEDIDOFOS = INSERTED.NRITPEDIDOFOS
                                             AND DELETED.NRSEQITPEDREL = INSERTED.NRSEQITPEDREL
             WHERE (INSERTED.CDFILIAL IS NOT NULL      AND ITPEDIDOFOSREL.CDFILIAL = INSERTED.CDFILIAL          )
               AND (INSERTED.NRPEDIDOFOS IS NOT NULL   AND ITPEDIDOFOSREL.NRPEDIDOFOS = INSERTED.NRPEDIDOFOS    )
               AND (INSERTED.NRITPEDIDOFOS IS NOT NULL AND ITPEDIDOFOSREL.NRITPEDIDOFOS = INSERTED.NRITPEDIDOFOS)
               AND (INSERTED.NRSEQITPEDREL IS NOT NULL AND ITPEDIDOFOSREL.NRSEQITPEDREL = INSERTED.NRSEQITPEDREL)
        END;
	";

	const GET_TRIGGER_KDSMENSAGEM_ON_DELETE = "
		SELECT NAME, object_name(parent_obj) TABLENAME
		  FROM SYS.SYSOBJECTS
		 WHERE XTYPE = 'TR'
		   AND NAME = 'KDSMENSAGEM_ON_DELETE'
	";

	const TRIGGER_KDSMENSAGEM_ON_DELETE = "
		CREATE TRIGGER KDSMENSAGEM_ON_DELETE
		ON KDSMENSAGEM
		FOR DELETE
		AS
		BEGIN
			DECLARE
		    @CDMENSAGEM  VARCHAR(MAX),
		    @NRSEQOPERACAO VARCHAR(MAX)

		    SELECT @NRSEQOPERACAO = RIGHT('0000000000'+CONVERT(VARCHAR(10), NRSEQUENCIAL+1), 10) FROM NOVOCODIGO WHERE CDCONTADOR = 'KDSOPERACAOTEMP';
			SELECT @CDMENSAGEM = CDMENSAGEM  FROM DELETED;
		    INSERT INTO KDSOPERACAOTEMP (NRSEQOPERACAO, DSOPERACAO)
				VALUES (@NRSEQOPERACAO,  '{\"operation\": \"deleteMessage\",\"params\": {\"CDMENSAGEM\": \"'+@CDMENSAGEM+'\"}}');
		    UPDATE NOVOCODIGO SET NRSEQUENCIAL = @NRSEQOPERACAO WHERE CDCONTADOR = 'KDSOPERACAOTEMP';
		END
	";

	//Consulta otimizada que só traz venda mesa
	const GET_SALES_COM = "
		SELECT
			VE.CDFILIAL + ISNULL(IT.NRSEQPRODCUP, IT.NRVENDAREST + IT.NRCOMANDA + IT.NRPRODCOMVEN) AS CHAVE,
			'COMANDA' AS VENDA,
			VE.CDFILIAL,
			CONVERT(VARCHAR, IT.DTHRINCOMVEN, 126) AS DATA,
			IT.IDIMPPRGRPROMO,
			IT.CDPRODUTO,
			IT.QTPRODCOMVEN AS QTDEPROD,
			'' AS NRSEQVENDA,
			'' AS CDCAIXA,
			VE.NRMESA AS NRMESA,
			CO.NRCOMANDA AS NRCOMANDAVND,
			CO.DSCOMANDA AS DSCOMANDAVND,
			'' AS NRSEQUITVEND,
			IT.NRVENDAREST,
			IT.NRCOMANDA,
			CO.DSCOMANDA,
			IT.NRPRODCOMVEN,
			LJ.CDLOJA,
			CONVERT(VARCHAR(2000), IT.DSOBSPEDDIGCMD) AS OBSDIGITADA,
			IT.CDSENHAPED,
			ISNULL(CO.DSCONSUMIDOR, CM.NMCONSUMIDOR) AS NMCONSUMIDOR,
			IT.CDGRPOCOR,
			IT.CDOCORR,
			'K' AS IDORIPED,
			NULL AS NRPEDIDOFOS,
			NULL AS NRITPEDIDOFOS,
			IT.NRSEQPRODCOM,
			GETDATE() AS NOW,
			IT.CDPRODPROMOCAO,
			IT.CDFILIAL + IT.NRVENDAREST + IT.NRCOMANDA + IT.NRPRODCOMVEN AS CHAVEITEM,
			IT.NRATRAPRODCOVE AS NRATRAPROD,
			IT.NRLUGARMESA,
			CO.IDORGCMDVENDA AS IDORIGEMVENDA,
			IT.IDORIGEMVENDA AS IDITORIGEMVENDA,
			CONVERT(DATE, IT.DTHRINCOMVEN) AS DTPEDIDO

		FROM COMANDAVEN CO , ITCOMANDAVEN IT , PRODUTO PR , LOJA LJ  ,
			VENDAREST VE  LEFT JOIN CONSUMIDOR CM
			ON VE.CDCLIENTE = CM.CDCLIENTE
			AND VE.CDCONSUMIDOR = CM.CDCONSUMIDOR

			WHERE CO.CDFILIAL    = :CDFILIAL
			AND CO.NRVENDAREST = :NRVENDAREST
			AND CO.NRCOMANDA = :NRCOMANDA

			-- JOIN VENDAREST - COMANDAVEN
			AND VE.CDFILIAL    = CO.CDFILIAL
			AND VE.NRVENDAREST = CO.NRVENDAREST

			-- JOIN COMANDAVEN - ITCOMANDAVEN
			AND CO.CDFILIAL    = IT.CDFILIAL
			AND CO.NRVENDAREST = IT.NRVENDAREST
			AND CO.NRCOMANDA   = IT.NRCOMANDA

			-- JOIN ITCOMANDAVEN - PRODUTO
			AND IT.CDPRODUTO   = PR.CDPRODUTO

			-- JOIN VENDAREST - LOJA
			AND VE.CDFILIAL    = LJ.CDFILIAL
			AND VE.CDLOJA      = LJ.CDLOJA

			AND IT.IDSTPRCOMVEN <> '6'
			AND IT.NRPEDIDOFOS IS NULL
			AND IT.DTHRINCOMVEN BETWEEN DATEADD(hh,-4,GETDATE()) AND DATEADD(hh,+1,GETDATE())
			AND ((IT.CDPRODUTO <> LJ.CDPRODCOUVER) OR (LJ.CDPRODCOUVER IS NULL))
			AND ((IT.CDPRODUTO <> LJ.CDPRODCONSUM) OR (LJ.CDPRODCONSUM IS NULL))
			AND ((IT.CDPRODUTO <> LJ.CDPRODCONSUF) OR (LJ.CDPRODCONSUF IS NULL))

			AND IT.IDIMPPRGRPROMO <> 'S'

			AND IT.DSCOMANDAORI IS NULL
			AND IT.NRCOMANDAORI IS NULL

		ORDER BY DATA, CHAVE, NRPRODCOMVEN
	";

	//Consulta otimizada que só traz venda balcão
	const GET_SALES_VEN = "
		SELECT VE.CDFILIAL + VE.CDCAIXA + VE.NRSEQVENDA AS CHAVE,
				'VENDA' AS VENDA,
				VE.CDFILIAL,
				CONVERT(VARCHAR,VE.DTINSERCAO, 126) AS DATA,
				IT.IDIMPPRGRPROMO,
				IT.CDPRODUTO,
				IT.QTPRODVEND AS QTDEPROD,
				VE.CDCAIXA,
				VE.NRSEQVENDA,
				VE.NRMESA,
				VE.NRCOMANDAVND,
				VE.DSCOMANDAVND,
				IT.NRSEQUITVEND, '' AS NRVENDAREST,
				'' AS NRCOMANDA,
				'' AS DSCOMANDA,
				'' AS NRPRODCOMVEN,
				LJ.CDLOJA,
				CONVERT(VARCHAR(2000), IT.DSOBSPEDDIGITA) AS OBSDIGITADA,
				VE.CDSENHAPED,
				ISNULL(VE.NMCONSVEND, CM.NMCONSUMIDOR) AS NMCONSUMIDOR,
				'' AS CDGRPOCOR,
				'' AS CDOCORR,
				'K' AS IDORIPED,
				NULL AS NRPEDIDOFOS,
				NULL AS NRITPEDIDOFOS,
				IT.NRSEQPRODCOMIT AS NRSEQPRODCOM, GETDATE() AS NOW,
				IT.CDPRODPROMOCAO,
				IT.CDFILIAL + IT.CDCAIXA + IT.NRSEQVENDA + IT.NRSEQUITVEND AS CHAVEITEM,
				IT.NRATRAPRODITVE AS NRATRAPROD,
				'' AS NRLUGARMESA,
				VE.IDORIGEMVENDA AS IDORIGEMVENDA,
				IT.IDORIGEMVENDA AS IDITORIGEMVENDA,
				IT.NRORDITCUPFIS,
				CONVERT(DATE, VE.DTINSERCAO) AS DTPEDIDO

		FROM ITEMVENDA IT JOIN VENDA VE
				ON IT.CDFILIAL   = VE.CDFILIAL
				AND IT.CDCAIXA    = VE.CDCAIXA
				AND IT.NRSEQVENDA = VE.NRSEQVENDA

				JOIN LOJA LJ
				ON IT.CDFILIAL = LJ.CDFILIAL
				AND IT.CDLOJA = LJ.CDLOJA

				JOIN PRODUTO PR
				ON IT.CDPRODUTO = PR.CDPRODUTO

			LEFT JOIN CONSUMIDOR CM
				ON VE.CDCLIENTE = CM.CDCLIENTE
				AND VE.CDCONSUMIDOR = CM.CDCONSUMIDOR
				
				WHERE VE.CDFILIAL = :CDFILIAL
				AND VE.CDCAIXA = :CDCAIXA
				AND VE.NRSEQVENDA = :NRSEQVENDA

				AND VE.IDSITUVENDA <> 'C'
				AND VE.NRCOMANDAVND IS NULL
				AND VE.DSCOMANDAVND IS NULL
				AND IT.NRPEDIDOFOS IS NULL
				AND VE.DTVENDA BETWEEN DATEADD(hh,-4,GETDATE()) AND DATEADD(hh,+1,GETDATE())
				AND ((IT.CDPRODUTO <> LJ.CDPRODCOUVER) OR (LJ.CDPRODCOUVER IS NULL))
				AND ((IT.CDPRODUTO <> LJ.CDPRODCONSUM) OR (LJ.CDPRODCONSUM IS NULL))
				AND ((IT.CDPRODUTO <> LJ.CDPRODCONSUF) OR (LJ.CDPRODCONSUF IS NULL))

				AND IT.IDIMPPRGRPROMO <> 'S'

		ORDER BY DATA, CHAVE, NRORDITCUPFIS, NRPRODCOMVEN
	";

	//Consulta antiga que trazia as vendas e comandas para virarem pedidofos e itpedidofos
	const GET_SALES = "
		SELECT A.CHAVE,
		       A.VENDA, CONVERT(VARCHAR,A.DATA, 126) AS DATA,
		       A.CDPRODUTO, A.QTDEPROD, A.CDFILIAL,
		       A.CDCAIXA, A.NRSEQVENDA, A.NRSEQUITVEND, A.NRMESA,
		       A.NRCOMANDAVND, A.DSCOMANDAVND,
		       A.NRVENDAREST, A.NRCOMANDA, A.DSCOMANDA, A.NRPRODCOMVEN,
		        A.CDLOJA, A.OBSDIGITADA, A.CDSENHAPED,
		       A.NMCONSUMIDOR, A.CDGRPOCOR, A.CDOCORR,
		       A.IDORIPED, A.NRPEDIDOFOS, A.NRITPEDIDOFOS,
		       A.NRSEQPRODCOM, GETDATE() AS NOW, A.CHAVEITEM, A.NRATRAPROD,
		       A.CDPRODPROMOCAO, A.NRLUGARMESA, A.IDORIGEMVENDA, A.IDITORIGEMVENDA
		  FROM (

		-- VENDAS BALCÃO
		SELECT VE.CDFILIAL + VE.CDCAIXA + VE.NRSEQVENDA AS CHAVE,
		       'VENDA' AS VENDA, VE.CDFILIAL,
		       VE.DTINSERCAO AS DATA, IT.CDPRODUTO, IT.QTPRODVEND AS QTDEPROD,
		       VE.CDCAIXA, VE.NRSEQVENDA, VE.NRMESA, VE.NRCOMANDAVND,
		       VE.DSCOMANDAVND, IT.NRSEQUITVEND, '' AS NRVENDAREST,
		       '' AS NRCOMANDA, '' AS DSCOMANDA, '' AS NRPRODCOMVEN,
		       LJ.CDLOJA, CONVERT(VARCHAR(2000),IT.DSOBSPEDDIGITA) AS OBSDIGITADA, VE.CDSENHAPED, ISNULL(VE.NMCONSVEND, CM.NMCONSUMIDOR) AS NMCONSUMIDOR,
		       '' AS CDGRPOCOR , '' AS CDOCORR,
		       'K' AS IDORIPED, NULL AS NRPEDIDOFOS, NULL AS NRITPEDIDOFOS,
		       IT.NRSEQPRODCOMIT AS NRSEQPRODCOM, IT.CDPRODPROMOCAO,
		       IT.CDFILIAL + IT.CDCAIXA + IT.NRSEQVENDA + IT.NRSEQUITVEND AS CHAVEITEM,
		       IT.NRATRAPRODITVE AS NRATRAPROD, '' AS NRLUGARMESA, VE.IDORIGEMVENDA AS IDORIGEMVENDA,
		       IT.IDORIGEMVENDA AS IDITORIGEMVENDA
		  FROM ITEMVENDA IT JOIN VENDA VE
		                      ON IT.CDFILIAL   = VE.CDFILIAL
		                     AND IT.CDCAIXA    = VE.CDCAIXA
		                     AND IT.NRSEQVENDA = VE.NRSEQVENDA

		                    JOIN LOJA LJ
		                      ON IT.CDFILIAL = LJ.CDFILIAL
		                     AND IT.CDLOJA = LJ.CDLOJA

		                    JOIN PRODUTO PR
		                      ON IT.CDPRODUTO = PR.CDPRODUTO

		               LEFT JOIN CONSUMIDOR CM
		                      ON VE.CDCLIENTE = CM.CDCLIENTE
		                     AND VE.CDCONSUMIDOR = CM.CDCONSUMIDOR

		 WHERE VE.CDFILIAL = :CDFILIAL
		   AND VE.IDSITUVENDA <> 'C'
		   AND VE.NRCOMANDAVND IS NULL
		   AND VE.DSCOMANDAVND IS NULL
		   AND IT.NRPEDIDOFOS IS NULL
		   AND VE.DTVENDA BETWEEN DATEADD(hh,-4,GETDATE()) AND DATEADD(hh,+1,GETDATE())
		   AND ((IT.CDPRODUTO <> LJ.CDPRODCOUVER) OR (LJ.CDPRODCOUVER IS NULL))
		   AND ((IT.CDPRODUTO <> LJ.CDPRODCONSUM) OR (LJ.CDPRODCONSUM IS NULL))
		   AND ((IT.CDPRODUTO <> LJ.CDPRODCONSUF) OR (LJ.CDPRODCONSUF IS NULL))

		UNION

		-- VENDAS COMANDA, MESA E DELIVERY
		SELECT VE.CDFILIAL + ISNULL(IT.NRSEQPRODCUP, IT.NRVENDAREST + IT.NRCOMANDA + IT.NRPRODCOMVEN) AS CHAVE,
		       'COMANDA' AS VENDA,VE.CDFILIAL,
		       IT.DTHRINCOMVEN AS DATA, IT.CDPRODUTO, IT.QTPRODCOMVEN AS QTDEPROD,
		       '' AS CDCAIXA, '' AS NRSEQVENDA, VE.NRMESA AS NRMESA, CO.NRCOMANDA AS NRCOMANDAVND,
		       CO.DSCOMANDA AS DSCOMANDAVND, '' AS NRSEQUITVEND, IT.NRVENDAREST,
		       IT.NRCOMANDA, CO.DSCOMANDA, IT.NRPRODCOMVEN,
		       LJ.CDLOJA, REPLACE(CONVERT(VARCHAR(2000), IT.DSOBSPEDDIGCMD), ';', '') AS OBSDIGITADA, IT.CDSENHAPED, ISNULL(CO.DSCONSUMIDOR, CM.NMCONSUMIDOR) AS NMCONSUMIDOR,
		       IT.CDGRPOCOR, IT.CDOCORR,
		       'K' AS IDORIPED,  NULL AS NRPEDIDOFOS, NULL AS NRITPEDIDOFOS,
		       IT.NRSEQPRODCOM, IT.CDPRODPROMOCAO,
		       IT.CDFILIAL + IT.NRVENDAREST + IT.NRCOMANDA + IT.NRPRODCOMVEN AS CHAVEITEM,
		       IT.NRATRAPRODCOVE AS NRATRAPROD, IT.NRLUGARMESA, CO.IDORGCMDVENDA AS IDORIGEMVENDA,
		       IT.IDORIGEMVENDA AS IDITORIGEMVENDA
		  FROM COMANDAVEN CO, ITCOMANDAVEN IT, PRODUTO PR, LOJA LJ,
		       VENDAREST VE LEFT JOIN CONSUMIDOR CM
		                           ON VE.CDCLIENTE = CM.CDCLIENTE
		                          AND VE.CDCONSUMIDOR = CM.CDCONSUMIDOR

		 WHERE VE.CDFILIAL    = :CDFILIAL

		   -- JOIN VENDAREST - COMANDAVEN
		   AND VE.CDFILIAL    = CO.CDFILIAL
		   AND VE.NRVENDAREST = CO.NRVENDAREST

		   -- JOIN COMANDAVEN - ITCOMANDAVEN
		   AND CO.CDFILIAL    = IT.CDFILIAL
		   AND CO.NRVENDAREST = IT.NRVENDAREST
		   AND CO.NRCOMANDA   = IT.NRCOMANDA

		   -- JOIN ITCOMANDAVEN - PRODUTO
		   AND IT.CDPRODUTO   = PR.CDPRODUTO

		   -- JOIN VENDAREST - LOJA
		   AND VE.CDFILIAL    = LJ.CDFILIAL
		   AND VE.CDLOJA      = LJ.CDLOJA

		   AND IT.IDSTPRCOMVEN <> '6'
		   AND IT.NRPEDIDOFOS IS NULL
		   AND IT.DTHRINCOMVEN BETWEEN DATEADD(hh,-4,GETDATE()) AND DATEADD(hh,+1,GETDATE())
		   AND ((IT.CDPRODUTO <> LJ.CDPRODCOUVER) OR (LJ.CDPRODCOUVER IS NULL))
		   AND ((IT.CDPRODUTO <> LJ.CDPRODCONSUM) OR (LJ.CDPRODCONSUM IS NULL))
		   AND ((IT.CDPRODUTO <> LJ.CDPRODCONSUF) OR (LJ.CDPRODCONSUF IS NULL))

		) A
		ORDER BY A.DATA, A.CHAVE, A.NRPRODCOMVEN
	";

	const DELETE_PEDIDO_KDS_TEMP_BY_ID = "
		DELETE FROM PEDIDO_KDS_TEMP WHERE COD_PEDIDO_KDS_TEMP = :COD_PEDIDO_KDS_TEMP
	";

	const GET_NMCONSUMIDOR_BY_NRPEDIDOFOS = "
				SELECT NMCONSUMIDOR FROM PEDIDOFOS WHERE NRPEDIDOFOS = :NRPEDIDOFOS
	";

	const UPDATE_STATUS_PEDIDO_KDS_TEMP_BY_ID = "
		UPDATE PEDIDO_KDS_TEMP SET STATUS = 'P' WHERE COD_PEDIDO_KDS_TEMP = :COD_PEDIDO_KDS_TEMP
	";

	const SELECT_PEDIDO_KDS_TEMP = "
		SELECT TOP 10 * FROM PEDIDO_KDS_TEMP
	";

	const INSERT_ORDER = "
		INSERT INTO PEDIDOFOS
			(CDFILIAL, NRPEDIDOFOS, DSPEDIDOFOS, DSCHAVEPEDFOS,
			 DTPEDIDOFOS, IDSTATUSPEDFOS, DSTIPOPEDFOS, NRMESA,
			 NRCOMANDA, DSCOMANDA, QTMAXPEDFOS, CDSETOR,
			 NRPEDIDOFOSAUX, CDLOJA, CDSENHAPED, NRPEDIDOFOSMSDE,
			 NMCONSUMIDOR, IDATIVO, DTULTATU)
		VALUES
			(:CDFILIAL, :NRPEDIDOFOS, :DSPEDIDOFOS, :DSCHAVEPEDFOS,
			 :DTPEDIDOFOS, :IDSTATUSPEDFOS, :DSTIPOPEDFOS, :NRMESA,
			 :NRCOMANDA, :DSCOMANDA, :QTMAXPEDFOS, :CDSETOR,
			 :NRPEDIDOFOSAUX, :CDLOJA, :CDSENHAPED, :NRPEDIDOFOSMSDE,
			 :NMCONSUMIDOR, :IDATIVO, GETDATE())
	";

	const INSERT_ORDER_ITEMS = "
		INSERT INTO ITPEDIDOFOS
			(CDFILIAL, NRPEDIDOFOS, NRITPEDIDOFOS, CDPRODUTO,
			 QTPRODPEFOS, CDCAIXA, NRSEQVENDA, NRSEQUITVEND,
			 NRVENDAREST, NRCOMANDA, NRPRODCOMVEN, TXPRODPED,
			 IDSITITPEDFOS, CDSETOR, DTHREXIBICAOPROD, DSCHAVEPEDPAI,
			 CDPRODUTOPAI, IDORIPED, CDPRODPROMOKDS, NRSEQPRODCOMKDS,
			 NRTEMPOPRODIT, NRTEMPOEXIBIT, NRATRAPRODITPE, NRLUGARMESAIT,
			 IDLIBERADO, NRMAIORTEMPO, DTULTATU, IDORIGEMVENDA)
		VALUES
			(:CDFILIAL, :NRPEDIDOFOS, :NRITPEDIDOFOS, :CDPRODUTO,
			 :QTPRODPEFOS, :CDCAIXA, :NRSEQVENDA, :NRSEQUITVEND,
		  	 :NRVENDAREST, :NRCOMANDA, :NRPRODCOMVEN, :TXPRODPED,
		  	 :IDSITITPEDFOS, :CDSETOR, :DTHREXIBICAOPROD, :DSCHAVEPEDPAI,
		  	 :CDPRODUTOPAI, 'K', :CDPRODPROMOKDS, :NRSEQPRODCOMKDS,
		  	 :NRTEMPOPRODIT, :NRTEMPOEXIBIT, :NRATRAPRODITPE, :NRLUGARMESAIT,
		  	 :IDLIBERADO, :NRMAIORTEMPO, GETDATE(), :IDORIGEMVENDA)
	";

	const INSERT_ORDER_COMPOSITION = "
		INSERT INTO ITPEDIDOFOS
			(CDFILIAL, NRPEDIDOFOS, NRITPEDIDOFOS, CDPRODUTO,
			 QTPRODPEFOS, CDCAIXA, NRSEQVENDA, NRSEQUITVEND,
			 NRVENDAREST, NRCOMANDA, NRPRODCOMVEN, TXPRODPED,
			 IDSITITPEDFOS, DSCHAVEPEDPAI, CDSETOR, NRLUGARMESAIT)
		VALUES
			(:CDFILIAL, :NRPEDIDOFOS, :NRITPEDIDOFOS, :CDPRODUTO,
			 :QTPRODPEFOS, :CDCAIXA, :NRSEQVENDA, :NRSEQUITVEND,
		  	 :NRVENDAREST, :NRCOMANDA, :NRPRODCOMVEN, :TXPRODPED,
		  	 :IDSITITPEDFOS, :DSCHAVEPEDPAI, :CDSETOR, :NRLUGARMESAIT)
	";

	const CHECK_ORDER_EXISTENCE = "
		SELECT DSCHAVEPEDFOS, NRPEDIDOFOS
		  FROM PEDIDOFOS
		 WHERE DSCHAVEPEDFOS = :DSCHAVEPEDFOS
		   AND CONVERT(DATE, DTPEDIDOFOS) = :DTPEDIDO
	";

	const GET_PRODUCTION_REQUESTS_BY_CDSETOR = "
	SELECT PF.NRMESA, PF.IDSTATUSPEDFOS, CONVERT(VARCHAR, PF.DTPEDIDOFOS, 126) AS DTPEDIDOFOS,
		       PF.CDSENHAPED, PF.IDATIVO, PF.DTULTATU,
			   PF.CDFILIAL, PF.CDLOJA, PF.NRPEDIDOFOS, PF.DSTIPOPEDFOS, IT.NRMAIORTEMPO,
			   PF.DSPEDIDOFOS, PF.NMCONSUMIDOR, 
               ISNULL(ISNULL(ISNULL(RL.DSAPELIDOKDS, RF.DSAPELIDOKDS), P.DSAPELIDOKDS), P.NMPRODUTO) AS NMPRODUTO,  ISNULL(P2.DSAPELIDOKDS, P2.NMPRODUTO) AS NMPROMOCAO,
			   ISNULL(SP.DSAPELIDORESUMO, P.NMPRODUTO) AS DSAPELIDORESUMO,
			   P.CDPRODUTO, IT.NRITPEDIDOFOS, IT.NRSEQPRODCOMKDS, CONVERT(FLOAT,IT.QTPRODPEFOS) AS QTPRODPEFOS,
		       IT.IDSITITPEDFOS, IT.CDSETOR, IT.DTHREXIBICAOPROD AS DTHREXIBICAOPROD, IT.DSCHAVEPEDPAI,
		       IT.TXPRODPED, SE.IDTIPOSETOR, GETDATE() AS NOW,
		       IT.DTHRINIPRODUCAO, IT.NRVENDAREST, ISNULL(MCD.NRSEQMOVDLV, MCX.NRSEQVENDA) AS NRSEQMOVDLV, VND.IDSITUVENDA, LJ.IDCONDPEDPAG, IT.NRPRODCOMVEN, IT.NRSEQUITVEND, PF.NRMESAOLD,
		       CONVERT(VARCHAR,GETDATE(), 126) AS LASTUPDATE,
		       CONVERT(VARCHAR, DATEADD(second, CAST(IT.NRMAIORTEMPO AS FLOAT), GETDATE()), 126) AS SOMAHORAMAIORTEMPO,
		       -- SUBTRACT MILISECONDS, NOT NECESSARY AND SCREWS COMPARISSON
		       CONVERT(VARCHAR, DATEADD(ms, -DATEPART(ms, IT.DTHREXIBICAOPROD), IT.DTHREXIBICAOPROD), 126) AS DTHREXIBICAOPRODISO,
		       -- SUBTRACT MILISECONDS, NOT NECESSARY AND SCREWS COMPARISON
		       CONVERT(VARCHAR, DATEADD(ms, -DATEPART(ms, PF.DTPEDIDOFOS), PF.DTPEDIDOFOS), 126) AS DTPEDIDOFOSISO,
		       IT.CDFILIAL + '-' + IT.NRPEDIDOFOS + IT.NRITPEDIDOFOS AS orderKey,
		       IT.NRSEQLIBERADO, IT.NRATRAPRODITPE, SP.IDRESUMOPRODKDS, IT.IDORIGEMVENDA,
			   'Posição ' + IT.NRLUGARMESAIT AS DSLUGARMESAIT, ISNULL(IT.NRLUGARMESAIT, 0) AS NRLUGARMESAIT,
			   ISNULL(CMV.IDRETBALLOJA, VND.IDRETBALLOJA) AS IDRETBALLOJA,

		       -- TEMPO DE PRODUÇÃO (PARA CÁLCULO)
		       IT.NRTEMPOPRODIT AS NRTEMPOPROD,
		       -- TEMPO DE EXIBIÇÃO (VISUAL, O QUE FAZ COUNTDOWN)
		       IT.NRTEMPOEXIBIT AS NRTEMPOEXIB,
		       -- TEMPO PARA CÁLCULO DAS CORES
		       ISNULL(IT.NRTEMPOPRODIT, 0) + ISNULL(IT.NRATRAPRODITPE, 0) AS TEMPOCORES,
		       -- TEMPO DE ATRASO DO ITEM
		       ISNULL(CONVERT(VARCHAR,NRATRAPRODITPE) + 'P', 0)  AS DELAYTIME,
									IT.IDLIBERADO, PF.DSCOMANDA, IT.CDCAIXA, IT.NRSEQVENDA, IT.DTHRPRIEXPED,
									-- DESATIVADO TEMPORARIAMENTE: 

									-- 
									-- IT.DTHREXIBICAOPROD AS DTACRPRIORTIME
									DATEADD(SECOND, ISNULL(SRT.NRTEMPOPRIORSEG,0), IT.DTHREXIBICAOPROD) AS DTACRPRIORTIME,
									SP.IDSOMRESUMO

		   FROM ITPEDIDOFOS IT JOIN PRODUTO P
                               ON P.CDPRODUTO = IT.CDPRODUTO

                        LEFT JOIN SETORPRODUTO SP
                               ON SP.CDPRODUTO = IT.CDPRODUTO
                              AND SP.CDSETOR   = IT.CDSETOR

                            JOIN SETOR SE
                              ON SE.CDSETOR = IT.CDSETOR
                            JOIN SETORFILIAL SF
                              ON IT.CDSETOR = SF.CDSETOR
                             AND IT.CDFILIAL = SF.CDFILIAL

                            JOIN PEDIDOFOS PF
                              ON IT.CDFILIAL = PF.CDFILIAL
                             AND IT.NRPEDIDOFOS = PF.NRPEDIDOFOS

                       LEFT JOIN COMANDAVEN CMV
                              ON CMV.NRCOMANDA = PF.NRCOMANDA
                             AND CMV.CDFILIAL = PF.CDFILIAL

                       LEFT JOIN MOVCAIXADLV MCD
                              ON MCD.NRVENDAREST  = CMV.NRVENDAREST
                             AND MCD.CDFILIAL = CMV.CDFILIAL
                             AND MCD.NRSEQMOVDLV = '0000000001'

                       LEFT JOIN VENDA VND
                              ON (PF.NRCOMANDA = VND.NRCOMANDAVND OR IT.NRSEQVENDA = VND.NRSEQVENDA)
                              AND VND.CDLOJA = PF.CDLOJA
                              AND VND.CDFILIAL = PF.CDFILIAL
                              AND PF.CDSENHAPED = VND.CDSENHAPED

                       LEFT JOIN MOVCAIXA MCX
                              ON MCX.NRSEQVENDA  = IT.NRSEQVENDA
                             AND MCX.CDFILIAL = IT.CDFILIAL
                             AND MCX.CDCAIXA = IT.CDCAIXA

                            JOIN LOJA LJ
                              ON LJ.CDLOJA = PF.CDLOJA
                             AND LJ.CDFILIAL = PF.CDFILIAL

                       LEFT JOIN ROTFABLOCAL RL
                              ON RL.CDFILIAL = PF.CDFILIAL
                             AND RL.CDSUBPRODLOC = IT.CDPRODUTO
                             AND RL.CDPRODUTO = IT.CDPRODUTOPAI

                       LEFT JOIN ROTFABRICA RF
                              ON RF.CDSUBPRODUTO = IT.CDPRODUTO
                             AND RF.CDPRODUTO = IT.CDPRODUTOPAI

                       LEFT JOIN SORTORDERSBYORG SRT
                              ON IT.CDFILIAL = SRT.CDFILIAL
                             AND IT.IDORIGEMVENDA = SRT.IDORIGEMVENDA

						-- JOIN PARA TRAZER O NOME DA PROMOÇÃO
						LEFT JOIN PRODUTO P2
							 ON IT.CDPRODPROMOKDS = P2.CDPRODUTO

			WHERE SE.CDSETOR = :CDSETOR
           AND SE.IDTIPOSETOR = 'P'
            -- F de FEITO, X de EXPEDIDO
		 	  AND IT.IDSITITPEDFOS NOT IN ('F', 'X')
		     --Testa se é pra enviar os pedidos de uma vez ou só quando chegar na hr de exibir
		     AND PF.IDATIVO <> 'F'
			 AND NOT EXISTS (SELECT 1
			                   FROM (SELECT JSON_VALUE(DSOPERACAO, '$.params.CDFILIAL') AS CDFILIAL,
									  	    JSON_VALUE(DSOPERACAO, '$.params.NRPEDIDOFOS') AS NRPEDIDOFOS,
										    JSON_VALUE(DSOPERACAO, '$.params.NRITPEDIDOFOS') AS NRITPEDIDOFOS,
											JSON_VALUE(DSOPERACAO, '$.params.CDSETOR') AS CDSETOR
									   FROM KDSOPERACAOTEMP
									  WHERE UPPER(DSOPERACAO) like '%CONCLUDEITEM%') ITCONCLUIDO
							  WHERE ITCONCLUIDO.CDFILIAL = IT.CDFILIAL
							    AND ITCONCLUIDO.NRPEDIDOFOS = IT.NRPEDIDOFOS
							    AND ITCONCLUIDO.NRITPEDIDOFOS = IT.NRITPEDIDOFOS
								AND ITCONCLUIDO.CDSETOR = IT.CDSETOR)
			 AND NOT EXISTS (SELECT 1
							   FROM (SELECT JSON_VALUE(DSOPERACAO, '$.params.CDFILIAL') AS CDFILIAL,
											JSON_VALUE(DSOPERACAO, '$.params.CDSETOR') AS CDSETOR,
											JSON_VALUE(DSOPERACAO, '$.params.itemsArray[0].NRPEDIDOFOS') AS NRPEDIDOFOS
									   FROM KDSOPERACAOTEMP
									  WHERE UPPER(DSOPERACAO) like '%EXPEDITEORDER%') PEDEXPEDIDO
							  WHERE PEDEXPEDIDO.CDFILIAL = IT.CDFILIAL
							    AND PEDEXPEDIDO.NRPEDIDOFOS = IT.NRPEDIDOFOS
								AND PEDEXPEDIDO.CDSETOR = IT.CDSETOR)
	    ORDER BY IT.DTHREXIBICAOPROD, IT.NRPEDIDOFOS, IT.NRITPEDIDOFOS
	";
    
	const GET_PRODUCTION_REQUESTS = "
		SELECT PF.NRMESA, PF.IDSTATUSPEDFOS, CONVERT(VARCHAR, PF.DTPEDIDOFOS, 126) AS DTPEDIDOFOS,
				 PF.CDSENHAPED, PF.IDATIVO, PF.DTULTATU,
			 PF.CDFILIAL, PF.CDLOJA, PF.NRPEDIDOFOS, PF.DSTIPOPEDFOS, IT.NRMAIORTEMPO,
			 PF.DSPEDIDOFOS, PF.NMCONSUMIDOR, 
             ISNULL(ISNULL(ISNULL(RL.DSAPELIDOKDS, RF.DSAPELIDOKDS), P.DSAPELIDOKDS), P.NMPRODUTO) AS NMPRODUTO, ISNULL(P2.DSAPELIDOKDS, P2.NMPRODUTO) AS NMPROMOCAO,
			 ISNULL(SP.DSAPELIDORESUMO, P.NMPRODUTO) AS DSAPELIDORESUMO,
			 P.CDPRODUTO, IT.NRITPEDIDOFOS, CONVERT(FLOAT,IT.QTPRODPEFOS) AS QTPRODPEFOS,
				 IT.IDSITITPEDFOS, IT.CDSETOR, IT.DTHREXIBICAOPROD AS DTHREXIBICAOPROD, IT.DSCHAVEPEDPAI,
				 IT.TXPRODPED, SE.IDTIPOSETOR, GETDATE() AS NOW,
				 IT.DTHRINIPRODUCAO, IT.NRVENDAREST, IT.NRSEQPRODCOMKDS, ISNULL(MCD.NRSEQMOVDLV, MCX.NRSEQVENDA) AS NRSEQMOVDLV, LJ.IDCONDPEDPAG, LJ.NMLOJA, VND.IDSITUVENDA, IT.NRPRODCOMVEN, PF.NRMESAOLD,
				 CONVERT(VARCHAR,GETDATE(), 126) AS LASTUPDATE,
				 CONVERT(VARCHAR, DATEADD(second, CAST(IT.NRMAIORTEMPO AS FLOAT), GETDATE()), 126) AS SOMAHORAMAIORTEMPO,
				 -- SUBTRACT MILISECONDS, NOT NECESSARY AND SCREWS COMPARISSON
				 CONVERT(VARCHAR, DATEADD(ms, -DATEPART(ms, IT.DTHREXIBICAOPROD), IT.DTHREXIBICAOPROD), 126) AS DTHREXIBICAOPRODISO,
				 -- SUBTRACT MILISECONDS, NOT NECESSARY AND SCREWS COMPARISON
				 CONVERT(VARCHAR, DATEADD(ms, -DATEPART(ms, PF.DTPEDIDOFOS), PF.DTPEDIDOFOS), 126) AS DTPEDIDOFOSISO,
				 IT.CDFILIAL + '-' + IT.NRPEDIDOFOS + IT.NRITPEDIDOFOS AS orderKey,
				 IT.NRSEQLIBERADO, IT.NRATRAPRODITPE, SP.IDRESUMOPRODKDS, IT.IDORIGEMVENDA,
				 'Posição ' + IT.NRLUGARMESAIT AS DSLUGARMESAIT, ISNULL(IT.NRLUGARMESAIT, 0) AS NRLUGARMESAIT,
				 ISNULL(CMV.IDRETBALLOJA, VND.IDRETBALLOJA) AS IDRETBALLOJA,
				 -- TEMPO DE PRODUÇÃO (PARA CÁLCULO)
				 IT.NRTEMPOPRODIT AS NRTEMPOPROD,
				 -- TEMPO DE EXIBIÇÃO (VISUAL, O QUE FAZ COUNTDOWN)
				 IT.NRTEMPOEXIBIT AS NRTEMPOEXIB,
				 -- TEMPO PARA CÁLCULO DAS CORES
				 ISNULL(IT.NRTEMPOPRODIT, 0) + ISNULL(IT.NRATRAPRODITPE, 0) AS TEMPOCORES,
				 -- TEMPO DE ATRASO DO ITEM
				 ISNULL(CONVERT(VARCHAR,NRATRAPRODITPE) + 'P', 0)  AS DELAYTIME,
					IT.IDLIBERADO, PF.DSCOMANDA, IT.CDCAIXA, IT.NRSEQVENDA, IT.DTHRPRIEXPED,
					
					-- IT.DTHREXIBICAOPROD AS DTACRPRIORTIME 
					-- DESATIVADO TEMPORARIAMENTE: 
					DATEADD(SECOND, (1 * ISNULL(SRT.NRTEMPOPRIORSEG,0)), IT.DTHREXIBICAOPROD) AS DTACRPRIORTIME,
					-- EXIBIR APENAS NO RESUMO DE PRODUCAO
					SP.IDSOMRESUMO    	   

		 FROM ITPEDIDOFOS IT JOIN PRODUTO P
									  ON P.CDPRODUTO = IT.CDPRODUTO

                      LEFT JOIN SETORPRODUTO SP
                             ON SP.CDPRODUTO = IT.CDPRODUTO
                            AND SP.CDSETOR   = IT.CDSETOR

                           JOIN SETOR SE
                             ON SE.CDSETOR = IT.CDSETOR

                           JOIN SETORFILIAL SF
                             ON IT.CDSETOR = SF.CDSETOR
                            AND IT.CDFILIAL = SF.CDFILIAL

                           JOIN PEDIDOFOS PF
                             ON IT.CDFILIAL = PF.CDFILIAL
                            AND IT.NRPEDIDOFOS = PF.NRPEDIDOFOS

                      LEFT JOIN VENDA VND
                             ON (PF.NRCOMANDA = VND.NRCOMANDAVND OR IT.NRSEQVENDA = VND.NRSEQVENDA)
                            AND VND.CDLOJA = PF.CDLOJA
                            AND VND.CDFILIAL = PF.CDFILIAL
                            AND VND.CDSENHAPED = PF.CDSENHAPED
                     LEFT JOIN MOVCAIXA MCX
                            ON MCX.NRSEQVENDA  = IT.NRSEQVENDA
                           AND MCX.CDFILIAL = IT.CDFILIAL
                           AND MCX.CDCAIXA = IT.CDCAIXA

                          JOIN UPDATE_PEDIDO_KDS_TEMP UP
                            ON IT.NRPEDIDOFOS = UP.NRPEDIDOFOS
                           AND IT.NRITPEDIDOFOS = UP.NRITPEDIDOFOS
                           AND UP.DTHREXIBIT <= GETDATE()
                           AND UP.STATUS = 'P'
                           AND (UP.TABELA = 'ITPEDIDOFOS' OR UP.TABELA = 'ITPEDIDOFOSREL')

                     LEFT JOIN COMANDAVEN CMV
                            ON CMV.NRCOMANDA = PF.NRCOMANDA
                           AND CMV.CDFILIAL = PF.CDFILIAL

				  			LEFT JOIN MOVCAIXADLV MCD
                            ON MCD.NRVENDAREST  = CMV.NRVENDAREST
                           AND MCD.CDFILIAL = CMV.CDFILIAL
                           AND MCD.NRSEQMOVDLV = '0000000001'

					           JOIN LOJA LJ
                            ON LJ.CDLOJA = PF.CDLOJA
                           AND LJ.CDFILIAL = PF.CDFILIAL

                     LEFT JOIN ROTFABLOCAL RL
                            ON RL.CDFILIAL = PF.CDFILIAL
                           AND RL.CDSUBPRODLOC = IT.CDPRODUTO
                           AND RL.CDPRODUTO = IT.CDPRODUTOPAI

                     LEFT JOIN ROTFABRICA RF
                            ON RF.CDSUBPRODUTO = IT.CDPRODUTO
                           AND RF.CDPRODUTO = IT.CDPRODUTOPAI

                     LEFT JOIN SORTORDERSBYORG SRT
                            ON IT.CDFILIAL = SRT.CDFILIAL
                           AND IT.IDORIGEMVENDA = SRT.IDORIGEMVENDA

					-- JOIN PARA TRAZER O NOME DA PROMOÇÃO
					 LEFT JOIN PRODUTO P2
							ON IT.CDPRODPROMOKDS = P2.CDPRODUTO

		WHERE
			-- F de FEITO, X de EXPEDIDO
		 IT.IDSITITPEDFOS NOT IN ('F', 'X')
			AND SE.IDTIPOSETOR = 'P'
			--Testa se é pra enviar os pedidos de uma vez ou só quando chegar na hr de exibir
			AND PF.IDATIVO <> 'F'
			AND NOT EXISTS (SELECT 1
			                   FROM (SELECT JSON_VALUE(DSOPERACAO, '$.params.CDFILIAL') AS CDFILIAL,
									  	    JSON_VALUE(DSOPERACAO, '$.params.NRPEDIDOFOS') AS NRPEDIDOFOS,
										    JSON_VALUE(DSOPERACAO, '$.params.NRITPEDIDOFOS') AS NRITPEDIDOFOS,
											JSON_VALUE(DSOPERACAO, '$.params.CDSETOR') AS CDSETOR
									   FROM KDSOPERACAOTEMP
									  WHERE UPPER(DSOPERACAO) like '%CONCLUDEITEM%') ITCONCLUIDO
							  WHERE ITCONCLUIDO.CDFILIAL = IT.CDFILIAL
							    AND ITCONCLUIDO.NRPEDIDOFOS = IT.NRPEDIDOFOS
							    AND ITCONCLUIDO.NRITPEDIDOFOS = IT.NRITPEDIDOFOS
								AND ITCONCLUIDO.CDSETOR = IT.CDSETOR)
			AND NOT EXISTS (SELECT 1
							   FROM (SELECT JSON_VALUE(DSOPERACAO, '$.params.CDFILIAL') AS CDFILIAL,
											JSON_VALUE(DSOPERACAO, '$.params.CDSETOR') AS CDSETOR,
											JSON_VALUE(DSOPERACAO, '$.params.itemsArray[0].NRPEDIDOFOS') AS NRPEDIDOFOS
									   FROM KDSOPERACAOTEMP
									  WHERE UPPER(DSOPERACAO) like '%EXPEDITEORDER%') PEDEXPEDIDO
							  WHERE PEDEXPEDIDO.CDFILIAL = IT.CDFILIAL
							    AND PEDEXPEDIDO.NRPEDIDOFOS = IT.NRPEDIDOFOS
								AND PEDEXPEDIDO.CDSETOR = IT.CDSETOR)
		ORDER BY IT.DTHREXIBICAOPROD, IT.NRPEDIDOFOS, IT.NRITPEDIDOFOS
	";

	const GET_EXPEDITION = "
		SELECT * FROM (
		    SELECT P.NMPRODUTO, P.CDPRODUTO, IT.NRPEDIDOFOS, IT.NRPRODCOMVEN, IT.NRITPEDIDOFOS,
	               CONVERT(VARCHAR,CONVERT(INT,IT.QTPRODPEFOS)) AS QTPRODPEFOS,
	               IT.IDSITITPEDFOS, IT.TXPRODPED, IT.DSCHAVEPEDPAI,
	               SE.CDSETOR, IT.DTULTATU, GETDATE() AS NOW,
	               IT.CDPRODPROMOKDS, P2.NMPRODUTO AS NMPROMOCAO, IT.NRSEQPRODCOMKDS,
	               --Pega o tempo de produção da tabela certa
	               ISNULL(IT.NRTEMPOPRODIT, 0) AS NRTEMPOPROD, IT.NRVENDAREST,
	               IT.CDFILIAL, SE.IDTIPOSETOR,
	               ISNULL(IT.NRTEMPOPRODIT, 0) AS TEMPOCORES,
	               'Posição ' + IT.NRLUGARMESAIT AS DSLUGARMESAIT, ISNULL(IT.NRLUGARMESAIT, 0) AS NRLUGARMESAIT,
	                 -- TEMPO DE ATRASO DO ITEM
	               ISNULL(CONVERT(VARCHAR, IT.NRATRAPRODITPE) + 'E', 0)  AS DELAYTIME, IT.DTHREXIBICAOPROD AS DTHREXIBICAOPROD ,
	               IT.IDLIBERADO, IT.CDFILIAL + '-' + IT.NRPEDIDOFOS + IT.NRITPEDIDOFOS AS orderKey,
	               -- SUBTRACT MILISECONDS, NOT NECESSARY AND SCREWS COMPARISON
	               CONVERT(VARCHAR, DATEADD(ms, -DATEPART(ms, IT.DTHREXIBICAOPROD), IT.DTHREXIBICAOPROD), 126) AS DTHREXIBICAOPRODISO,
	               NRSEQLIBERADO = CASE WHEN PAI.IDATRASO = 'S' THEN ISNULL(IT.NRSEQLIBERADO, '0000000000') ELSE '' END,
	               IT.NRATRAPRODITPE, PE.NRCOMANDA, IT.IDORIGEMVENDA, IT.CDCAIXA, IT.NRSEQVENDA, IT.NRSEQUITVEND, PAI.CDLOJA,
	               PAI.DSPEDIDOFOS, PAI.DSTIPOPEDFOS, PAI.NMCONSUMIDOR, PAI.NRMESA, PAI.DTPEDIDOFOS,
	               PAI.CDSENHAPED, PAI.NRMESAOLD, PAI.LASTUPDATE, PAI.DTPEDIDOFOSISO, PAI.DSCOMANDA,
				   VND.DTVENDA, IT.DTHRPRIEXPED, 
				   -- IT.DTHREXIBICAOPROD AS DTACRPRIORTIME 
				   -- DESATIVADO TEMPORARIAMENTE: 
				   DATEADD(SECOND, (1 * ISNULL(SRT.NRTEMPOPRIORSEG,0)), IT.DTHREXIBICAOPROD) AS DTACRPRIORTIME
	          FROM ITPEDIDOFOS IT JOIN PRODUTO P
	                                ON IT.CDPRODUTO = P.CDPRODUTO

	                              JOIN PEDIDOFOS PE
	                                ON IT.CDFILIAL = PE.CDFILIAL
	                               AND IT.NRPEDIDOFOS = PE.NRPEDIDOFOS

	                              LEFT JOIN VENDA VND 
                                    ON (PE.NRCOMANDA = VND.NRCOMANDAVND OR IT.NRSEQVENDA = VND.NRSEQVENDA)
	                              	AND VND.CDLOJA = PE.CDLOJA
	                              	AND VND.CDFILIAL = PE.CDFILIAL
	                              	AND VNC.CDSENHAPED = PE.CDSENHAPED

	                         LEFT JOIN SETORPRODUTO SP
	                                ON IT.CDSETOR = SP.CDSETOR
	                               AND IT.CDPRODUTO = SP.CDPRODUTO

	                              JOIN SETOR SE
																																	ON IT.CDSETOR = SE.CDSETOR
																																	
																										LEFT JOIN SORTORDERSBYORG SRT
																																	ON IT.CDFILIAL = SRT.CDFILIAL
																																	AND IT.IDORIGEMVENDA = SRT.IDORIGEMVENDA

	                         -- JOIN PARA TRAZER O NOME DA PROMOÇÃO
	                         LEFT JOIN PRODUTO P2
	                                ON IT.CDPRODPROMOKDS = P2.CDPRODUTO

	                              JOIN( SELECT DISTINCT -- BUSCA OS ITENS SEM ATRASO
	                                       PF.CDFILIAL, PF.CDSETOR, PF.CDLOJA, PF.NRPEDIDOFOS,
	                                       PF.DSPEDIDOFOS, PF.DSTIPOPEDFOS, PF.NMCONSUMIDOR, PF.NRMESA,
	                                       PF.IDSTATUSPEDFOS, CONVERT(VARCHAR, PF.DTPEDIDOFOS, 126) AS DTPEDIDOFOS, PF.CDSENHAPED,
	                                       PF.IDATIVO, PF.NRPEDIDOFOS AS label, PF.DTULTATU, GETDATE() AS NOW,
	                                       PF.NRMESAOLD, CONVERT(VARCHAR,GETDATE(), 126) AS LASTUPDATE, IDORIGEMVENDA,
	                                       -- SUBTRACT MILISECONDS, NOT NECESSARY AND SCREWS COMPARISON
	                                       CONVERT(VARCHAR, DATEADD(ms, -DATEPART(ms, PF.DTPEDIDOFOS), PF.DTPEDIDOFOS), 126) AS DTPEDIDOFOSISO,
	                                       PF.DSCOMANDA,SE.IDTIPOSETOR,
	                                       NRSEQLIBERADO = CASE WHEN IT.NRATRAPRODITPE IS NOT NULL OR IT.NRSEQLIBERADO IS NOT NULL THEN ISNULL(IT.NRSEQLIBERADO, '0000000000') ELSE '' END,
	                                       IDATRASO =  CASE WHEN IT.NRATRAPRODITPE IS NULL AND IT.NRSEQLIBERADO IS NULL AND DTHREXIBICAOPROD <= GETDATE() THEN 'N' ELSE 'S' END

	                                  FROM PEDIDOFOS PF JOIN ITPEDIDOFOS IT
	                                                      ON PF.CDFILIAL = IT.CDFILIAL
	                                                     AND PF.NRPEDIDOFOS = IT.NRPEDIDOFOS

	                                                    JOIN SETOR SE
	                                                      ON IT.CDSETOR = SE.CDSETOR

	                                                    JOIN UPDATE_PEDIDO_KDS_TEMP UP
	                                                      ON (IT.NRPEDIDOFOS = UP.NRPEDIDOFOS
	                                                     AND IT.NRITPEDIDOFOS = UP.NRITPEDIDOFOS
	                                                     AND UP.STATUS = 'P'
	                                                     AND UP.DTHREXIBIT <= GETDATE()
	                                                     AND (UP.TABELA = 'ITPEDIDOFOS' OR UP.TABELA = 'ITPEDIDOFOSREL'))

	                                 WHERE
	                                       PF.IDATIVO <> 'X'
	                                   AND IT.IDSITITPEDFOS <> 'X'
	                                   AND SE.IDTIPOSETOR IN ('E', 'M')) AS PAI
	                                                                           ON IT.CDFILIAL    = PAI.CDFILIAL
	                                                                          AND IT.NRPEDIDOFOS = PAI.NRPEDIDOFOS
	                                                                          AND (((IT.NRATRAPRODITPE IS NOT NULL OR IT.NRSEQLIBERADO IS NOT NULL) AND PAI.IDATRASO = 'S' ) OR (IT.NRATRAPRODITPE IS NULL AND PAI.IDATRASO = 'N'))
	                                                                          AND SE.IDTIPOSETOR = PAI.IDTIPOSETOR

	         WHERE IT.IDSITITPEDFOS <> 'X'
           ) AS PEDIDOS
		ORDER BY PEDIDOS.NRPEDIDOFOS, PEDIDOS.NRSEQLIBERADO, PEDIDOS.NRITPEDIDOFOS, PEDIDOS.DTHREXIBICAOPROD
	";



	const GET_EXPEDITION_BY_CDSETOR = "
	SELECT DISTINCT * FROM (
		SELECT ISNULL(P.DSAPELIDOKDS ,P.NMPRODUTO) AS NMPRODUTO , P.CDPRODUTO, IT.NRPEDIDOFOS, IT.NRPRODCOMVEN, IT.NRITPEDIDOFOS,
				   CONVERT(VARCHAR,CONVERT(INT,IT.QTPRODPEFOS)) AS QTPRODPEFOS,
				   IT.IDSITITPEDFOS, IT.TXPRODPED, IT.DSCHAVEPEDPAI,
				   SE.CDSETOR, IT.DTULTATU, GETDATE() AS NOW, IT.NRSEQUITVEND,
				   IT.CDPRODPROMOKDS, ISNULL(P2.DSAPELIDOKDS, P2.NMPRODUTO) AS NMPROMOCAO, IT.NRSEQPRODCOMKDS,
				   --Pega o tempo de produção da tabela certa
				   ISNULL(IT.NRTEMPOPRODIT, 0) AS NRTEMPOPROD, IT.NRVENDAREST,
				   IT.CDFILIAL, SE.IDTIPOSETOR,
				   ISNULL(IT.NRTEMPOPRODIT, 0) AS TEMPOCORES,
				   'Posição ' + IT.NRLUGARMESAIT AS DSLUGARMESAIT, ISNULL(IT.NRLUGARMESAIT, 0) AS NRLUGARMESAIT,
					 -- TEMPO DE ATRASO DO ITEM
				   ISNULL(CONVERT(VARCHAR, IT.NRATRAPRODITPE) + 'E', 0)  AS DELAYTIME, IT.DTHREXIBICAOPROD AS DTHREXIBICAOPROD,
				   IT.IDLIBERADO, IT.CDFILIAL + '-' + IT.NRPEDIDOFOS + IT.NRITPEDIDOFOS AS orderKey,
				   -- SUBTRACT MILISECONDS, NOT NECESSARY AND SCREWS COMPARISON
				   CONVERT(VARCHAR, DATEADD(ms, -DATEPART(ms, IT.DTHREXIBICAOPROD), IT.DTHREXIBICAOPROD), 126) AS DTHREXIBICAOPRODISO,
				   NRSEQLIBERADO = CASE WHEN PAI.IDATRASO = 'S' THEN ISNULL(IT.NRSEQLIBERADO, '0000000000') ELSE '' END,
				   IT.NRATRAPRODITPE, PE.NRCOMANDA, IT.IDORIGEMVENDA, IT.CDCAIXA, IT.NRSEQVENDA, PAI.CDLOJA,
				   PAI.DSPEDIDOFOS, PAI.DSTIPOPEDFOS, PAI.NMCONSUMIDOR, PAI.NRMESA, PAI.DTPEDIDOFOS,
				   PAI.CDSENHAPED, PAI.NRMESAOLD, PAI.LASTUPDATE, PAI.DTPEDIDOFOSISO, PAI.DSCOMANDA,
				   VND.DTVENDA, IT.DTHRPRIEXPED, ISNULL(MCD.NRSEQMOVDLV, MCX.NRSEQVENDA) AS NRSEQMOVDLV, VND.IDSITUVENDA, LJ.IDCONDPEDPAG, 
				   -- IT.DTHREXIBICAOPROD AS DTACRPRIORTIME 
				   -- DESATIVADO TEMPORARIAMENTE: 
				   DATEADD(SECOND, (1 * ISNULL(SRT.NRTEMPOPRIORSEG,0)), IT.DTHREXIBICAOPROD) AS DTACRPRIORTIME,
				   ISNULL(PRPAI.IDIMPPRODUTO, DADOSPAI.IDIMPPRODUTO) AS IDPAIIMPRIME,
				   ISNULL(PRPAI.IDTIPOCOMPPROD, DADOSPAI.IDTIPOCOMPPROD) AS IDPAICOMBO,
				   -- CASE PRPAI.QTPRODVEND WHEN NULL THEN '1' ELSE PRPAI.QTPRODVEND END AS QTPRODPAI,
				   ISNULL(PRPAI.QTPRODVEND,ISNULL(PRPAICMD.QTPRODCOMVEN ,'1')) AS QTPRODPAI, ISNULL(CMV.IDRETBALLOJA, VND.IDRETBALLOJA) AS IDRETBALLOJA,
				   ISNULL(PRPAI.DSOBSPEDDIGITA, PRPAICMD.DSOBSPEDDIGCMD) AS OBSPAIDIGITADA, ISNULL(PRPAI.DSOBSITEMVENDA, PRPAICMD.TXPRODCOMVEN) AS OBSPAI, LJ.NMLOJA, SP.IDPRODPRIORIDADE
			FROM ITPEDIDOFOS IT LEFT JOIN (SELECT I.CDFILIAL, I.CDCAIXA, I.NRSEQUITVEND, I.NRSEQVENDA, I.DSOBSPEDDIGITA, I.DSOBSITEMVENDA, PR.CDPRODUTO, I.QTPRODVEND, PR.IDIMPPRODUTO, PR.IDTIPOCOMPPROD
											FROM ITEMVENDA I, PRODUTO PR
											WHERE I.CDPRODUTO = PR.CDPRODUTO) PRPAI
										ON PRPAI.CDFILIAL = IT.CDFILIAL
										AND PRPAI.CDCAIXA = IT.CDCAIXA
										AND PRPAI.NRSEQVENDA = IT.NRSEQVENDA
										AND PRPAI.CDPRODUTO = IT.CDPRODPROMOKDS
										AND PRPAI.NRSEQUITVEND = IT.NRSEQUITVEND
										LEFT JOIN (
											SELECT ITC.CDFILIAL, ITC.CDCAIXACOLETOR, ITC.NRPRODCOMVEN, ITC.NRVENDAREST, ITC.DSOBSPEDDIGCMD, ITC.TXPRODCOMVEN, PR.CDPRODUTO, ITC.QTPRODCOMVEN, PR.IDIMPPRODUTO, PR.IDTIPOCOMPPROD
											FROM ITCOMANDAVEN ITC, PRODUTO PR
											WHERE ITC.CDPRODUTO = PR.CDPRODUTO) PRPAICMD
											ON PRPAICMD.CDFILIAL = IT.CDFILIAL
											AND PRPAICMD.NRVENDAREST = IT.NRVENDAREST
											AND PRPAICMD.NRPRODCOMVEN = IT.NRPRODCOMVEN
											AND PRPAICMD.CDPRODUTO = IT.CDPRODPROMOKDS
								  	JOIN PRODUTO P
									ON IT.CDPRODUTO = P.CDPRODUTO

									LEFT JOIN (SELECT PR.CDPRODUTO, PR.IDIMPPRODUTO, PR.IDTIPOCOMPPROD
										FROM PRODUTO PR) DADOSPAI
										ON  IT.CDPRODPROMOKDS = DADOSPAI.CDPRODUTO

								  JOIN PEDIDOFOS PE
									ON IT.CDFILIAL = PE.CDFILIAL
									AND IT.NRPEDIDOFOS = PE.NRPEDIDOFOS
									
									LEFT JOIN COMANDAVEN CMV
									ON CMV.NRCOMANDA = PE.NRCOMANDA
									AND CMV.CDFILIAL = PE.CDFILIAL
									
									LEFT JOIN MOVCAIXADLV MCD
									ON MCD.NRVENDAREST  = CMV.NRVENDAREST
									AND MCD.CDFILIAL = CMV.CDFILIAL
									AND MCD.NRSEQMOVDLV = '0000000001'

								   LEFT JOIN VENDA VND 
									ON (PE.NRCOMANDA = VND.NRCOMANDAVND OR IT.NRSEQVENDA = VND.NRSEQVENDA)
									  AND VND.CDLOJA = PE.CDLOJA
									  AND VND.CDFILIAL = PE.CDFILIAL
									  AND VND.IDSITUVENDA <> 'C'
									  AND VND.CDSENHAPED = PE.CDSENHAPED
									  AND ((VND.CDCAIXA = IT.CDCAIXA) OR (IT.CDCAIXA = '') OR (IT.CDCAIXA IS NULL))

									  LEFT JOIN (SELECT DISTINCT NRSEQVENDA, CDFILIAL FROM MOVCAIXA) MCX 
									  ON MCX.NRSEQVENDA  = IT.NRSEQVENDA
									  AND MCX.CDFILIAL = IT.CDFILIAL

									  JOIN LOJA LJ ON (LJ.CDLOJA = PE.CDLOJA) --LJ.IDCONDPEDPAG,

							 LEFT JOIN SETORPRODUTO SP
									ON IT.CDSETOR = SP.CDSETOR
								   AND IT.CDPRODUTO = SP.CDPRODUTO

								  JOIN SETOR SE
									ON IT.CDSETOR = SE.CDSETOR
									
							 LEFT JOIN SORTORDERSBYORG SRT
									 ON IT.CDFILIAL = SRT.CDFILIAL
								   AND IT.IDORIGEMVENDA = SRT.IDORIGEMVENDA

							 -- JOIN PARA TRAZER O NOME DA PROMOÇÃO
							 LEFT JOIN PRODUTO P2
									ON IT.CDPRODPROMOKDS = P2.CDPRODUTO

							 LEFT JOIN LINHAPRODSETOR LPS 
							 ON IT.CDSETOR = LPS.CDSETOR

								  JOIN( SELECT DISTINCT -- BUSCA OS ITENS SEM ATRASO
										   PF.CDFILIAL, PF.CDSETOR, PF.CDLOJA, PF.NRPEDIDOFOS,
										   PF.DSPEDIDOFOS, PF.DSTIPOPEDFOS, PF.NMCONSUMIDOR, PF.NRMESA,
										   PF.IDSTATUSPEDFOS, CONVERT(VARCHAR, PF.DTPEDIDOFOS, 126) AS DTPEDIDOFOS, PF.CDSENHAPED,
										   PF.IDATIVO, PF.NRPEDIDOFOS AS label, PF.DTULTATU, GETDATE() AS NOW,
										   PF.NRMESAOLD, CONVERT(VARCHAR,GETDATE(), 126) AS LASTUPDATE, IDORIGEMVENDA,
										   -- SUBTRACT MILISECONDS, NOT NECESSARY AND SCREWS COMPARISON
										   CONVERT(VARCHAR, DATEADD(ms, -DATEPART(ms, PF.DTPEDIDOFOS), PF.DTPEDIDOFOS), 126) AS DTPEDIDOFOSISO,
										   PF.DSCOMANDA,SE.IDTIPOSETOR, LJ.IDCONDPEDPAG,
										   NRSEQLIBERADO = CASE WHEN IT.NRATRAPRODITPE IS NOT NULL OR IT.NRSEQLIBERADO IS NOT NULL THEN ISNULL(IT.NRSEQLIBERADO, '0000000000') ELSE '' END,
										   IDATRASO =  CASE WHEN IT.NRATRAPRODITPE IS NULL AND IT.NRSEQLIBERADO IS NULL AND DTHREXIBICAOPROD <= GETDATE() THEN 'N' ELSE 'S' END

									  FROM PEDIDOFOS PF JOIN ITPEDIDOFOS IT
														  ON PF.CDFILIAL = IT.CDFILIAL
														 AND PF.NRPEDIDOFOS = IT.NRPEDIDOFOS
														 
														 LEFT JOIN COMANDAVEN CMV
														 ON CMV.NRCOMANDA = PF.NRCOMANDA
														 AND CMV.CDFILIAL = PF.CDFILIAL
														 
														 LEFT JOIN MOVCAIXADLV MCD
														 ON MCD.NRVENDAREST  = CMV.NRVENDAREST
														 AND MCD.CDFILIAL = CMV.CDFILIAL
														 AND MCD.NRSEQMOVDLV = '0000000001'

														JOIN SETOR SE
														  ON IT.CDSETOR = SE.CDSETOR
														
														JOIN LOJA LJ ON (LJ.CDLOJA = PF.CDLOJA) --LJ.IDCONDPEDPAG,


									 WHERE
										   PF.IDATIVO <> 'X'
									   AND IT.IDSITITPEDFOS <> 'X'
									   AND SE.IDTIPOSETOR IN ('E', 'M')) AS PAI
																			   ON IT.CDFILIAL    = PAI.CDFILIAL
																			  AND IT.NRPEDIDOFOS = PAI.NRPEDIDOFOS
																			  AND (((IT.NRATRAPRODITPE IS NOT NULL OR IT.NRSEQLIBERADO IS NOT NULL) AND PAI.IDATRASO = 'S' ) OR (IT.NRATRAPRODITPE IS NULL AND PAI.IDATRASO = 'N'))
																			  AND SE.IDTIPOSETOR = PAI.IDTIPOSETOR

			 WHERE IT.IDSITITPEDFOS <> 'X'
			   AND SE.CDSETOR = :CDSETOR

		) AS PEDIDOS
	ORDER BY PEDIDOS.NRPEDIDOFOS, PEDIDOS.NRSEQLIBERADO, PEDIDOS.NRITPEDIDOFOS, PEDIDOS.DTHREXIBICAOPROD
";

	const GET_EXPEDITION_UPDATED_BY_CDSETOR = "
	SELECT DISTINCT * FROM (
		SELECT ISNULL(P.DSAPELIDOKDS ,P.NMPRODUTO) AS NMPRODUTO , P.CDPRODUTO, IT.NRPEDIDOFOS, IT.NRPRODCOMVEN, IT.NRITPEDIDOFOS,
				CONVERT(VARCHAR,CONVERT(INT,IT.QTPRODPEFOS)) AS QTPRODPEFOS,
				IT.IDSITITPEDFOS, IT.TXPRODPED, IT.DSCHAVEPEDPAI,
				SE.CDSETOR, IT.DTULTATU, GETDATE() AS NOW, IT.NRSEQUITVEND,
				IT.CDPRODPROMOKDS, ISNULL(P2.DSAPELIDOKDS, P2.NMPRODUTO) AS NMPROMOCAO, IT.NRSEQPRODCOMKDS,
				--Pega o tempo de produção da tabela certa
				ISNULL(IT.NRTEMPOPRODIT, 0) AS NRTEMPOPROD, IT.NRVENDAREST,
				IT.CDFILIAL, SE.IDTIPOSETOR,
				ISNULL(IT.NRTEMPOPRODIT, 0) AS TEMPOCORES,
				'Posição ' + IT.NRLUGARMESAIT AS DSLUGARMESAIT, ISNULL(IT.NRLUGARMESAIT, 0) AS NRLUGARMESAIT,
					-- TEMPO DE ATRASO DO ITEM
				ISNULL(CONVERT(VARCHAR, IT.NRATRAPRODITPE) + 'E', 0)  AS DELAYTIME, IT.DTHREXIBICAOPROD AS DTHREXIBICAOPROD,
				IT.IDLIBERADO, IT.CDFILIAL + '-' + IT.NRPEDIDOFOS + IT.NRITPEDIDOFOS AS orderKey,
				-- SUBTRACT MILISECONDS, NOT NECESSARY AND SCREWS COMPARISON
				CONVERT(VARCHAR, DATEADD(ms, -DATEPART(ms, IT.DTHREXIBICAOPROD), IT.DTHREXIBICAOPROD), 126) AS DTHREXIBICAOPRODISO,
				NRSEQLIBERADO = CASE WHEN PAI.IDATRASO = 'S' THEN ISNULL(IT.NRSEQLIBERADO, '0000000000') ELSE '' END,
				IT.NRATRAPRODITPE, PE.NRCOMANDA, IT.IDORIGEMVENDA, IT.CDCAIXA, IT.NRSEQVENDA, PAI.CDLOJA,
				PAI.DSPEDIDOFOS, PAI.DSTIPOPEDFOS, PAI.NMCONSUMIDOR, PAI.NRMESA, PAI.DTPEDIDOFOS,
				PAI.CDSENHAPED, PAI.NRMESAOLD, PAI.LASTUPDATE, PAI.DTPEDIDOFOSISO, PAI.DSCOMANDA,
				VND.DTVENDA, IT.DTHRPRIEXPED, ISNULL(MCD.NRSEQMOVDLV, MCX.NRSEQVENDA) AS NRSEQMOVDLV, VND.IDSITUVENDA, LJ.IDCONDPEDPAG, LJ.NMLOJA,
				-- IT.DTHREXIBICAOPROD AS DTACRPRIORTIME 
				-- DESATIVADO TEMPORARIAMENTE: 
				DATEADD(SECOND, (1 * ISNULL(SRT.NRTEMPOPRIORSEG,0)), IT.DTHREXIBICAOPROD) AS DTACRPRIORTIME,
				ISNULL(PRPAI.IDIMPPRODUTO, DADOSPAI.IDIMPPRODUTO) AS IDPAIIMPRIME,
				ISNULL(PRPAI.IDTIPOCOMPPROD, DADOSPAI.IDTIPOCOMPPROD) AS IDPAICOMBO,
				-- CASE PRPAI.QTPRODVEND WHEN NULL THEN '1' ELSE PRPAI.QTPRODVEND END AS QTPRODPAI,
				ISNULL(PRPAI.QTPRODVEND,ISNULL(PRPAICMD.QTPRODCOMVEN ,'1')) AS QTPRODPAI, ISNULL(CMV.IDRETBALLOJA, VND.IDRETBALLOJA) AS IDRETBALLOJA,
				ISNULL(PRPAI.DSOBSPEDDIGITA, PRPAICMD.DSOBSPEDDIGCMD) AS OBSPAIDIGITADA, ISNULL(PRPAI.DSOBSITEMVENDA, PRPAICMD.TXPRODCOMVEN) AS OBSPAI,  SP.IDPRODPRIORIDADE
		   FROM ITPEDIDOFOS IT LEFT JOIN (SELECT I.CDFILIAL, I.CDCAIXA, I.NRSEQUITVEND, I.NRSEQVENDA, I.DSOBSPEDDIGITA, I.DSOBSITEMVENDA, PR.CDPRODUTO, I.QTPRODVEND, PR.IDIMPPRODUTO, PR.IDTIPOCOMPPROD
											FROM ITEMVENDA I, PRODUTO PR
										   WHERE I.CDPRODUTO = PR.CDPRODUTO) PRPAI
									  ON PRPAI.CDFILIAL = IT.CDFILIAL
									 AND PRPAI.CDCAIXA = IT.CDCAIXA
									 AND PRPAI.NRSEQVENDA = IT.NRSEQVENDA
									 AND PRPAI.CDPRODUTO = IT.CDPRODPROMOKDS
									 AND PRPAI.NRSEQUITVEND = IT.NRSEQUITVEND
									 LEFT JOIN (
										SELECT ITC.CDFILIAL, ITC.CDCAIXACOLETOR, ITC.NRPRODCOMVEN, ITC.NRVENDAREST, ITC.DSOBSPEDDIGCMD, ITC.TXPRODCOMVEN, PR.CDPRODUTO, ITC.QTPRODCOMVEN, PR.IDIMPPRODUTO, PR.IDTIPOCOMPPROD
										FROM ITCOMANDAVEN ITC, PRODUTO PR
										WHERE ITC.CDPRODUTO = PR.CDPRODUTO) PRPAICMD
										ON PRPAICMD.CDFILIAL = IT.CDFILIAL
										AND PRPAICMD.NRVENDAREST = IT.NRVENDAREST
										AND PRPAICMD.NRPRODCOMVEN = IT.NRPRODCOMVEN
										AND PRPAICMD.CDPRODUTO = IT.CDPRODPROMOKDS
								 JOIN PRODUTO P
									ON IT.CDPRODUTO = P.CDPRODUTO

									LEFT JOIN (SELECT PR.CDPRODUTO, PR.IDIMPPRODUTO, PR.IDTIPOCOMPPROD
										FROM PRODUTO PR) DADOSPAI
										ON  IT.CDPRODPROMOKDS = DADOSPAI.CDPRODUTO

								JOIN PEDIDOFOS PE
									ON IT.CDFILIAL = PE.CDFILIAL
									AND IT.NRPEDIDOFOS = PE.NRPEDIDOFOS
									
									LEFT JOIN COMANDAVEN CMV
									ON CMV.NRCOMANDA = PE.NRCOMANDA
									AND CMV.CDFILIAL = PE.CDFILIAL
									
									LEFT JOIN MOVCAIXADLV MCD
									ON MCD.NRVENDAREST  = CMV.NRVENDAREST
									AND MCD.CDFILIAL = CMV.CDFILIAL
									AND MCD.NRSEQMOVDLV = '0000000001'

								LEFT JOIN VENDA VND 
									ON (PE.NRCOMANDA = VND.NRCOMANDAVND OR IT.NRSEQVENDA = VND.NRSEQVENDA)
									AND VND.CDLOJA = PE.CDLOJA
									AND VND.CDFILIAL = PE.CDFILIAL
									AND VND.IDSITUVENDA <> 'C'
									AND VND.CDSENHAPED = PE.CDSENHAPED
									AND ((VND.CDCAIXA = IT.CDCAIXA) OR (IT.CDCAIXA = '') OR (IT.CDCAIXA IS NULL))

									LEFT JOIN (SELECT DISTINCT NRSEQVENDA, CDFILIAL FROM MOVCAIXA) MCX 
									ON MCX.NRSEQVENDA  = IT.NRSEQVENDA
									AND MCX.CDFILIAL = IT.CDFILIAL

									JOIN LOJA LJ ON (LJ.CDLOJA = PE.CDLOJA) --LJ.IDCONDPEDPAG,

							LEFT JOIN SETORPRODUTO SP
									ON IT.CDSETOR = SP.CDSETOR
								AND IT.CDPRODUTO = SP.CDPRODUTO

								JOIN SETOR SE
									ON IT.CDSETOR = SE.CDSETOR
									
							LEFT JOIN SORTORDERSBYORG SRT
									ON IT.CDFILIAL = SRT.CDFILIAL
								AND IT.IDORIGEMVENDA = SRT.IDORIGEMVENDA

							-- JOIN PARA TRAZER O NOME DA PROMOÇÃO
							LEFT JOIN PRODUTO P2
									ON IT.CDPRODPROMOKDS = P2.CDPRODUTO

								JOIN( SELECT DISTINCT -- BUSCA OS ITENS SEM ATRASO
										PF.CDFILIAL, PF.CDSETOR, PF.CDLOJA, PF.NRPEDIDOFOS,
										PF.DSPEDIDOFOS, PF.DSTIPOPEDFOS, PF.NMCONSUMIDOR, PF.NRMESA,
										PF.IDSTATUSPEDFOS, CONVERT(VARCHAR, PF.DTPEDIDOFOS, 126) AS DTPEDIDOFOS, PF.CDSENHAPED,
										PF.IDATIVO, PF.NRPEDIDOFOS AS label, PF.DTULTATU, GETDATE() AS NOW,
										PF.NRMESAOLD, CONVERT(VARCHAR,GETDATE(), 126) AS LASTUPDATE, IDORIGEMVENDA,
										-- SUBTRACT MILISECONDS, NOT NECESSARY AND SCREWS COMPARISON
										CONVERT(VARCHAR, DATEADD(ms, -DATEPART(ms, PF.DTPEDIDOFOS), PF.DTPEDIDOFOS), 126) AS DTPEDIDOFOSISO,
										PF.DSCOMANDA,SE.IDTIPOSETOR, LJ.IDCONDPEDPAG,
										NRSEQLIBERADO = CASE WHEN IT.NRATRAPRODITPE IS NOT NULL OR IT.NRSEQLIBERADO IS NOT NULL THEN ISNULL(IT.NRSEQLIBERADO, '0000000000') ELSE '' END,
										IDATRASO =  CASE WHEN IT.NRATRAPRODITPE IS NULL AND IT.NRSEQLIBERADO IS NULL AND DTHREXIBICAOPROD <= GETDATE() THEN 'N' ELSE 'S' END

									FROM PEDIDOFOS PF 
										JOIN ITPEDIDOFOS IT
										ON PF.CDFILIAL = IT.CDFILIAL
										AND PF.NRPEDIDOFOS = IT.NRPEDIDOFOS
										
										LEFT JOIN COMANDAVEN CMV
										ON CMV.NRCOMANDA = PF.NRCOMANDA
										AND CMV.CDFILIAL = PF.CDFILIAL
										
										LEFT JOIN MOVCAIXADLV MCD
										ON MCD.NRVENDAREST  = CMV.NRVENDAREST
										AND MCD.CDFILIAL = CMV.CDFILIAL
										AND MCD.NRSEQMOVDLV = '0000000001'

										JOIN UPDATE_PEDIDO_KDS_TEMP UP
										ON (IT.NRPEDIDOFOS = UP.NRPEDIDOFOS
										AND IT.NRITPEDIDOFOS = UP.NRITPEDIDOFOS
										AND UP.STATUS = 'P'
										AND UP.DTHREXIBIT <= GETDATE()
										AND (UP.TABELA = 'ITPEDIDOFOS' OR UP.TABELA = 'ITPEDIDOFOSREL'))

										JOIN SETOR SE
										ON IT.CDSETOR = SE.CDSETOR
										
										JOIN LOJA LJ ON (LJ.CDLOJA = PF.CDLOJA) --LJ.IDCONDPEDPAG,


									WHERE
										PF.IDATIVO <> 'X'
									AND IT.IDSITITPEDFOS <> 'X'
									AND SE.IDTIPOSETOR IN ('E', 'M')) AS PAI
																			ON IT.CDFILIAL    = PAI.CDFILIAL
																			AND IT.NRPEDIDOFOS = PAI.NRPEDIDOFOS
																			AND (((IT.NRATRAPRODITPE IS NOT NULL OR IT.NRSEQLIBERADO IS NOT NULL) AND PAI.IDATRASO = 'S' ) OR (IT.NRATRAPRODITPE IS NULL AND PAI.IDATRASO = 'N'))
																			AND SE.IDTIPOSETOR = PAI.IDTIPOSETOR

			WHERE IT.IDSITITPEDFOS <> 'X'
			AND SE.CDSETOR = :CDSETOR
		) AS PEDIDOS
	ORDER BY PEDIDOS.NRPEDIDOFOS, PEDIDOS.NRSEQLIBERADO, PEDIDOS.NRITPEDIDOFOS, PEDIDOS.DTHREXIBICAOPROD
	";

	const GET_EXPEDITION_UPDATED_BY_CDSETOR_old = "
		SELECT * FROM (
			SELECT P.NMPRODUTO, P.CDPRODUTO, IT.NRPEDIDOFOS, IT.NRPRODCOMVEN, IT.NRITPEDIDOFOS,
				CONVERT(VARCHAR,CONVERT(INT,IT.QTPRODPEFOS)) AS QTPRODPEFOS,
				IT.IDSITITPEDFOS, IT.TXPRODPED, IT.DSCHAVEPEDPAI,
				SE.CDSETOR, IT.DTULTATU, GETDATE() AS NOW, IT.NRSEQUITVEND,
				IT.CDPRODPROMOKDS, P2.NMPRODUTO AS NMPROMOCAO, IT.NRSEQPRODCOMKDS,
				--Pega o tempo de produção da tabela certa
				ISNULL(IT.NRTEMPOPRODIT, 0) AS NRTEMPOPROD, IT.NRVENDAREST,
				IT.CDFILIAL, SE.IDTIPOSETOR,
				ISNULL(IT.NRTEMPOPRODIT, 0) AS TEMPOCORES,
				'Posição ' + IT.NRLUGARMESAIT AS DSLUGARMESAIT, ISNULL(IT.NRLUGARMESAIT, 0) AS NRLUGARMESAIT,
					-- TEMPO DE ATRASO DO ITEM
				ISNULL(CONVERT(VARCHAR, IT.NRATRAPRODITPE) + 'E', 0)  AS DELAYTIME, IT.DTHREXIBICAOPROD AS DTHREXIBICAOPROD ,
				IT.IDLIBERADO, IT.CDFILIAL + '-' + IT.NRPEDIDOFOS + IT.NRITPEDIDOFOS AS orderKey,
				-- SUBTRACT MILISECONDS, NOT NECESSARY AND SCREWS COMPARISON
				CONVERT(VARCHAR, DATEADD(ms, -DATEPART(ms, IT.DTHREXIBICAOPROD), IT.DTHREXIBICAOPROD), 126) AS DTHREXIBICAOPRODISO,
				NRSEQLIBERADO = CASE WHEN PAI.IDATRASO = 'S' THEN ISNULL(IT.NRSEQLIBERADO, '0000000000') ELSE '' END,
				IT.NRATRAPRODITPE, PE.NRCOMANDA, IT.IDORIGEMVENDA, IT.CDCAIXA, IT.NRSEQVENDA, PAI.CDLOJA,
				PAI.DSPEDIDOFOS, PAI.DSTIPOPEDFOS, PAI.NMCONSUMIDOR, PAI.NRMESA, PAI.DTPEDIDOFOS,
				PAI.CDSENHAPED, PAI.NRMESAOLD, PAI.LASTUPDATE, PAI.DTPEDIDOFOSISO, PAI.DSCOMANDA,
				VND.DTVENDA, IT.DTHRPRIEXPED, ISNULL(MCD.NRSEQMOVDLV, MCX.NRSEQVENDA) AS NRSEQMOVDLV, LJ.IDCONDPEDPAG, VND.IDSITUVENDA, 
				-- IT.DTHREXIBICAOPROD AS DTACRPRIORTIME 
				-- DESATIVADO TEMPORARIAMENTE: 
				DATEADD(SECOND, (1 * ISNULL(SRT.NRTEMPOPRIORSEG,0)), IT.DTHREXIBICAOPROD) AS DTACRPRIORTIME
			FROM ITPEDIDOFOS IT JOIN PRODUTO P
									ON IT.CDPRODUTO = P.CDPRODUTO

								JOIN PEDIDOFOS PE
									ON IT.CDFILIAL = PE.CDFILIAL
								AND IT.NRPEDIDOFOS = PE.NRPEDIDOFOS

								LEFT JOIN VENDA VND 
                                    ON (PE.NRCOMANDA = VND.NRCOMANDAVND OR IT.NRSEQVENDA = VND.NRSEQVENDA)
									AND VND.CDLOJA = PE.CDLOJA
									AND VND.CDFILIAL = PE.CDFILIAL
									AND VND.IDSITUVENDA <> 'C'
									AND VND.CDSENHAPED = PE.CDSENHAPED
									AND VND.CDCAIXA = IT.CDCAIXA

									LEFT JOIN (SELECT DISTINCT NRSEQVENDA, CDFILIAL FROM MOVCAIXA) MCX 
									ON MCX.NRSEQVENDA  = IT.NRSEQVENDA
									AND MCX.CDFILIAL = IT.CDFILIAL	

								LEFT JOIN COMANDAVEN CMV
								ON CMV.NRCOMANDA = PE.NRCOMANDA
								AND CMV.CDFILIAL = PE.CDFILIAL
								
								LEFT JOIN MOVCAIXADLV MCD
								ON MCD.NRVENDAREST  = CMV.NRVENDAREST
								AND MCD.CDFILIAL = CMV.CDFILIAL
								AND MCD.NRSEQMOVDLV = '0000000001'

								LEFT JOIN LOJA LJ ON (LJ.CDLOJA = PE.CDLOJA) -- LJ.IDCONDPEDPAG

							LEFT JOIN SETORPRODUTO SP
									ON IT.CDSETOR = SP.CDSETOR
								AND IT.CDPRODUTO = SP.CDPRODUTO

								JOIN SETOR SE
									ON IT.CDSETOR = SE.CDSETOR

								LEFT JOIN SORTORDERSBYORG SRT
										ON IT.CDFILIAL = SRT.CDFILIAL
									AND IT.IDORIGEMVENDA = SRT.IDORIGEMVENDA

							-- JOIN PARA TRAZER O NOME DA PROMOÇÃO
							LEFT JOIN PRODUTO P2
									ON IT.CDPRODPROMOKDS = P2.CDPRODUTO

								JOIN(SELECT DISTINCT -- BUSCA OS ITENS SEM ATRASO
										PF.CDFILIAL, PF.CDSETOR, PF.CDLOJA, PF.NRPEDIDOFOS,
										PF.DSPEDIDOFOS, PF.DSTIPOPEDFOS, PF.NMCONSUMIDOR, PF.NRMESA,
										PF.IDSTATUSPEDFOS, CONVERT(VARCHAR, PF.DTPEDIDOFOS, 126) AS DTPEDIDOFOS, PF.CDSENHAPED,
										PF.IDATIVO, PF.NRPEDIDOFOS AS label, PF.DTULTATU, GETDATE() AS NOW,
										PF.NRMESAOLD, CONVERT(VARCHAR,GETDATE(), 126) AS LASTUPDATE, IDORIGEMVENDA,
										-- SUBTRACT MILISECONDS, NOT NECESSARY AND SCREWS COMPARISON
										CONVERT(VARCHAR, DATEADD(ms, -DATEPART(ms, PF.DTPEDIDOFOS), PF.DTPEDIDOFOS), 126) AS DTPEDIDOFOSISO,
										PF.DSCOMANDA,SE.IDTIPOSETOR,
										NRSEQLIBERADO = CASE WHEN IT.NRATRAPRODITPE IS NOT NULL OR IT.NRSEQLIBERADO IS NOT NULL THEN ISNULL(IT.NRSEQLIBERADO, '0000000000') ELSE '' END,
										IDATRASO =  CASE WHEN IT.NRATRAPRODITPE IS NULL AND IT.NRSEQLIBERADO IS NULL AND DTHREXIBICAOPROD <= GETDATE() THEN 'N' ELSE 'S' END

									FROM PEDIDOFOS PF JOIN ITPEDIDOFOS IT
														ON PF.CDFILIAL = IT.CDFILIAL
														AND PF.NRPEDIDOFOS = IT.NRPEDIDOFOS

														JOIN SETOR SE
														ON IT.CDSETOR = SE.CDSETOR

														JOIN UPDATE_PEDIDO_KDS_TEMP UP
														ON (IT.NRPEDIDOFOS = UP.NRPEDIDOFOS
														AND IT.NRITPEDIDOFOS = UP.NRITPEDIDOFOS
														AND UP.STATUS = 'P'
														AND UP.DTHREXIBIT <= GETDATE()
														AND (UP.TABELA = 'ITPEDIDOFOS' OR UP.TABELA = 'ITPEDIDOFOSREL'))

									WHERE
										PF.IDATIVO <> 'X'
									AND IT.IDSITITPEDFOS <> 'X'
									AND SE.IDTIPOSETOR IN ('E', 'M')) AS PAI
																			ON IT.CDFILIAL    = PAI.CDFILIAL
																			AND IT.NRPEDIDOFOS = PAI.NRPEDIDOFOS
																			AND (((IT.NRATRAPRODITPE IS NOT NULL OR IT.NRSEQLIBERADO IS NOT NULL) AND PAI.IDATRASO = 'S' ) OR (IT.NRATRAPRODITPE IS NULL AND PAI.IDATRASO = 'N'))
																			AND SE.IDTIPOSETOR = PAI.IDTIPOSETOR

			WHERE IT.IDSITITPEDFOS <> 'X'
			AND SE.CDSETOR = :CDSETOR
		) AS PEDIDOS
		ORDER BY PEDIDOS.NRPEDIDOFOS, PEDIDOS.NRSEQLIBERADO, PEDIDOS.NRITPEDIDOFOS, PEDIDOS.DTHREXIBICAOPROD
	";

	const GET_CONSUMER_PASSWORDS = "
		SELECT CDOPERADOR, CDSENHAOPERWEB
		  FROM OPERADOR
		 WHERE CDSENHAOPERWEB IS NOT NULL
		   AND CDSENHAOPERMD5 IS NULL
	";

	const SET_CONSUMER_PASSWORDS = "
		UPDATE OPERADOR
		   SET CDSENHAOPERMD5 = :CDSENHAOPERMD5
		 WHERE CDOPERADOR     = :CDOPERADOR
	";

	const GET_NEW_CODE = "
		SELECT CDCONTADOR, NRSEQUENCIAL
		FROM NOVOCODIGO
		 WHERE CDCONTADOR = :CDCONTADOR
	";

	const GET_CONTROL_REGISTER = "
		SELECT CDCAIXA
		  FROM CAIXA
		 WHERE CDSETOR  = :CDSETOR
		   AND IDHABCAIXAVENDA = 'CTL'
	";

	const GET_SECTOR_PARAMETERS = "
		SELECT SF.IDHABROLLBKDS, SF.IDHABSOMKDS, SF.IDHABTIMERPROD, SF.IDHABSOMPROD,
		       SF.IDHABCONTSOMPROD, SF.IDBLOQPRODKDS, ISNULL(SF.NRROLLBTIME, 0) AS NRROLLBTIME,
		       SF.IDCONTSOMKDS, SF.IDHABPREENVIO, SF.NRATRASOSOMPROD, SF.NRPRODATRAINISOM,
		       AR.CDARQUIVO, AR.ARQUIVO, AR.NMARQUIVO, SF.IDCONCDIRETO, SF.IDMOSTRAORIGEM,
		       SF.IDUTLINTPAINEL, SF.NRTEMPOATRASOEXP, CDARQUIVOBEEPEXP, ARX.ARQUIVO AS ARQUIVOEXP,
		       ARX.NMARQUIVO AS NMARQUIVOEXP, S.IDTIPOSETOR, SF.NRMULTIPULO, SF.IDLIBCONDPG, SF.IDHABAGRUPPROD,
		       SF.IDFRNONNTF, SF.IDCONCAUT, SF.IDHABCANCDLV, SF.IDHABCANCBAL, SF.IDHABCANCMES,
			   SF.IDHABCANCCMD, SF.IDHABCANCTHR, SF.IDHABCANCTGO, SF.IDAUMENTARESUMO, SF.IDHABSCANCODE,
			   SF.IDHABESTATISTICAS, SF.IDHABLIBDIRETOEXP, SF.IDHABESTGERAL, SF.IDHABEXPFLUID, SF.IDEXIBCONDLIB, SF.IDHABAGRUPPRODPOSMESA, LPS.CDLINHAPROD, LP.IDLINHAPRINCIPAL, SF.IDHABPRIORIDADE
		  FROM SETORFILIAL SF JOIN SETOR S
		                        ON SF.CDSETOR = S.CDSETOR
		                 LEFT JOIN ARQUIVOS AR
		  				   	    ON AR.CDARQUIVO = SF.CDARQUIVO
		                 LEFT JOIN ARQUIVOS ARX
									 ON ARX.CDARQUIVO = SF.CDARQUIVOBEEPEXP
						 LEFT JOIN LINHAPRODSETOR LPS 
						 		ON SF.CDSETOR = LPS.CDSETOR
						 LEFT JOIN LINHAPROD LP
								ON LPS.CDLINHAPROD = LP.CDLINHAPROD
		 WHERE SF.CDFILIAL = :CDFILIAL
		   AND SF.CDSETOR  = :CDSETOR
		   AND (SF.IDATIVO = 'S' 
		   OR SF.IDATIVO IS NULL)
	";

	const UPDATE_OLD_REQUESTS_COMANDA = "
		UPDATE ITCOMANDAVEN
		   SET NRPEDIDOFOS  =  :NRPEDIDOFOS
		 WHERE NRPEDIDOFOS IS NULL
	";

	const UPDATE_OLD_REQUESTS_VENDA = "
		UPDATE ITEMVENDA
		   SET NRPEDIDOFOS  =  :NRPEDIDOFOS
		 WHERE NRPEDIDOFOS IS NULL
	";

	const UPDATE_SALE_MESA = "
		UPDATE ITCOMANDAVEN
		   SET NRPEDIDOFOS  =  :NRPEDIDOFOS
		 WHERE CDFILIAL     =  :CDFILIAL
		   AND NRVENDAREST  =  :NRVENDAREST
		   AND NRCOMANDA    =  :NRCOMANDA
		   AND NRPRODCOMVEN =  :NRPRODCOMVEN
	";

	const UPDATE_SALE_VENDA = "
		UPDATE ITEMVENDA
		   SET NRPEDIDOFOS  =  :NRPEDIDOFOS
		 WHERE CDFILIAL     =  :CDFILIAL
		   AND CDCAIXA      =  :CDCAIXA
		   AND NRSEQVENDA   =  :NRSEQVENDA
		   AND NRSEQUITVEND =  :NRSEQUITVEND
	";

	const UPDATE_IDKDSHABILITADO = "
		UPDATE PARAVEND
		   SET IDKDSHABILITADO  =  :IDKDSHABILITADO
	";
	const GET_IDKDSHABILITADO = "
		SELECT IDKDSHABILITADO FROM PARAVEND
	";

	const EXPEDITE_ORDER = "
		UPDATE PEDIDOFOS
		   SET IDSTATUSPEDFOS = '4'
		 WHERE CDFILIAL       = :CDFILIAL
		   AND NRPEDIDOFOS    = :NRPEDIDOFOS
		   AND IDSTATUSPEDFOS <> '4'
	";
	const EXPEDITE_COMANDA = "
		UPDATE COMANDAVEN
			 SET IDIMPCUPEXP = '2'
		 WHERE IDIMPCUPEXP IN ('1','0')
			 AND NRCOMANDA = :NRCOMANDA
			 AND NRVENDAREST = :NRVENDAREST
			 AND CDFILIAL = :CDFILIAL
	";

	const CHANGE_STATUS_REQUEST = "
		UPDATE PEDIDOFOS
		   SET IDATIVO     = :IDATIVO
		 WHERE CDFILIAL    = :CDFILIAL
		   AND NRPEDIDOFOS = :NRPEDIDOFOS
	";

	const GET_COLOUR_PARAMS = "
		SELECT NRCORPEDIDO, IDPISCAPED, NRINICIOCOR, NRFINALCOR
		  FROM CORPEDIDO
		 ORDER BY NRINICIOCOR ASC
	";

    const GET_FREEZE_TIME_PARAM = "
        SELECT IDFRNONNTF FROM SETORFILIAL 
            WHERE CDSETOR = :CDSETOR 
            AND CDFILIAL = :CDFILIAL
    ";

	const GET_PRODUCTION_ORDER = "
		SELECT PT.CDPRODUTO, CDSUBPRODUTO, ISNULL(SP.NRTEMPOPROD, 0) AS NRTEMPOPROD, PF.DTPEDIDOFOS,
		       IT.DSCHAVEPEDPAI
		  FROM PEDIDOFOS PF JOIN ITPEDIDOFOS IT
                              ON PF.NRPEDIDOFOS = IT.NRPEDIDOFOS
                            JOIN PRODUTO PT
                              ON PT.CDPRODUTO = IT.CDPRODUTO
                            JOIN ROTFABRICA RF
                              ON RF.CDPRODUTO = PT.CDPRODUTO
                            JOIN SETORPRODUTO SP
                              ON PT.CDPRODUTO = SP.CDPRODUTO
         WHERE IT.NRITPEDIDOFOS = :NRITPEDIDOFOS
           AND IT.NRPEDIDOFOS   = :NRPEDIDOFOS
	";

	const GET_LOCAL_COMPOSITION = "
		SELECT DISTINCT RF.CDSUBPRODLOC AS CDSUBPRODUTO, RF.QTSUBPRODLOC AS QUANTIDADE,
		ISNULL(SP.NRTEMPOPROD, 0) AS NRTEMPOPROD, RF.DSAPELIDOKDS, SP.IDSOMRESUMO
		FROM ROTFABLOCAL RF JOIN SETORPRODUTO SP
				ON RF.CDSUBPRODLOC = SP.CDPRODUTO
				JOIN SETORFILIAL SF
				ON SF.CDSETOR  = SP.CDSETOR
				JOIN SETORLOJA SL
				ON SL.CDFILIAL = SF.CDFILIAL
				AND SL.CDSETOR = SP.CDSETOR
				JOIN SETOR SE 
				ON SE.CDSETOR = SP.CDSETOR AND SE.IDTIPOSETOR = 'P'
		WHERE RF.CDPRODUTO = :CDPRODUTO
		AND SF.CDFILIAL  = :CDFILIAL
		AND (SF.IDATIVO = 'S' 
		OR SF.IDATIVO IS NULL)
		AND SL.CDLOJA = :CDLOJA
		ORDER BY NRTEMPOPROD DESC
	";

	const GET_PATTERN_COMPOSITION = "
		SELECT DISTINCT RF.CDSUBPRODUTO AS CDSUBPRODUTO, RF.QTSUBPRODROT AS QUANTIDADE,
		       ISNULL(SP.NRTEMPOPROD, 0) AS NRTEMPOPROD, DSAPELIDOKDS, SP.IDSOMRESUMO
		  FROM ROTFABRICA RF JOIN SETORPRODUTO SP
                               ON RF.CDSUBPRODUTO = SP.CDPRODUTO
                             JOIN SETORFILIAL SF
                               ON SF.CDSETOR  = SP.CDSETOR
                             JOIN SETORLOJA SL
                               ON SL.CDFILIAL = SF.CDFILIAL
                               AND SL.CDSETOR = SP.CDSETOR
							JOIN SETOR SE 
							   ON SE.CDSETOR = SP.CDSETOR AND SE.IDTIPOSETOR = 'P'
		WHERE RF.CDPRODUTO = :CDPRODUTO
           	AND SF.CDFILIAL  = :CDFILIAL
		   	AND (SF.IDATIVO = 'S' 
			OR SF.IDATIVO IS NULL)
          	AND SL.CDLOJA = :CDLOJA
		ORDER BY NRTEMPOPROD DESC
	";

	const VERIFY_OBSERVATION_BY_DSOCORR = "
		SELECT DSOCORR AS OBSERVACAO, 
			ISNULL(NRCORSINAL, 'FFFFFF') AS NRCORSINAL, 
			DSAPELIDOOBS 
		FROM OCORRENCIA
		WHERE DSOCORR = :DSOCORR
	";

	const GET_ALL_ITEM_OBSERVATIONS = "
		SELECT OBSERVACOES.DSOCORR AS OBSERVACAO, OBSERVACOES.DSAPELIDOOBS AS DSAPELIDOOBS, 0 AS NRTEMPOPROD, ISNULL(OBSERVACOES.NRCORSINAL, 'FFFFFF') AS NRCORSINAL
			FROM (
			SELECT 
			CASE
			WHEN CA.IDCONTROLAOBS = 'A'
				THEN  '+' + CA.DSOCORR 
			WHEN  CA.IDCONTROLAOBS = 'R' 
				THEN  '-' + CA.DSOCORR 
			ELSE CA.DSOCORR END AS DSOCORR,

			CASE
			WHEN CA.IDCONTROLAOBS = 'A'
				THEN  '+' + CA.DSAPELIDOOBS 
			WHEN  CA.IDCONTROLAOBS = 'R' 
				THEN  '-' + CA.DSAPELIDOOBS 
			ELSE CA.DSAPELIDOOBS END AS DSAPELIDOOBS,
			
			-- DSAPELIDOOBS
			CA.NRCORSINAL
				FROM OBSITCOMANDAEST OA JOIN OCORRENCIA CA
																	ON CA.CDGRPOCOR = OA.CDGRPOCOR
																AND CA.CDOCORR   = OA.CDOCORR

			WHERE OA.CDFILIAL + OA.NRVENDAREST + OA.NRCOMANDA + OA.NRPRODCOMVEN + OA.CDPRODUTO = :CHAVEITEM

			UNION

			SELECT 
			CASE
			WHEN CB.IDCONTROLAOBS = 'A'
				THEN  '+' + CB.DSOCORR
			WHEN  CB.IDCONTROLAOBS = 'R' 
				THEN  '-' + CB.DSOCORR
			ELSE CB.DSOCORR END AS DSOCORR,

			CASE
			WHEN CB.IDCONTROLAOBS = 'A'
				THEN  '+' + CB.DSAPELIDOOBS 
			WHEN  CB.IDCONTROLAOBS = 'R' 
				THEN  '-' + CB.DSAPELIDOOBS 
			ELSE CB.DSAPELIDOOBS END AS DSAPELIDOOBS, 
			
			CB.NRCORSINAL
				FROM OBSITEMVENDAEST OB JOIN OCORRENCIA CB
													ON CB.CDGRPOCOR = OB.CDGRPOCOR
												AND CB.CDOCORR   = OB.CDOCORR

			WHERE OB.CDFILIAL + OB.CDCAIXA + OB.NRSEQVENDA + OB.NRSEQUITVEND + OB.CDPRODUTO = :CHAVEITEM

			UNION

			SELECT 
			CASE
			WHEN CC.IDCONTROLAOBS = 'A'
				THEN  '+' + CC.DSOCORR 
			WHEN  CC.IDCONTROLAOBS = 'R' 
				THEN  '-' + CC.DSOCORR 
			ELSE CC.DSOCORR END AS DSOCORR, 

			CASE
			WHEN CC.IDCONTROLAOBS = 'A'
				THEN  '+' + CC.DSAPELIDOOBS 
			WHEN  CC.IDCONTROLAOBS = 'R' 
				THEN  '-' + CC.DSAPELIDOOBS 
			ELSE CC.DSAPELIDOOBS END AS DSAPELIDOOBS, 
			
			CC.NRCORSINAL
				FROM OBSITEMVENDA OC JOIN OCORRENCIA CC
															ON CC.CDGRPOCOR = OC.CDGRPOCOR
															AND CC.CDOCORR   = OC.CDOCORR

			WHERE OC.CDFILIAL + OC.CDCAIXA + OC.NRSEQVENDA + OC.NRSEQUITVEND = :CHAVEITEM

			UNION

			SELECT 
			CASE
			WHEN CD.IDCONTROLAOBS = 'A'
				THEN  '+' + CD.DSOCORR 
			WHEN  CD.IDCONTROLAOBS = 'R' 
				THEN  '-' + CD.DSOCORR 
			ELSE CD.DSOCORR END AS DSOCORR, 

			CASE
			WHEN CD.IDCONTROLAOBS = 'A'
				THEN  '+' + CD.DSAPELIDOOBS 
			WHEN  CD.IDCONTROLAOBS = 'R' 
				THEN  '-' + CD.DSAPELIDOOBS 
			ELSE CD.DSAPELIDOOBS END AS DSAPELIDOOBS, 
			
			CD.NRCORSINAL
				FROM OBSITCOMANDAVEN OD JOIN OCORRENCIA CD
													ON CD.CDGRPOCOR = OD.CDGRPOCOR
												AND CD.CDOCORR   = OD.CDOCORR

			WHERE OD.CDFILIAL + OD.NRVENDAREST + OD.NRCOMANDA + OD.NRPRODCOMVEN  = :CHAVEITEM
		) OBSERVACOES
	";

	const GET_ITEM_OBSERVATIONS_BY_SETOR_PRODUTO = "
		SELECT OBSERVACOES.DSOCORR AS OBSERVACAO, OBSERVACOES.DSAPELIDOOBS AS DSAPELIDOOBS, ISNULL(OBSERVACOES.NRTEMPOPROD, 0) AS NRTEMPOPROD, ISNULL(OBSERVACOES.NRCORSINAL, 'FFFFFF') AS NRCORSINAL
		FROM (
		SELECT 
		
		CASE
		WHEN CA.IDCONTROLAOBS = 'A'
			THEN  '+' + CA.DSOCORR 
		WHEN  CA.IDCONTROLAOBS = 'R' 
			THEN  '-' + CA.DSOCORR 
		ELSE CA.DSOCORR END AS DSOCORR, 

		CASE
		WHEN CA.IDCONTROLAOBS = 'A'
			THEN  '+' + CA.DSAPELIDOOBS 
		WHEN  CA.IDCONTROLAOBS = 'R' 
			THEN  '-' + CA.DSAPELIDOOBS 
		ELSE CA.DSAPELIDOOBS END AS DSAPELIDOOBS,
		
		SA.NRTEMPOPROD, CA.NRCORSINAL
			FROM OBSITCOMANDAEST OA JOIN OCORRENCIA CA
									ON CA.CDGRPOCOR = OA.CDGRPOCOR
									AND CA.CDOCORR   = OA.CDOCORR

									JOIN SETORPRODOBS SA
									ON SA.CDGRPOCOR = OA.CDGRPOCOR
									AND SA.CDOCORR   = OA.CDOCORR

		WHERE OA.CDFILIAL + OA.NRVENDAREST + OA.NRCOMANDA + OA.NRPRODCOMVEN + OA.CDPRODUTO = :CHAVEITEM
			AND SA.CDSETOR = :CDSETOR
			AND SA.CDPRODUTO = :CDPRODUTO

		UNION

		SELECT 
		
		CASE
		WHEN CB.IDCONTROLAOBS = 'A'
			THEN  '+' + CB.DSOCORR 
		WHEN  CB.IDCONTROLAOBS = 'R' 
			THEN  '-' + CB.DSOCORR 
		ELSE CB.DSOCORR END AS DSOCORR, 

		CASE
		WHEN CB.IDCONTROLAOBS = 'A'
			THEN  '+' + CB.DSAPELIDOOBS 
		WHEN  CB.IDCONTROLAOBS = 'R' 
			THEN  '-' + CB.DSAPELIDOOBS 
		ELSE CB.DSAPELIDOOBS END AS DSAPELIDOOBS,
		
		SB.NRTEMPOPROD, CB.NRCORSINAL
			FROM OBSITEMVENDAEST OB JOIN OCORRENCIA CB
									ON CB.CDGRPOCOR = OB.CDGRPOCOR
									AND CB.CDOCORR   = OB.CDOCORR

									JOIN SETORPRODOBS SB
									ON SB.CDGRPOCOR = OB.CDGRPOCOR
									AND SB.CDOCORR   = OB.CDOCORR

		WHERE OB.CDFILIAL + OB.CDCAIXA + OB.NRSEQVENDA + OB.NRSEQUITVEND + OB.CDPRODUTO = :CHAVEITEM
			AND SB.CDSETOR = :CDSETOR
			AND SB.CDPRODUTO = :CDPRODUTO

		UNION

		SELECT 
		CASE
		WHEN CC.IDCONTROLAOBS = 'A'
			THEN  '+' + CC.DSOCORR 
		WHEN  CC.IDCONTROLAOBS = 'R' 
			THEN  '-' + CC.DSOCORR 
		ELSE CC.DSOCORR END AS DSOCORR, 

		CASE
		WHEN CC.IDCONTROLAOBS = 'A'
			THEN  '+' + CC.DSAPELIDOOBS 
		WHEN  CC.IDCONTROLAOBS = 'R' 
			THEN  '-' + CC.DSAPELIDOOBS 
		ELSE CC.DSAPELIDOOBS END AS DSAPELIDOOBS, 
		
		SC.NRTEMPOPROD, CC.NRCORSINAL
			FROM OBSITEMVENDA OC JOIN OCORRENCIA CC
								ON CC.CDGRPOCOR = OC.CDGRPOCOR
								AND CC.CDOCORR   = OC.CDOCORR

								JOIN SETORPRODOBS SC
								ON SC.CDGRPOCOR = OC.CDGRPOCOR
								AND SC.CDOCORR   = OC.CDOCORR

		WHERE OC.CDFILIAL + OC.CDCAIXA + OC.NRSEQVENDA + OC.NRSEQUITVEND = :CHAVEITEM
			AND SC.CDSETOR = :CDSETOR
			AND SC.CDPRODUTO = :CDPRODUTO

		UNION

		SELECT 
		CASE
		WHEN CD.IDCONTROLAOBS = 'A'
			THEN  '+' + CD.DSOCORR 
		WHEN  CD.IDCONTROLAOBS = 'R' 
			THEN  '-' + CD.DSOCORR 
		ELSE CD.DSOCORR END AS DSOCORR, 

		CASE
		WHEN CD.IDCONTROLAOBS = 'A'
			THEN  '+' + CD.DSAPELIDOOBS 
		WHEN  CD.IDCONTROLAOBS = 'R' 
			THEN  '-' + CD.DSAPELIDOOBS 
		ELSE CD.DSAPELIDOOBS END AS DSAPELIDOOBS, 
		
		SD.NRTEMPOPROD, CD.NRCORSINAL
			FROM OBSITCOMANDAVEN OD JOIN OCORRENCIA CD
									ON CD.CDGRPOCOR = OD.CDGRPOCOR
									AND CD.CDOCORR   = OD.CDOCORR

									JOIN SETORPRODOBS SD
									ON SD.CDGRPOCOR = OD.CDGRPOCOR
									AND SD.CDOCORR   = OD.CDOCORR

		WHERE OD.CDFILIAL + OD.NRVENDAREST + OD.NRCOMANDA + OD.NRPRODCOMVEN = :CHAVEITEM
			AND SD.CDSETOR = :CDSETOR
			AND SD.CDPRODUTO = :CDPRODUTO
		) OBSERVACOES
	";

	const GET_SECTOR_OBSERVATIONS = "
		SELECT CDOCORR
		  FROM SETORPRODOBS
		 WHERE CDSETOR = :CDSETOR
		   AND CDPRODUTO = :CDPRODUTO
	";

	const GET_PRODUCT_PROMOTION_VENDA = "
			SELECT I.CDPRODUTO, I.QTITVENDAEST AS QUANTIDADE, P.NMPRODUTO,
			I.CDFILIAL + I.CDCAIXA + I.NRSEQVENDA + I.NRSEQUITVEND + I.CDPRODUTO AS CHAVEITEM,
			I.NRATRAPRODITES AS NRATRAPROD, 
			I.DSOBSPEDDIGITE AS OBSDIGITADA,
			I.DSOBSITVENDAEST AS TXPRODCOMVENEST
		FROM PRODUTO P, ITEMVENDAEST I 
		WHERE I.CDFILIAL = :CDFILIAL
		AND I.CDCAIXA = :CDCAIXA
		AND I.NRSEQVENDA = :NRSEQVENDA
		AND I.NRSEQUITVEND = :NRSEQUITVEND
		AND I.CDPRODUTO = P.CDPRODUTO
	";
    
	const GET_PRODUCT_PROMOTION_COMANDA = "
		SELECT I.CDPRODUTO, I.QTPROCOMEST AS QUANTIDADE, P.NMPRODUTO, I.TXPRODCOMVENEST,
		       I.CDFILIAL + I.NRVENDAREST + I.NRCOMANDA + I.NRPRODCOMVEN + I.CDPRODUTO AS CHAVEITEM,
		       I.NRATRAPRODCOES AS NRATRAPROD, I.DSOBSPEDDIGEST AS OBSDIGITADA
		  FROM ITCOMANDAEST I, PRODUTO P
		 WHERE I.CDFILIAL = :CDFILIAL
		   AND I.NRCOMANDA = :NRCOMANDA
		   AND I.NRPRODCOMVEN = :NRPRODCOMVEN
		   AND I.NRVENDAREST = :NRVENDAREST
		   AND I.CDPRODUTO = P.CDPRODUTO
	";

	const SEND_ITEMS_TO_PRODUCTION = "
		UPDATE ITPEDIDOFOS
		   SET DTHREXIBICAOPROD = :DTHREXIBICAOPROD
		 WHERE DSCHAVEPEDPAI    = :DSCHAVEPEDPAI
		   AND NRITPEDIDOFOS    = :NRITPEDIDOFOS
	";

	const GET_PATTERN_PRODUCT = "
		SELECT IT.DSCHAVEPEDPAI, ISNULL(SP.NRTEMPOPROD, 0)AS NRTEMPOPROD, IT.CDPRODUTO, IT.CDFILIAL,
		       IT.NRPEDIDOFOS, IT.NRITPEDIDOFOS, SP.IDSOMRESUMO
		  FROM ITPEDIDOFOS IT JOIN SETORPRODUTO SP
		                        ON SP.CDSETOR   = IT.CDSETOR
		                       AND SP.CDPRODUTO = IT.CDPRODUTO
		 WHERE (NRITPEDIDOFOS = :NRITPEDIDOFOS OR (:NRITPEDIDOFOS IS NULL AND DSCHAVEPEDPAI IS NULL))
		   AND CDFILIAL       = :CDFILIAL
		   AND NRPEDIDOFOS    = :NRPEDIDOFOS
	  ORDER BY SP.NRTEMPOPROD
	";

	const GET_PATTERN_COMPOSITION_BY_CHAVE = "
		SELECT RF.CDSUBPRODUTO AS CDSUBPRODUTO, RF.QTSUBPRODROT AS QUANTIDADE, ISNULL(SP.NRTEMPOPROD, 0) AS NRTEMPOPROD, IT.DTHREXIBICAOPROD,
		       IT.CDSETOR, IT.DSCHAVEPEDPAI, SP.IDSOMRESUMO
		  FROM ROTFABRICA RF JOIN SETORPRODUTO SP
                               ON RF.CDSUBPRODUTO = SP.CDPRODUTO
                             JOIN ITPEDIDOFOS IT
                               ON IT.CDPRODUTO = RF.CDSUBPRODUTO
		 WHERE IT.DSCHAVEPEDPAI = :DSCHAVEPEDPAI
		   AND RF.CDPRODUTO = :CDPRODUTO
		 ORDER BY NRSEQPROD
	";

	const GET_PRODUCT_SECTOR = "
		SELECT P.*, S.IDTIPOSETOR, F.NRCORVGM, LPS.CDLINHAPROD, F.IDHABREDIREC
		  FROM SETORPRODUTO P JOIN SETOR S
		  				        ON P.CDSETOR  = S.CDSETOR
		  				      JOIN SETORFILIAL F
								  ON F.CDSETOR  = S.CDSETOR
							  LEFT JOIN LINHAPRODSETOR LPS 
								  ON (LPS.CDSETOR = P.CDSETOR)
								LEFT JOIN LINHAPROD LP ON (LP.CDLINHAPROD = LPS.CDLINHAPROD AND LP.IDATIVO = 'S')
								JOIN SETORLOJA SL ON (SL.CDFILIAL = :CDFILIAL AND SL.CDLOJA = :CDLOJA AND SL.CDSETOR = F.CDSETOR)

		WHERE P.CDPRODUTO = :CDPRODUTO
		AND F.CDFILIAL  = :CDFILIAL
	";

	const GET_PRODUCT_SECTOR_BY_TYPE = "
		SELECT P.CDPRODUTO, P.CDSETOR, F.IDHABREDIREC, ISNULL(P.NRTEMPOPROD, 0) AS NRTEMPOPROD, S.IDTIPOSETOR,
		       ISNULL(P.NRTEMPOEXIB, 0) AS NRTEMPOEXIB, F.NRCORVGM, P.IDPRODPRIORIDADE
			FROM SETORPRODUTO P JOIN SETOR S
		  				        ON P.CDSETOR  = S.CDSETOR
		  				      JOIN SETORFILIAL F
		  				        ON F.CDSETOR  = S.CDSETOR
		 WHERE P.CDPRODUTO   = :CDPRODUTO
		   	AND F.CDFILIAL    = :CDFILIAL
		   	AND (F.IDATIVO = 'S'
			OR F.IDATIVO IS NULL)
			AND S.IDTIPOSETOR = :IDTIPOSETOR
	";
	const GET_REDIRECT_SECTOR = "
		SELECT RED.CDSETOR, RED.CDSETORRED, RED.IDORIGEMVENDA, RED.IDHABILITADO, S.IDTIPOSETOR
		FROM REDPEDMODALIDADE RED
			JOIN SETOR S
			ON S.CDSETOR = RED.CDSETORRED
		WHERE RED.CDFILIAL = :CDFILIAL
		AND RED.CDSETOR = :CDSETOR
	";

	const GET_SECTOR_STORE_COUNT = "
		SELECT *
		  FROM SETORLOJA
		 WHERE CDFILIAL = :CDFILIAL
		   AND CDLOJA = :CDLOJA
	";

	const GET_PRODUCT_SECTOR_BY_TYPE_STORE = "
		SELECT P.CDPRODUTO, P.CDSETOR, F.IDHABREDIREC, ISNULL(P.NRTEMPOPROD, 0) AS NRTEMPOPROD, S.IDTIPOSETOR,
		       ISNULL(P.NRTEMPOEXIB, 0) AS NRTEMPOEXIB, F.NRCORVGM
		  FROM SETORPRODUTO P JOIN SETOR S
		  				        ON P.CDSETOR  = S.CDSETOR
		  				      JOIN SETORFILIAL F
		  				        ON F.CDSETOR  = S.CDSETOR
		  				      JOIN SETORLOJA L
		  				        ON F.CDFILIAL = L.CDFILIAL
		  				       AND F.CDSETOR = L.CDSETOR
		 WHERE P.CDPRODUTO   = :CDPRODUTO
		   	AND F.CDFILIAL    = :CDFILIAL
			AND (F.IDATIVO = 'S'
			OR F.IDATIVO IS NULL)
		   	AND L.CDLOJA      = :CDLOJA
			AND S.IDTIPOSETOR = :IDTIPOSETOR
		 ORDER BY F.IDPRIORM
	";

	const GET_CHECK_PRODUCTION = "
		SELECT IDSITITPEDFOS
		  FROM ITPEDIDOFOS
		 WHERE IDSITITPEDFOS = 'P'
		   AND DSCHAVEPEDPAI = :DSCHAVEPEDPAI
	";

	const GET_CHECK_DONE = "
		SELECT IDSITITPEDFOS
		  FROM ITPEDIDOFOS
		 WHERE IDSITITPEDFOS = 'F'
		 AND DSCHAVEPEDPAI = :DSCHAVEPEDPAI
	";

	const GET_SUBPRODUCTS = "
		SELECT IDSITITPEDFOS
		  FROM ITPEDIDOFOS
		 WHERE DSCHAVEPEDPAI = :DSCHAVEPEDPAI
	";

	const GET_CHILD_PRODUCTS = "
		SELECT IT.CDFILIAL, IT.NRPEDIDOFOS, IT.NRITPEDIDOFOS, IT.IDSITITPEDFOS, SE.IDTIPOSETOR
		  FROM ITPEDIDOFOS IT JOIN ITPEDIDOFOSPAI IP
		                        ON IT.CDFILIAL = IP.CDFILIAL
		                       AND IT.NRPEDIDOFOS = IP.NRPEDIDOFOS
		                       AND IT.NRITPEDIDOFOS = IP.NRITPEDIDOFOS
		                      JOIN SETOR SE
		                        ON IT.CDSETOR = SE.CDSETOR
		 WHERE IP.CDFILIALPAI = :CDFILIAL
		   AND IP.NRPEDIDOFOSPAI = :NRPEDIDOFOS
		   AND IP.NRITPEDIDOFOSPAI = :NRITPEDIDOFOS
	";

	const GET_CHILD_DONE = "
		SELECT IT.CDFILIAL, IT.NRPEDIDOFOS, IT.NRITPEDIDOFOS, IT.IDSITITPEDFOS
		  FROM ITPEDIDOFOS IT JOIN ITPEDIDOFOSPAI IP
		                        ON IT.CDFILIAL = IP.CDFILIAL
		                       AND IT.NRPEDIDOFOS = IP.NRPEDIDOFOS
		                       AND IT.NRITPEDIDOFOS = IP.NRITPEDIDOFOS
		                      JOIN SETOR SE
		                        ON IT.CDSETOR = SE.CDSETOR
		 WHERE IP.CDFILIALPAI = :CDFILIAL
		   AND IP.NRPEDIDOFOSPAI = :NRPEDIDOFOS
		   AND IP.NRITPEDIDOFOSPAI = :NRITPEDIDOFOS
		   AND ((IT.IDSITITPEDFOS = 'F' AND SE.IDTIPOSETOR = 'P') OR IT.IDSITITPEDFOS = 'X')
	";

	const GET_CHILD_DONE_EXP = "
		SELECT IT.CDFILIAL, IT.NRPEDIDOFOS, IT.NRITPEDIDOFOS, IT.IDSITITPEDFOS
		  FROM ITPEDIDOFOS IT JOIN ITPEDIDOFOSPAI IP
		                        ON IT.CDFILIAL = IP.CDFILIAL
		                       AND IT.NRPEDIDOFOS = IP.NRPEDIDOFOS
		                       AND IT.NRITPEDIDOFOS = IP.NRITPEDIDOFOS
		                      JOIN SETOR SE
		                        ON IT.CDSETOR = SE.CDSETOR
		 WHERE IP.CDFILIALPAI = :CDFILIAL
		   AND IP.NRPEDIDOFOSPAI = :NRPEDIDOFOS
		   AND IP.NRITPEDIDOFOSPAI = :NRITPEDIDOFOS
		   AND (IT.IDSITITPEDFOS = 'F' OR IT.IDSITITPEDFOS = 'X')
		   AND SE.IDTIPOSETOR = 'P'

		UNION

		SELECT IT.CDFILIAL, IT.NRPEDIDOFOS, IT.NRITPEDIDOFOS, IT.IDSITITPEDFOS
		  FROM ITPEDIDOFOS IT JOIN ITPEDIDOFOSPAI IP
		                        ON IT.CDFILIAL = IP.CDFILIAL
		                       AND IT.NRPEDIDOFOS = IP.NRPEDIDOFOS
		                       AND IT.NRITPEDIDOFOS = IP.NRITPEDIDOFOS
		                      JOIN SETOR SE
		                        ON IT.CDSETOR = SE.CDSETOR
		 WHERE IP.CDFILIALPAI = :CDFILIAL
		   AND IP.NRPEDIDOFOSPAI = :NRPEDIDOFOS
		   AND IP.NRITPEDIDOFOSPAI = :NRITPEDIDOFOS
		   AND IT.IDSITITPEDFOS = 'X'
		   AND SE.IDTIPOSETOR = 'M'
	";

	const GET_CHILD_PRODUCTION = "
		SELECT IT.CDFILIAL, IT.NRPEDIDOFOS, IT.NRITPEDIDOFOS, IT.IDSITITPEDFOS
		  FROM ITPEDIDOFOS IT JOIN ITPEDIDOFOSPAI IP
		                        ON IT.CDFILIAL = IP.CDFILIAL
		                       AND IT.NRPEDIDOFOS = IP.NRPEDIDOFOS
		                       AND IT.NRITPEDIDOFOS = IP.NRITPEDIDOFOS
		 WHERE IP.CDFILIALPAI = :CDFILIAL
		   AND IP.NRPEDIDOFOSPAI = :NRPEDIDOFOS
		   AND IP.NRITPEDIDOFOSPAI = :NRITPEDIDOFOS
		   AND IT.IDSITITPEDFOS = 'P'
	";

	const GET_OBSERVATION_TIME = "
		SELECT PO.CDGRPOCOR, PO.CDOCORR, PO.CDPRODUTO, CAST(ISNULL(PO.NRTEMPOPROD, 0) AS FLOAT) AS NRTEMPOPROD
		  FROM PRODOCORRE PO
		  JOIN ITPEDIDOFOS IT
		    ON IT.CDPRODUTO = PO.CDPRODUTO
		 WHERE IT.CDPRODUTO = :CDPRODUTO
		   AND IT.CDGRPOCOR = :CDGRPOCOR
		   AND IT.CDOCORR   = :CDOCORR
	";

	const GET_OBSERVATION = "
		SELECT CASE WHEN O.IDCONTROLAOBS = 'A' THEN  '+' + O.DSOCORR ELSE O.DSOCORR END AS DSOCORR, CAST(ISNULL(P.NRTEMPOPROD, 0) AS FLOAT) AS NRTEMPOPROD
		  FROM OCORRENCIA O, PRODOCORRE P
		 WHERE O.CDGRPOCOR = P.CDGRPOCOR
		 AND O.CDOCORR     = P.CDOCORR
		 AND P.CDPRODUTO   = :CDPRODUTO
	";

	const GET_PRODUCT_BY_SEQ_ORDER = "
		SELECT CDPRODUTO
		  FROM ITPEDIDOFOS
		 WHERE CDFILIAL    = :CDFILIAL
		 AND NRPEDIDOFOS   = :NRPEDIDOFOS
		 AND NRITPEDIDOFOS = :NRITPEDIDOFOS
	";
	const CLEAN_ORDERS = "
		DELETE 
			FROM PEDIDOFOS WHERE NRPEDIDOFOS IN
			(SELECT NRPEDIDOFOS FROM ITPEDIDOFOS WHERE
			(DTHREXIBICAOPROD < DATEADD(hh, :INTERVALO, GETDATE())) AND
			(IDSITITPEDFOS <> 'X')
		)
	";
	const CLEAN_ORDERS_STATISTICS = "
		DELETE FROM KDS_TEMP_SETOREST where NRPEDIDOFOS IN
			(SELECT NRPEDIDOFOS FROM PEDIDOFOS WHERE NRPEDIDOFOS IN
				(SELECT NRPEDIDOFOS 
				FROM ITPEDIDOFOS 
				WHERE (DTHREXIBICAOPROD < DATEADD(hh, :INTERVALO, GETDATE())
				AND (IDSITITPEDFOS <> 'X')))
			)
	";
	const CLEAN_PEDIDOFOS = "
		DELETE
		  FROM PEDIDOFOS
		 WHERE CDFILIAL = :CDFILIAL
		   AND DTPEDIDOFOS < GETDATE() - (:NRHORA/24)
	";

	const CLEAN_PEDIDOFOS_FROM_LOJA_BY_CDSETOR = "
		DELETE
		  FROM PEDIDOFOS
		 WHERE CDFILIAL = :CDFILIAL
		  AND CDLOJA IN
		    	(
					SELECT CDLOJA FROM SETORLOJA WHERE CDSETOR = :CDSETOR AND CDFILIAL = :CDFILIAL
				)
		   AND DTPEDIDOFOS < GETDATE() - (:NRHORA/24)
	";

	const CLEAN_ITPEDIDOFOS  = "
		DELETE
		  FROM ITPEDIDOFOS
		 WHERE CDFILIAL = :CDFILIAL
	";

	const CLEAN_ITPEDIDOFOSPAI = "
		DELETE
		  FROM ITPEDIDOFOSPAI
		 WHERE CDFILIAL = :CDFILIAL
	";

	const CLEAN_ITPEDIDOFOSREL = "
		DELETE
		  FROM ITPEDIDOFOSREL
		 WHERE CDFILIAL = :CDFILIAL
	";

	const UPDATE_DTULTATU_PEDIDOFOS = "
		UPDATE PEDIDOFOS
		   SET DTULTATU = GETDATE()
		 WHERE CDFILIAL = :CDFILIAL
		   AND NRPEDIDOFOS = :NRPEDIDOFOS
	";

	const GET_MAX_PRODUCTION_TIME = "
		-- BUSCA MAIOR TEMPO DE PRODUÇÃO DO PEDIDO
		SELECT ISNULL(MAX(CAST(IT.NRTEMPOPRODIT AS FLOAT)), 0)AS TEMPO
			FROM ITPEDIDOFOS IT
	   WHERE IT.CDFILIAL = :CDFILIAL
			 AND IT.NRPEDIDOFOS = :NRPEDIDOFOS
			 AND NRATRAPRODITPE IS NULL
	";

	const GET_MAX_PRODUCTION_TIME_NRATRAPRODITPED = "
	-- BUSCA MAIOR TEMPO DE PRODUÇÃO DO PEDIDO
	SELECT ISNULL(MAX(CAST(IT.NRTEMPOPRODIT AS FLOAT)), 0)AS TEMPO
		FROM ITPEDIDOFOS IT
	 WHERE IT.CDFILIAL = :CDFILIAL
		 AND IT.NRPEDIDOFOS = :NRPEDIDOFOS
		 AND NRATRAPRODITPE IS NOT NULL
";

	const GET_FILIAL = "
		SELECT CDFILIAL, NMFILIAL
		  FROM FILIAL
	";

	const DELETE_ITPEDIDOFOS = "
		DELETE
		  FROM ITPEDIDOFOS
		 WHERE CDFILIAL = :CDFILIAL
		   AND NRPEDIDOFOS = :NRPEDIDOFOS
		   AND NRITPEDIDOFOS  LIKE '%'+:NRITPEDIDOFOS+'%'
	";

	const DELETE_PEDIDOFOS = "
		DELETE
		  FROM PEDIDOFOS
		 WHERE CDFILIAL = :CDFILIAL
		   AND NRPEDIDOFOS = :NRPEDIDOFOS
	";

	const GET_PEDIDOFOS_BY_VENDA ="
		SELECT CDFILIAL, NRPEDIDOFOS, NRITPEDIDOFOS
		  FROM ITPEDIDOFOS
		 WHERE CDFILIAL = :CDFILIAL
		   AND NRSEQVENDA = :NRSEQVENDA
		   AND NRSEQUITVEND = :NRSEQUI'TVEND
	";

	const GET_NEW_TEMPORARY_CODE = "
		SELECT ISNULL(MAX(NRITPEDIDOFOS), 0) + 1 AS NRSEQUENCIAL
		  FROM ITPEDIDOFOS
		 WHERE CDFILIAL = :CDFILIAL
		   AND NRPEDIDOFOS = :NRPEDIDOFOS
	";

	const GET_PRODUCT_SEM_VENDA = "
		SELECT CDPRODUTO, QTPRODPEFOS AS QUANTIDADE
		  FROM ITPEDIDOFOS
		 WHERE CDFILIAL = :CDFILIAL
		   AND NRPEDIDOFOS = :NRPEDIDOFOS
	";

	const CHECK_IF_KEY_EXISTS = "
		SELECT *
		  FROM ITPEDIDOFOS
		 WHERE CDFILIAL = :CDFILIAL
		   AND NRPEDIDOFOS = :NRPEDIDOFOS
		   AND NRITPEDIDOFOS = :NRITPEDIDOFOS
	";

	const CHECK_IF_ITPEDIDOFOSPAI_EXISTS = "
		SELECT *
		  FROM ITPEDIDOFOSPAI
		 WHERE CDFILIAL = :CDFILIAL
		   AND NRPEDIDOFOS = :NRPEDIDOFOS
		   AND NRITPEDIDOFOS = :NRITPEDIDOFOS
		   AND NRSEQITPEDPAI = :NRSEQITPEDPAI
	";

 	const FIND_OLD_REQUESTS = "
		SELECT P.CDFILIAL, P.NRPEDIDOFOS
		  FROM PEDIDOFOS P JOIN ITPEDIDOFOS I
		                     ON I.NRPEDIDOFOS = P.NRPEDIDOFOS
		 WHERE NOT(P.DTPEDIDOFOS BETWEEN DATEADD(d,-1,GETDATE()) AND DATEADD(d,+1,GETDATE()))
		   AND I.IDSITITPEDFOS = 'X'
		   AND I.CDPRODUTOPAI IS NULL
		   AND P.CDFILIAL = :CDFILIAL
 	";

 	const GET_PRODUTO_FILIAL = "
 		SELECT SP.CDPRODUTO, CAST(ISNULL(SP.NRTEMPOPROD, 0) AS FLOAT) AS NRTEMPOPROD, SE.CDSETOR
 		  FROM SETORPRODUTO SP, SETOR SE, SETORFILIAL SF
 		 WHERE SP.CDPRODUTO = :CDPRODUTO
 		   AND SE.IDTIPOSETOR = :IDTIPOSETOR
 		   AND SF.CDFILIAL = :CDFILIAL
 		   AND SF.CDSETOR = SE.CDSETOR
 		   AND SF.CDSETOR = SP.CDSETOR
 		   AND SP.CDSETOR = :CDSETOR
 	";

 	const INSERT_ITPEDIDOFOSPAI = "
 		INSERT INTO ITPEDIDOFOSPAI
 		(CDFILIAL, NRPEDIDOFOS, NRITPEDIDOFOS, NRSEQITPEDPAI,
 		CDFILIALPAI, NRPEDIDOFOSPAI, NRITPEDIDOFOSPAI)
		VALUES
		(:CDFILIAL, :NRPEDIDOFOS, :NRITPEDIDOFOS, :NRSEQITPEDPAI,
 		:CDFILIALPAI, :NRPEDIDOFOSPAI, :NRITPEDIDOFOSPAI)
 	";

 	const GET_PRODUCT_BY_CODE = "
		SELECT CDPRODUTO
 		  FROM PRODUTO
 		 WHERE CDPRODUTO = :CDPRODUTO
 	";

 	const INSERT_ITPEDIDOFOSREL = "
 		INSERT INTO ITPEDIDOFOSREL
 		(CDFILIAL, NRPEDIDOFOS, NRITPEDIDOFOS, NRSEQITPEDREL,
 		NRVENDAREST, NRCOMANDA, NRPRODCOMVEN, QTPRODPEFOS,
 		IDSITITPEDFOS)
		VALUES
		(:CDFILIAL, :NRPEDIDOFOS, :NRITPEDIDOFOS, :NRSEQITPEDREL,
 		:NRVENDAREST, :NRCOMANDA, :NRPRODCOMVEN, :QTPRODPEFOS,
 		:IDSITITPEDFOS)
	 ";
	 
	const GET_EXPEDITIONS_AND_MOUNTS_CDSETOR_FROM_ITPEDIDOFOS = "
		SELECT DISTINCT IT.CDSETOR 
		FROM ITPEDIDOFOS IT
		JOIN SETOR SE ON (SE.CDSETOR = IT.CDSETOR)
		WHERE SE.IDTIPOSETOR IN ('M','E')
	";

 	const GET_ITEMS_RELATION = "
 		SELECT IR.CDFILIAL, IR.NRPEDIDOFOS, IR.NRITPEDIDOFOS, IR.NRSEQITPEDREL,
 		       IR.NRVENDAREST, IR.NRCOMANDA, IR.NRPRODCOMVEN, IR.QTPRODPEFOS,
 		       IR.IDSITITPEDFOS, IT.IDLIBERADO
 		  FROM ITPEDIDOFOS IT JOIN ITPEDIDOFOSREL IR
 		                        ON IT.CDFILIAL      = IR.CDFILIAL
 		                       AND IT.NRPEDIDOFOS   = IR.NRPEDIDOFOS
 		                       AND IT.NRITPEDIDOFOS = IR.NRITPEDIDOFOS
 		 WHERE IR.CDFILIAL      = :CDFILIAL
 		   AND IR.NRPEDIDOFOS   = :NRPEDIDOFOS
 		   AND IR.NRITPEDIDOFOS = :NRITPEDIDOFOS
 	";

	const CANCEL_ITEM = "
		UPDATE ITPEDIDOFOS
		   SET IDSITITPEDFOS = 'C'
		 WHERE CDFILIAL = :CDFILIAL
		   AND NRPEDIDOFOS = :NRPEDIDOFOS
		   AND NRITPEDIDOFOS = :NRITPEDIDOFOS
	";

	const CHANGE_ITEM_QUANTITY = "
		UPDATE ITPEDIDOFOS
		   SET QTPRODPEFOS = :QTPRODPEFOS
		 WHERE CDFILIAL = :CDFILIAL
		   AND NRPEDIDOFOS = :NRPEDIDOFOS
		   AND NRITPEDIDOFOS = :NRITPEDIDOFOS
	";

	const GET_PENDING_PRODUCTS = "
		SELECT I.*, S.IDTIPOSETOR
		  FROM ITPEDIDOFOS I JOIN SETOR S
		                       ON I.CDSETOR = S.CDSETOR
		 WHERE I.CDFILIAL = :CDFILIAL
		   AND I.NRPEDIDOFOS = :NRPEDIDOFOS
		   AND I.IDSITITPEDFOS <> 'X'
	";

	const GET_PENDING_PRODUCTS_EXPEDITION = "
		SELECT I.*, S.IDTIPOSETOR
		  FROM ITPEDIDOFOS I JOIN SETOR S
		                       ON I.CDSETOR = S.CDSETOR
		 WHERE I.CDFILIAL = :CDFILIAL
		   AND I.NRPEDIDOFOS = :NRPEDIDOFOS
		   AND I.IDSITITPEDFOS <> 'X'
		   AND S.IDTIPOSETOR <> 'P'
	";

    const GET_PENDING_PRODUCTS_PRODUCTION = "
		SELECT I.*, S.IDTIPOSETOR
		  FROM ITPEDIDOFOS I JOIN SETOR S
		                       ON I.CDSETOR = S.CDSETOR
		 WHERE I.CDFILIAL = :CDFILIAL
		   AND I.NRPEDIDOFOS = :NRPEDIDOFOS
		   AND I.IDSITITPEDFOS <> 'X'
		   AND S.IDTIPOSETOR = 'P'
	 ";
	 
	const GET_PENDING_PRODUCTS_PRODUCTION_CORRECT = "
		SELECT I.*, S.IDTIPOSETOR
		FROM ITPEDIDOFOS I JOIN SETOR S
								ON I.CDSETOR = S.CDSETOR
		WHERE I.CDFILIAL = :CDFILIAL
			AND I.NRPEDIDOFOS = :NRPEDIDOFOS
			AND I.IDSITITPEDFOS <> 'X'
			AND S.IDTIPOSETOR = 'P'
	";	 

 	const GET_ITEM_SONS = "
 		SELECT *
 		  FROM ITPEDIDOFOSPAI
 		 WHERE CDFILIALPAI = :CDFILIALPAI
 		   AND NRPEDIDOFOSPAI = :NRPEDIDOFOSPAI
 		   AND NRITPEDIDOFOSPAI = :NRITPEDIDOFOSPAI
 	";

 	const GET_ITEM_INTERVALS = "
 		SELECT NRTEMPOINTER
 		  FROM SETORPRODINTER
 		 WHERE CDPRODUTO = :CDPRODUTO
 		   AND CDSETOR = :CDSETOR
 		ORDER BY NRTEMPOINTER
 	";

    const RELEASE_ITEM = "
        UPDATE ITPEDIDOFOS
           SET IDLIBERADO = 'S',
               NRSEQLIBERADO = :NRSEQLIBERADO
         WHERE CDFILIAL = :CDFILIAL
           AND NRPEDIDOFOS = :NRPEDIDOFOS
           AND NRITPEDIDOFOS = :NRITPEDIDOFOS
    ";

    const GET_ITEM_PARENT = "
    	SELECT CDFILIALPAI, NRPEDIDOFOSPAI, NRITPEDIDOFOSPAI
    	  FROM ITPEDIDOFOSPAI
    	 WHERE CDFILIAL = :CDFILIAL
    	   AND NRPEDIDOFOS = :NRPEDIDOFOS
    	   AND NRITPEDIDOFOS = :NRITPEDIDOFOS
    ";

	const GET_ITEM_PARENT_NOT_CONCLUDED = "
		SELECT CDFILIALPAI, NRPEDIDOFOSPAI, NRITPEDIDOFOSPAI
			FROM ITPEDIDOFOSPAI ITP
		JOIN ITPEDIDOFOS IT 
			ON IT.NRPEDIDOFOS = ITP.NRPEDIDOFOS
			AND IT.CDFILIAL = ITP.CDFILIAL
			AND IT.NRITPEDIDOFOS = ITP.NRITPEDIDOFOSPAI
		WHERE ITP.CDFILIAL = :CDFILIAL
			AND ITP.NRPEDIDOFOS = :NRPEDIDOFOS
			AND ITP.NRITPEDIDOFOS = :NRITPEDIDOFOS
			AND IT.IDSITITPEDFOS <> 'F'
    ";

    const GET_ITEM_CASCADE = "
    	SELECT CDFILIAL, NRPEDIDOFOS, NRITPEDIDOFOS
    	  FROM ITPEDIDOFOSPAI
    	 WHERE CDFILIALPAI = :CDFILIAL
    	   AND NRPEDIDOFOSPAI = :NRPEDIDOFOS
    	   AND NRITPEDIDOFOSPAI = :NRITPEDIDOFOS
    ";

    const GET_PRODUCTION_START = "
    	SELECT DTHRINIPRODUCAO
    	  FROM ITPEDIDOFOS
    	 WHERE CDFILIAL = :CDFILIAL
    	   AND NRPEDIDOFOS = :NRPEDIDOFOS
    	   AND NRITPEDIDOFOS = :NRITPEDIDOFOS
    ";

    const GET_IF_MUST_SEND_CONCLUSIONS = "
    	SELECT *
    	  FROM ITPEDIDOFOS
    	 WHERE CDFILIAL = :CDFILIAL
    	   AND NRPEDIDOFOS = :NRPEDIDOFOS
    	   AND CDSETOR = :CDSETOR
    	   AND IDSITITPEDFOS <> 'X'
    ";

    const GET_MAPPED_KEYS = "
    	SELECT IDKEY, IDFUNCAO
    	  FROM LAYOUTTECLAKDS
    ";

	// STATUS UPDATES ---------------------------------------------------------------

	const CHANGE_STATUS_REQUEST_ITEM_PLAY = "
		UPDATE ITPEDIDOFOS
		   SET IDSITITPEDFOS   = 'P',
		       DTHRINIPRODUCAO = GETDATE()
		 WHERE CDFILIAL        = :CDFILIAL
		   AND NRPEDIDOFOS     = :NRPEDIDOFOS
		   AND NRITPEDIDOFOS   = :NRITPEDIDOFOS
		   AND IDSITITPEDFOS   <> 'P'
	";

	const CHANGE_STATUS_REQUEST_ITEM_CONCLUDE = "
		UPDATE ITPEDIDOFOS
		   SET IDSITITPEDFOS   = 'F',
		       DTHRFINPRODUCAO = DATEADD(second,ISNULL((SELECT NRROLLBTIME
		       													  FROM SETORFILIAL
		       													 WHERE CDFILIAL = :CDFILIAL
		       													   AND IDHABROLLBKDS = 'S'
		       													   AND CDSETOR = (SELECT CDSETOR
		       													                    FROM ITPEDIDOFOS
		       													                   WHERE CDFILIAL      = :CDFILIAL
																	       		     AND NRPEDIDOFOS   = :NRPEDIDOFOS
																		     		 AND NRITPEDIDOFOS = :NRITPEDIDOFOS))
								                 , 0) *(-1), GETDATE()),
		       DTHRINIPRODUCAO = ISNULL(DTHRINIPRODUCAO, DATEADD(second,ISNULL((SELECT NRROLLBTIME
		       													  FROM SETORFILIAL
		       													 WHERE CDFILIAL = :CDFILIAL
		       													   AND IDHABROLLBKDS = 'S'
		       													   AND CDSETOR = (SELECT CDSETOR
		       													                    FROM ITPEDIDOFOS
		       													                   WHERE CDFILIAL      = :CDFILIAL
																	       		     AND NRPEDIDOFOS   = :NRPEDIDOFOS
																		     		 AND NRITPEDIDOFOS = :NRITPEDIDOFOS))
								                 , 0) *(-1), GETDATE()))
		 WHERE CDFILIAL        = :CDFILIAL
		   AND NRPEDIDOFOS     = :NRPEDIDOFOS
		   AND NRITPEDIDOFOS   = :NRITPEDIDOFOS
		   AND IDSITITPEDFOS   <> 'F'
	";

    const CHANGE_ITEM_STATUS_RELEASED = "
    	UPDATE ITPEDIDOFOS
		   SET IDSITITPEDFOS = 'X',
		   DTHRFINPRODUCAO = ISNULL(DTHRFINPRODUCAO, GETDATE()),
		   DTHRINIPRODUCAO = ISNULL(DTHRINIPRODUCAO, DTHREXIBICAOPROD)
    	 WHERE CDFILIAL      = :CDFILIAL
    	   AND NRPEDIDOFOS   = :NRPEDIDOFOS
    	   AND NRITPEDIDOFOS = :NRITPEDIDOFOS
    	   AND IDSITITPEDFOS <> 'X'
		   AND CDPRODUTOPAI IS NULL
    ";

	const CHANGE_STATUS_REQUEST_ITEM_EXPEDITE = "
		UPDATE ITPEDIDOFOS
		   SET IDSITITPEDFOS   = 'X',
		       DTHRFINPRODUCAO = DATEADD(second,ISNULL((SELECT NRROLLBTIME
		       													  FROM SETORFILIAL
		       													 WHERE CDFILIAL = :CDFILIAL
		       													   AND IDHABROLLBKDS = 'S'
		       													   AND CDSETOR = (SELECT CDSETOR
		       													                    FROM ITPEDIDOFOS
		       													                   WHERE CDFILIAL      = :CDFILIAL
																	       		     AND NRPEDIDOFOS   = :NRPEDIDOFOS
																		     		 AND NRITPEDIDOFOS = :NRITPEDIDOFOS))
								                 , 0) *(-1), GETDATE()),
		       DTHRINIPRODUCAO = ISNULL(DTHRINIPRODUCAO, DATEADD(second,ISNULL((SELECT NRROLLBTIME
		       													  FROM SETORFILIAL
		       													 WHERE CDFILIAL = :CDFILIAL
		       													   AND IDHABROLLBKDS = 'S'
		       													   AND CDSETOR = (SELECT CDSETOR
		       													                    FROM ITPEDIDOFOS
		       													                   WHERE CDFILIAL      = :CDFILIAL
																	       		     AND NRPEDIDOFOS   = :NRPEDIDOFOS
																		     		 AND NRITPEDIDOFOS = :NRITPEDIDOFOS))
								                 , 0) *(-1), GETDATE()))
		 WHERE CDFILIAL        = :CDFILIAL
		   AND NRPEDIDOFOS     = :NRPEDIDOFOS
		   AND NRITPEDIDOFOS   = :NRITPEDIDOFOS
		   AND IDSITITPEDFOS   <> 'X'
	";

	const CHANGE_STATUS_REQUEST_ITEM_ZOOM_EVENT = "
		UPDATE ITPEDIDOFOS
		SET IDSITITPEDFOS = :IDSITITPEDFOS,
			DTHRFINPRODUCAO = ISNULL(DTHRFINPRODUCAO, GETDATE()),
			DTHRINIPRODUCAO = ISNULL(DTHRINIPRODUCAO, DTHREXIBICAOPROD)
		WHERE CDFILIAL      = :CDFILIAL
			AND NRPEDIDOFOS   = :NRPEDIDOFOS
			AND NRITPEDIDOFOS = :NRITPEDIDOFOS
			AND IDSITITPEDFOS <> 'X'
	";

	// END ---------------------------------------------------------------

	const GET_DEFAULT_FILIAL = "
		SELECT CDFILIAL
		FROM FILIAL
	";

	const GET_SALE_ORIGIN = "
		SELECT IDORGCMDVENDA
		  FROM COMANDAVEN
		 WHERE CDFILIAL    = :CDFILIAL
		   AND NRVENDAREST = :NRVENDAREST
		   AND IDORGCMDVENDA <> 'DLV_APP'
	";

	const GET_CONSUMER_SALE_OWNER = "
		SELECT C.CDCLIENTE, C.CDCLIENTE
		  FROM VENDAREST V
		  JOIN CONSUMIDOR C
		    ON C.CDCLIENTE = V.CDCLIENTE
		   AND C.CDCONSUMIDOR = V.CDCONSUMIDOR
		 WHERE CDFILIAL = :CDFILIAL
		   AND NRVENDAREST = :NRVENDAREST
	";

	const GET_EXTERNAL_CODE = "
		SELECT NRCOMANDAEXT
		  FROM COMANDAVEN
		 WHERE NRVENDAREST = :NRVENDAREST
		   AND CDFILIAL = :CDFILIAL
	";

	const GET_SALE_IDIMPCUPEXP = "
		SELECT IDIMPCUPEXP
		  FROM COMANDAVEN
		 WHERE CDFILIAL = :CDFILIAL
		   AND NRVENDAREST =  :NRVENDAREST
    ";

  const UPDATE_SALE_IDIMPCUPEXP = "
    	UPDATE COMANDAVEN
    	   SET IDIMPCUPEXP = :IDIMPCUPEXP
    	 WHERE CDFILIAL = :CDFILIAL
    	   AND NRVENDAREST = :NRVENDAREST
    ";
	const GET_FIXED_SUMMARY_ITEMS = "
		SELECT DISTINCT SP.CDPRODUTO, 0 AS QTDESPERA, 0 AS	QTDPRODUCAO, SP.IDRESUMOPRODKDS,
					 ISNULL(SP.DSAPELIDORESUMO, P.NMPRODUTO) AS DSAPELIDORESUMO
			FROM SETORPRODUTO SP JOIN SETORFILIAL F
                             ON SP.CDSETOR = F.CDSETOR
                           JOIN PRODUTO P
                             ON P.CDPRODUTO = SP.CDPRODUTO
		 WHERE F.CDSETOR  = :CDSETOR
			 AND F.CDFILIAL = :CDFILIAL
			 AND SP.IDRESUMOPRODKDS = 'FIXED'
	";

	const GET_SECTOR_DATA = "
		SELECT IDTIPOSETOR
		  FROM SETOR
		 WHERE CDSETOR = :CDSETOR
	";

	const GET_INTEGRATION_ADDRESS = "
		SELECT DSWSINTEGRAPAGER, DSWSINTEGRAAPP FROM PARAVEND
	";

	const GET_STATISTICS = "
    SELECT 
        IE.CDFILIAL, 
        IE.CDSETOR, 
        SE.IDTIPOSETOR,
        ISNULL(IE.VRTMPMEDPROD,  0) AS TEMPOMEDIO, 
        ISNULL(IE.VRTMPMEDINI, 0) AS TEMPOINICIO,
        ISNULL(IE.VRTMPMEDATRA,  0) AS TEMPOATRASO, 
        ISNULL(IE.VRPORCCOMANATRA, 0) AS PORCENTAGEM, 
        ISNULL(IE.IDDIA,0) AS IDDIA, 
        ISNULL(IE.QTDIA,0) AS QTDIA, 
        ISNULL(IE.IDHORA,0) AS IDHORA, 
        ISNULL(IE.QTHORAANT, 0) AS QTHORAANT, 
        ISNULL(CAST(IE.MEDIADIA AS VARCHAR), 0) AS MEDIADIA, 
        ISNULL(IE.QTHORA,0) AS QTHORA,
        ISNULL(CAST(IE.MEDIAHORA AS VARCHAR),0) AS MEDIAHORA, 
        ISNULL(CAST(IE.MEDIAHORAANT AS VARCHAR),0) AS MEDIAHORAANT ,
        ISNULL(STGER.QTSETORES, 0) AS QTSETORES,
        ISNULL(STGER.SUMQTCONCLUIDO, 0) AS SUMQTCONCLUIDO,
        ISNULL(STGER.MEDIAKDSDIA, 0) AS MEDIAKDSDIA,
        ISNULL(STGER.SUMQTCONCLUIDOULTHR, 0) AS SUMQTCONCLUIDOULTHR,
        ISNULL(STGER.MEDIAKDSULTHR, 0) AS MEDIAKDSULTHR,
        ISNULL(STGER.SUMQTCONCLUIDOHR, 0) AS SUMQTCONCLUIDOHR,
        ISNULL(STGER.MEDIAKDSHR, 0) AS MEDIAKDSHR
    FROM 
        ITPEDIDOFOSEST IE
        JOIN UPDATE_PEDIDO_KDS_TEMP UP ON IE.CDSETOR = UP.CDSETOR 
        JOIN SETOR SE ON (IE.CDSETOR = SE.CDSETOR)
        LEFT JOIN 
            (
            SELECT 
                ITE.CDFILIAL, IDTIPOSETOR,
                COUNT(ITE.CDSETOR) QTSETORES, 
                SUM(QTDIA) SUMQTCONCLUIDO,

				CASE SUM(QTDIA)
				   WHEN 0 THEN 0
				   ELSE
                	(SUM(MEDIADIA * QTDIA) / SUM(QTDIA))
				END AS MEDIAKDSDIA,
                SUM(QTHORAANT) SUMQTCONCLUIDOULTHR,

				CASE SUM(ISNULL(NULLIF(QTHORAANT, 0), DATEPART(HOUR, GETDATE())))
				   WHEN 0 THEN 0
				   ELSE (SUM(MEDIAHORAANT * QTHORAANT) / SUM(ISNULL(NULLIF(QTHORAANT, 0), DATEPART(HOUR, GETDATE()))))
				END AS MEDIAKDSULTHR,
                SUM(QTHORA) SUMQTCONCLUIDOHR,

				CASE SUM(QTHORA)
				   WHEN 0 THEN 0
				   ELSE
                	(SUM(MEDIAHORA * QTHORA) / SUM(QTHORA))
				END AS MEDIAKDSHR
            FROM 
                ITPEDIDOFOSEST ITE
                -- JOIN UPDATE_PEDIDO_KDS_TEMP UP ON ITE.CDSETOR = UP.CDSETOR
                JOIN 
                        SETOR SE 
                    ON 
                        ITE.CDSETOR = SE.CDSETOR
            GROUP BY 
                ITE.CDFILIAL, 
                IDTIPOSETOR ) STGER ON SE.IDTIPOSETOR = STGER.IDTIPOSETOR

                    WHERE (IE.CDFILIAL = :CDFILIAL OR :CDFILIAL = 'T')
                    AND (IE.CDSETOR = :CDSETOR OR :CDSETOR = 'T')
                    AND STGER.IDTIPOSETOR = SE.IDTIPOSETOR
                    --AND IE.DTULTATU > DATEADD(SECOND, -5, GETDATE())
	";

    const GET_STATISTICS_FROM_ONE_CLIENT = "
    SELECT 
        IE.CDFILIAL, 
        IE.CDSETOR, 
        SE.IDTIPOSETOR,
        ISNULL(IE.VRTMPMEDPROD,  0) AS TEMPOMEDIO, 
        ISNULL(IE.VRTMPMEDINI, 0) AS TEMPOINICIO,
        ISNULL(IE.VRTMPMEDATRA,  0) AS TEMPOATRASO, 
        ISNULL(IE.VRPORCCOMANATRA, 0) AS PORCENTAGEM, 
        ISNULL(IE.IDDIA,0) AS IDDIA, 
        ISNULL(IE.QTDIA,0) AS QTDIA, 
        ISNULL(IE.IDHORA,0) AS IDHORA, 
        ISNULL(IE.QTHORAANT, 0) AS QTHORAANT, 
        ISNULL(CAST(IE.MEDIADIA AS VARCHAR), 0) AS MEDIADIA, 
        ISNULL(IE.QTHORA,0) AS QTHORA,
        ISNULL(CAST(IE.MEDIAHORA AS VARCHAR),0) AS MEDIAHORA, 
        ISNULL(CAST(IE.MEDIAHORAANT AS VARCHAR),0) AS MEDIAHORAANT ,
        ISNULL(STGER.QTSETORES, 0) AS QTSETORES,
        ISNULL(STGER.SUMQTCONCLUIDO, 0) AS SUMQTCONCLUIDO,
        ISNULL(STGER.MEDIAKDSDIA, 0) AS MEDIAKDSDIA,
        ISNULL(STGER.SUMQTCONCLUIDOULTHR, 0) AS SUMQTCONCLUIDOULTHR,
        ISNULL(STGER.MEDIAKDSULTHR, 0) AS MEDIAKDSULTHR,
        ISNULL(STGER.SUMQTCONCLUIDOHR, 0) AS SUMQTCONCLUIDOHR,
        ISNULL(STGER.MEDIAKDSHR, 0) AS MEDIAKDSHR
    FROM 
        ITPEDIDOFOSEST IE
        --JOIN UPDATE_PEDIDO_KDS_TEMP UP ON IE.CDSETOR = UP.CDSETOR 
        JOIN SETOR SE ON (IE.CDSETOR = SE.CDSETOR)
        LEFT JOIN 
            (
            SELECT 
                ITE.CDFILIAL, IDTIPOSETOR,
                COUNT(ITE.CDSETOR) QTSETORES, 
                SUM(QTDIA) SUMQTCONCLUIDO,
				CASE SUM(QTDIA)
				   WHEN 0 THEN 0
                   ELSE
				   	(SUM(MEDIADIA * QTDIA) / SUM(QTDIA))
				END AS MEDIAKDSDIA,
                SUM(QTHORAANT) SUMQTCONCLUIDOULTHR,
				
				CASE SUM(ISNULL(NULLIF(QTHORAANT, 0), DATEPART(HOUR, GETDATE())))
				   WHEN 0 THEN 0
				   ELSE (SUM(MEDIAHORAANT * QTHORAANT) / SUM(ISNULL(NULLIF(QTHORAANT, 0), DATEPART(HOUR, GETDATE()))))
				END AS MEDIAKDSULTHR,
                SUM(QTHORA) SUMQTCONCLUIDOHR,
				
				CASE SUM(QTHORA)
				   WHEN 0 THEN 0
				   ELSE
                      (SUM(MEDIAHORA * QTHORA) / SUM(QTHORA))
				END AS MEDIAKDSHR
            FROM 
                ITPEDIDOFOSEST ITE
                -- JOIN UPDATE_PEDIDO_KDS_TEMP UP ON ITE.CDSETOR = UP.CDSETOR
                JOIN 
                        SETOR SE 
                    ON 
                        ITE.CDSETOR = SE.CDSETOR
            GROUP BY 
                ITE.CDFILIAL, 
                IDTIPOSETOR ) STGER ON SE.IDTIPOSETOR = STGER.IDTIPOSETOR

                    WHERE (IE.CDFILIAL = :CDFILIAL OR :CDFILIAL = 'T')
                    AND (IE.CDSETOR = :CDSETOR OR :CDSETOR = 'T')
                    AND STGER.IDTIPOSETOR = SE.IDTIPOSETOR
                    --AND IE.DTULTATU > DATEADD(SECOND, -5, GETDATE())
	";

    // Não é chamada em nenhum lugar
	const GET_STATISTICS_ALL = "
		SELECT 
			IE.CDFILIAL, 
			IE.CDSETOR, 
			IE.VRTMPMEDPROD AS TEMPOMEDIO, 
			IE.VRTMPMEDINI AS TEMPOINICIO,
			IE.VRTMPMEDATRA AS TEMPOATRASO,
			ISNULL(IE.VRPORCCOMANATRA, 0) AS PORCENTAGEM,
			IE.IDDIA,
			IE.QTDIA, 
			IE.IDHORA, 
			IE.QTHORA, 
			IE.QTHORAANT, 
			CAST(IE.MEDIADIA AS VARCHAR) AS MEDIADIA,
			CAST(IE.MEDIAHORA AS VARCHAR) AS MEDIAHORA, CAST(IE.MEDIAHORAANT AS VARCHAR) AS MEDIAHORAANT
		FROM 
			ITPEDIDOFOSEST IE/*,
			(  SELECT 
					CDFILIAL, IDTIPOSETOR,
					COUNT(ITE.CDSETOR) QTSETORES, 
					SUM(QTDIA) SUMQTCONCLUIDO,
					CASE SUM(QTDIA)
					   WHEN 0 THEN 0
					   ELSE (SUM(MEDIADIA) / SUM(QTDIA))
					END AS MEDIAKDSDIA,
					SUM(QTHORAANT) SUMQTCONCLUIDOULTHR, 

					CASE SUM(ISNULL(NULLIF(QTHORAANT, 0), DATEPART(HOUR, GETDATE())))
					   WHEN 0 THEN 0
					   ELSE 
					      (SUM(MEDIAHORAANT) / SUM(ISNULL(NULLIF(QTHORAANT, 0), DATEPART(HOUR, GETDATE()))))
					END AS MEDIAKDSULTHR,
					SUM(QTHORA) SUMQTCONCLUIDOHR,
					
					CASE SUM(QTHORA)
					   WHEN 0 THEN 0
					   ELSE
					      (SUM(MEDIAHORA) / SUM(QTHORA))
					END AS MEDIAKDSHR
				FROM 
					ITPEDIDOFOSEST ITE 
						JOIN 
							SETOR SE 
						ON 
							ITE.CDSETOR = SE.CDSETOR
				WHERE 
					CDFILIAL = :CDFILIAL
					AND SE.IDTIPOSETOR = :IDTIPOSETOR
				GROUP BY 
					CDFILIAL, 
					IDTIPOSETOR ) STGER */
		WHERE 
			(IE.CDFILIAL = :CDFILIAL OR :CDFILIAL = 'T')
			AND (IE.CDSETOR = :CDSETOR OR :CDSETOR = 'T')
	";

	const GET_STATISTICS_GERAL = "
	SELECT 
		CDFILIAL, IDTIPOSETOR,
		COUNT(ITE.CDSETOR) QTSETORES, 
		SUM(QTDIA) SUMQTCONCLUIDO,
		CASE SUM(QTDIA)
		   WHEN 0 THEN 0
		   ELSE
		      (SUM(MEDIADIA) / SUM(QTDIA))
		END AS MEDIAKDSDIA,
		SUM(QTHORAANT) SUMQTCONCLUIDOULTHR,
		
		CASE SUM(ISNULL(NULLIF(QTHORAANT, 0), DATEPART(HOUR, GETDATE())))
		   WHEN 0 THEN 0
		   ELSE
		      (SUM(MEDIAHORAANT) / SUM(ISNULL(NULLIF(QTHORAANT, 0), DATEPART(HOUR, GETDATE()))))
		END AS MEDIAKDSULTHR,
		SUM(QTHORA) SUMQTCONCLUIDOHR
		FROM 
		ITPEDIDOFOSEST ITE 
			JOIN 
				SETOR SE 
			ON 
				ITE.CDSETOR = SE.CDSETOR
	WHERE 
		CDFILIAL = :CDFILIAL
		AND SE.IDTIPOSETOR = :IDTIPOSETOR
	GROUP BY 
		CDFILIAL, 
		IDTIPOSETOR
	";

	const SQL_GET_ITEMS_BY_RELATIONS = "
		SELECT IR.CDFILIAL, IR.NRPEDIDOFOS, IR.NRITPEDIDOFOS, CAST(IR.QTPRODPEFOS AS FLOAT) AS QTPEDIDO,
			   CAST(IT.QTPRODPEFOS AS FLOAT) AS QTCAIXA, IT.DTHREXIBICAOPROD AS DTHREXIBATRASO,
			   ISNULL(IT.NRTEMPOPRODIT, 0) AS NRTEMPOPRODIT, SE.IDTIPOSETOR, IT.NRATRAPRODITPE,
			   -- PARAMS TO INSERT NEW RELATION
			   IR.NRVENDAREST, IR.NRCOMANDA, IR.NRPRODCOMVEN, IR.NRSEQITPEDREL, IR.IDSITITPEDFOS, GETDATE() AS NOW
		  FROM ITPEDIDOFOSREL IR JOIN ITPEDIDOFOS IT
								   ON IR.CDFILIAL = IT.CDFILIAL
								  AND IR.NRPEDIDOFOS = IT.NRPEDIDOFOS
								  AND IR.NRITPEDIDOFOS = IT.NRITPEDIDOFOS
								 JOIN SETOR SE
								   ON IT.CDSETOR = SE.CDSETOR
		 WHERE IR.CDFILIAL = ?
		   AND IR.NRVENDAREST = ?
		   AND IR.NRCOMANDA = ?
		   AND IR.NRPRODCOMVEN = ?
	";

	const SQL_SET_NEW_QUANTITY = "
		UPDATE ITPEDIDOFOS
		   SET QTPRODPEFOS = ?
		 WHERE CDFILIAL = ?
		   AND NRPEDIDOFOS = ?
		   AND NRITPEDIDOFOS = ?
	";

	const UPDATE_ITPEDIDOFOSPAI = "
		UPDATE ITPEDIDOFOSPAI
		   SET NRPEDIDOFOS = ?,
			   NRITPEDIDOFOS = ?,
			   NRSEQITPEDPAI = ?,
			   NRPEDIDOFOSPAI = ?
		 WHERE CDFILIAL = ?
		   AND NRPEDIDOFOS = ?
		   AND NRITPEDIDOFOS = ?
		   AND NRSEQITPEDPAI = ?
	";

	const GET_OLD_PARENTS_RELATIONS = "
		SELECT *
		  FROM ITPEDIDOFOSPAI
		 WHERE CDFILIAL = ?
		   AND NRPEDIDOFOS = ?
		   AND NRITPEDIDOFOS = ?
	";

	// const DELETE_OLD_ITPEDIDOFOSREL = "
	// 	DELETE
	// 	  FROM ITPEDIDOFOSREL
	// 	 WHERE CDFILIAL = ?
	// 	   AND NRPEDIDOFOS = ?
	// 	   AND NRITPEDIDOFOS = ?
	// 	   AND NRSEQITPEDREL = ?
	// ";

	const UPDATE_OLD_ITPEDIDOFOSREL = "
		UPDATE ITPEDIDOFOSREL
		   SET NRITPEDIDOFOS = ?,
			   NRSEQITPEDREL = ?
		 WHERE CDFILIAL = ?
		   AND NRPEDIDOFOS = ?
		   AND NRITPEDIDOFOS = ?
		   AND NRSEQITPEDREL = ?
	";

	const DELETE_OLD_PARENTS_RELATIONS = "
		DELETE
		  FROM ITPEDIDOFOSPAI
		 WHERE CDFILIAL = ?
		   AND NRPEDIDOFOS = ?
		   AND NRITPEDIDOFOS = ?
		   AND CDFILIALPAI = ?
		   AND NRPEDIDOFOSPAI = ?
		   AND NRITPEDIDOFOSPAI = ?
	";

	const SQL_UPDATE_PRODUCT_SHOWTIME = "
		UPDATE ITPEDIDOFOS
		   SET DTHREXIBICAOPROD = ?,
			   NRATRAPRODITPE = ?,
			   IDLIBERADO = 'S',
			   NRSEQLIBERADO = ?
		 WHERE CDFILIAL = ?
		   AND NRPEDIDOFOS = ?
		   AND NRITPEDIDOFOS = ?
	";

	const SQL_GET_ITEM_OBS = "
		SELECT TXPRODPED
		  FROM ITPEDIDOFOS
		 WHERE CDFILIAL = ?
		   AND NRPEDIDOFOS = ?
		   AND NRITPEDIDOFOS = ?
	";

	const SQL_UPDATE_PRODUCT_OBS = "
		UPDATE ITPEDIDOFOS
		   SET TXPRODPED = ?
		 WHERE CDFILIAL = ?
		   AND NRPEDIDOFOS = ?
		   AND NRITPEDIDOFOS = ?
	";

	const SQL_INSERT_NEW_BOX = "
		INSERT INTO ITPEDIDOFOS
		(CDFILIAL, NRPEDIDOFOS, NRITPEDIDOFOS, CDPRODUTO,
		QTPRODPEFOS, CDCAIXA, NRSEQVENDA, NRSEQUITVEND,
		NRVENDAREST, NRCOMANDA, NRPRODCOMVEN, NRORG,
		IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO,
		CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, TXPRODPED,
		IDSITITPEDFOS, DTCANCITPED, DTHRINIPRODUCAO, DTHRFINPRODUCAO,
		DSCHAVEPEDPAI, IDPRODUTOESPERA, DTHREXIBICAOPROD, CDSETOR,
		CDPRODUTOPAI, CDPRODPROMOKDS, NRSEQPRODCOMKDS, IDORIPED,
		NRTEMPOPRODIT, NRTEMPOEXIBIT, IDLIBERADO, NRATRAPRODITPE,
		NRLUGARMESAIT, NRSEQLIBERADO)
		SELECT CDFILIAL, NRPEDIDOFOS, ?, CDPRODUTO,
			   CAST(? AS DECIMAL), CDCAIXA, NRSEQVENDA, NRSEQUITVEND,
			   NRVENDAREST, NRCOMANDA, NRPRODCOMVEN, NRORG,
			   IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO,
			   CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, TXPRODPED,
			   IDSITITPEDFOS, DTCANCITPED, DTHRINIPRODUCAO, DTHRFINPRODUCAO,
			   DSCHAVEPEDPAI, IDPRODUTOESPERA, DTHREXIBICAOPROD, CDSETOR,
			   CDPRODUTOPAI, CDPRODPROMOKDS, NRSEQPRODCOMKDS, IDORIPED,
			   NRTEMPOPRODIT, NRTEMPOEXIBIT, IDLIBERADO, NRATRAPRODITPE,
			   NRLUGARMESAIT, NRSEQLIBERADO
		  FROM ITPEDIDOFOS
		 WHERE CDFILIAL = ?
		   AND NRPEDIDOFOS = ?
		   AND NRITPEDIDOFOS = ?
	";

	const CANCEL_ITEM_KDS = "
    	UPDATE ITPEDIDOFOSREL
           SET IDSITITPEDFOS = 'C'
         WHERE CDFILIAL = :CDFILIAL
           AND NRVENDAREST = :NRVENDAREST
           AND NRCOMANDA = :NRCOMANDA
           AND NRPRODCOMVEN = :NRPRODCOMVEN
    ";

	const CANCEL_QUANT_KDS = "
		UPDATE ITPEDIDOFOSREL
	   	   SET QTPRODPEFOS = :QTPRODPEFOS
		 WHERE CDFILIAL = :CDFILIAL
   		   AND NRVENDAREST = :NRVENDAREST
		   AND NRCOMANDA = :NRCOMANDA
		   AND NRPRODCOMVEN = :NRPRODCOMVEN
	";

	const INSERT_PASSWORD_DISPLAY_NOTIFICATION = "
			INSERT INTO SENHAPED
			(CDFILIAL, CDCAIXA, NRSEQVENDA, CDSENHAPED,
			IDSTATUS, DTNOTIFICACAO)
			VALUES (:CDFILIAL, :CDCAIXA, :NRSEQVENDA, :CDSENHAPED,
			'A', GETDATE())
	";

    const INSERT_PASSWORD_DISPLAY_NOTIFICATION_EMPLOYEE = "
			INSERT INTO SENHAPED
			(CDFILIAL, CDCAIXA, NRSEQVENDA, CDSENHAPED,
			IDSTATUS, DTNOTIFICACAO)
			VALUES (:CDFILIAL, '000', :NRSEQVENDA, :CDSENHAPED,
			'A', GETDATE())
	";

	const VERIFY_NOTIFICATION_EXISTS = "
			SELECT COUNT(NRSEQVENDA) AS COUNT FROM SENHAPED
			WHERE CDFILIAL = :CDFILIAL
			AND CDCAIXA = :CDCAIXA
			AND NRSEQVENDA = :NRSEQVENDA
			AND CDSENHAPED = :CDSENHAPED
	";

	const VERIFICA_DISPLAY_NOTIFICATION = "
			SELECT IDUTLINTPAINEL, IDHABWSPAGER
				FROM SETORFILIAL
			WHERE CDFILIAL = :CDFILIAL
				AND CDSETOR = :CDSETOR
	";

	const GET_VENDA_KEY = "
		SELECT A.NRPEDIDOFOS, A.NRSEQVENDA, A.CDFILIAL, A.CDCAIXA, A.NMCONSUMIDOR, A.CDLOJA
		  FROM (SELECT IC.NRPEDIDOFOS, IC.NRVENDAREST + IC.NRCOMANDA + IC.NRPRODCOMVEN AS NRSEQVENDA, IC.CDFILIAL,
		   (SELECT MIN(CDCAIXA) FROM CAIXA ) AS CDCAIXA, PE.NMCONSUMIDOR, IC.CDLOJA
		  		  FROM ITCOMANDAVEN IC  JOIN PEDIDOFOS PE
										 ON IC.NRPEDIDOFOS = PE.NRPEDIDOFOS
							           JOIN COMANDAVEN CM
							             ON CM.CDFILIAL    = IC.CDFILIAL
							            AND CM.NRCOMANDA   = IC.NRCOMANDA
						                AND CM.NRVENDAREST = IC.NRVENDAREST
			     WHERE IC.CDFILIAL    = :CDFILIAL
			       AND IC.NRVENDAREST = :NRVENDAREST
			       AND IC.NRCOMANDA   = :NRCOMANDA
			       AND IC.NRPEDIDOFOS = :NRPEDIDOFOS
		UNION
		SELECT IV.NRPEDIDOFOS, IV.NRSEQVENDA, IV.CDFILIAL, IV.CDCAIXA, PE.NMCONSUMIDOR, IV.CDLOJA
		  FROM ITEMVENDA IV  JOIN PEDIDOFOS PE
							  ON IV.NRPEDIDOFOS = PE.NRPEDIDOFOS
							JOIN VENDA VN
							  ON VN.CDFILIAL    = IV.CDFILIAL
							 AND VN.CDCAIXA     = IV.CDCAIXA
							 AND VN.NRSEQVENDA  = IV.NRSEQVENDA
		 WHERE IV.CDCAIXA    = :CDCAIXA
           AND IV.NRSEQVENDA = :NRSEQVENDA
           AND IV.CDFILIAL   = :CDFILIAL
		) A
	";


	const GET_KDS_MESSAGES = "
		SELECT SF.CDFILIAL, SE.CDSETOR, KM.CDMENSAGEM, KM.DSMENSAGEM,
		       KM.NRHORA, KM.NRREPTINTERV, KM.NRQTDREPTINTERV, KM.IDREPETEDIAS, MD.NRDIA,
		       KM.CDARQUIVOSOMMSG AS CDARQUIVO, AQ.NMARQUIVO, KM.IDREPETINDEF
		  FROM SETOR SE JOIN CAIXA CX
					      ON SE.CDSETOR = CX.CDSETOR
					    JOIN SETORFILIAL SF
					      ON SF.CDSETOR = SE.CDSETOR
					    JOIN SETORFILIALMSG SM
					      ON SM.CDFILIAL = SF.CDFILIAL
					     AND SM.CDSETOR  = SF.CDSETOR
					    JOIN KDSMENSAGEM KM
					      ON SM.CDMENSAGEM = KM.CDMENSAGEM
				   LEFT JOIN KDSMSGDIAS MD
					      ON MD.CDMENSAGEM = SM.CDMENSAGEM
				   LEFT JOIN ARQUIVOS AQ
				   		  ON KM.CDARQUIVOSOMMSG = AQ.CDARQUIVO
		 WHERE CX.IDHABCAIXAVENDA = 'CTL'
		   AND KM.IDMSGATIVA = 'S'
		   AND (NRDIA = :NRDIA OR NRDIA IS NULL)
		   AND NRHORA <= :NRHORA
		   AND NRHORA > :NRHORAANTERIOR
		   AND (SM.CDSETOR = :CDSETOR OR :CDSETOR IS NULL)
	";

	const GET_ARQUIVO = "
		SELECT CDARQUIVO, NMARQUIVO, ARQUIVO
		  FROM ARQUIVOS
		 WHERE CDARQUIVO = :CDARQUIVO
	";

	const UPDATE_KDS_MESSAGE = "
		UPDATE KDSMENSAGEM
		   SET IDMSGATIVA     = 'N'
		 WHERE CDMENSAGEM     = :CDMENSAGEM
	";

	const UPDATE_STATUS_SENHAPED = "
		UPDATE SENHAPED
		   SET IDSTATUS = :IDSTATUS, DTNOTIFICACAO = GETDATE()
		 WHERE CDSENHAPED = :CDSENHAPED
			 AND CDFILIAL = :CDFILIAL
			 AND NRSEQVENDA = :NRSEQVENDA
			 AND CDCAIXA = :CDCAIXA
	";

	const VERIFY_REMOVED_EXISTS = "
		SELECT COUNT(NRSEQVENDA) AS COUNT FROM SENHAPED
		WHERE CDFILIAL = :CDFILIAL
		AND CDCAIXA = :CDCAIXA
		AND NRSEQVENDA = :NRSEQVENDA
		AND CDSENHAPED = :CDSENHAPED
		AND IDSTATUS <> 'C'
	";

    const SQL_UPDATE_ITPEDIDOFOSREL = "
        UPDATE ITPEDIDOFOSREL
           SET NRVENDAREST = ?,
               NRCOMANDA = ?,
               NRPRODCOMVEN = ?
         WHERE CDFILIAL = ?
           AND NRVENDAREST = ?
           AND NRCOMANDA = ?
           AND NRPRODCOMVEN = ?
    ";

    const SQL_UPDATE_PEDIDOFOS = "
        UPDATE PEDIDOFOS
           SET NRMESA = ?,
               NRMESAOLD = ?
         WHERE CDFILIAL = ?
           AND NRPEDIDOFOS = ?
    ";

    const SQL_GET_NRPEDIDOFOS = "
        SELECT CDFILIAL, NRPEDIDOFOS
          FROM ITPEDIDOFOSREL
         WHERE CDFILIAL = ?
           AND NRVENDAREST = ?
           AND NRCOMANDA = ?
           AND NRPRODCOMVEN = ?
    ";

    const GET_ITPEDIDOFOS_BY_ITPEDIDOFOSREL = "
        SELECT R.CDFILIAL, R.NRPEDIDOFOS, R.NRITPEDIDOFOS, R.NRSEQITPEDREL,
               R.QTPRODPEFOS AS QTREL, I.QTPRODPEFOS AS QTPED, I.CDSETOR
          FROM ITPEDIDOFOSREL R JOIN ITPEDIDOFOS I
                                  ON R.CDFILIAL = I.CDFILIAL
                                 AND R.NRPEDIDOFOS = I.NRPEDIDOFOS
                                 AND R.NRITPEDIDOFOS = I.NRITPEDIDOFOS
         WHERE R.CDFILIAL = ?
           AND R.NRVENDAREST = ?
           AND R.NRCOMANDA = ?
           AND R.NRPRODCOMVEN = ?
    ";

    const SQL_UPD_POS_KDS = "
        UPDATE ITPEDIDOFOS
           SET NRLUGARMESAIT = ?
         WHERE CDFILIAL = ?
           AND NRPEDIDOFOS = ?
           AND NRITPEDIDOFOS = ?
    ";

    const GET_TRIGGER_AI_ITCOMANDAVEN_INS_PED_KDS_TMP = "
		SELECT NAME, object_name(parent_obj) TABLENAME
			FROM SYS.SYSOBJECTS
		WHERE XTYPE = 'TR'
		AND NAME = 'TGR_AI_ITCOMANDAVEN_INS_PED_KDS_TMP'
	";

	const GET_TRIGGER_AI_VENDA_INS_PED_KDS_TMP = "
		SELECT NAME, object_name(parent_obj) TABLENAME
			FROM SYS.SYSOBJECTS
		WHERE XTYPE = 'TR'
		AND NAME = 'TGR_AI_VENDA_INS_PED_KDS_TMP'
	";

	const GET_PEDIDO_KDS_TEMP = "
		select * from sysobjects where name = 'PEDIDO_KDS_TEMP' AND XTYPE = 'U'
	";

	const CREATE_PEDIDO_KDS_TEMP = "
		CREATE TABLE PEDIDO_KDS_TEMP
		(
			COD_PEDIDO_KDS_TEMP INT IDENTITY(1,1) PRIMARY KEY,
			CDFILIAL VARCHAR(4) NOT NULL,
			CDCAIXA VARCHAR(3),
			NRSEQVENDA VARCHAR(50),
			NRVENDAREST VARCHAR(50),
			NRCOMANDA VARCHAR(50),
			TP_PEDIDO VARCHAR(3),
			STATUS VARCHAR(1) not null DEFAULT 'E'
		)
		CREATE INDEX IDX_PEDIDO_KDS_TEMP ON PEDIDO_KDS_TEMP
   (CDFILIAL, NRVENDAREST, NRCOMANDA, TP_PEDIDO, STATUS)
	";

    const TGR_AI_ITCOMANDAVEN_INS_PED_KDS_TMP = "
		CREATE TRIGGER TGR_AI_ITCOMANDAVEN_INS_PED_KDS_TMP
		   ON  ITCOMANDAVEN
		   AFTER INSERT
		AS
		BEGIN
			SET NOCOUNT ON;

			DECLARE
			@CM_CDFILIAL VARCHAR(4),
			@CM_NRVENDAREST VARCHAR(50),
			@CM_NRCOMANDA VARCHAR(50)

			SELECT
				@CM_CDFILIAL = CDFILIAL,
				@CM_NRVENDAREST = NRVENDAREST,
				@CM_NRCOMANDA = NRCOMANDA
			FROM INSERTED

         INSERT INTO PEDIDO_KDS_TEMP(CDFILIAL, NRVENDAREST, NRCOMANDA, TP_PEDIDO, STATUS)
         SELECT @CM_CDFILIAL, @CM_NRVENDAREST, @CM_NRCOMANDA, 'COM', 'E'
          WHERE NOT EXISTS (SELECT 1
                              FROM PEDIDO_KDS_TEMP
                             WHERE CDFILIAL = @CM_CDFILIAL
                               AND NRVENDAREST = @CM_NRVENDAREST
                               AND NRCOMANDA = @CM_NRCOMANDA
                               AND TP_PEDIDO = 'COM'
                               AND STATUS = 'E');
         END;

    ";

    const TGR_AI_VENDA_INS_PED_KDS_TMP = "
			CREATE TRIGGER TGR_AI_VENDA_INS_PED_KDS_TMP
			   ON  TEKNISA.VENDA
			   AFTER INSERT
			AS
			BEGIN
				SET NOCOUNT ON;
				DECLARE
				@VN_CDFILIAL VARCHAR(4),
				@VN_CDCAIXA VARCHAR(3),
				@VN_NRSEQVENDA VARCHAR(50),
				@VN_NRCOMANDAVND VARCHAR(50)

				SELECT
					@VN_CDFILIAL = CDFILIAL,
					@VN_CDCAIXA = CDCAIXA,
					@VN_NRSEQVENDA = NRSEQVENDA,
					@VN_NRCOMANDAVND = NRCOMANDAVND
				FROM INSERTED

				IF (@VN_NRCOMANDAVND IS NULL)
					INSERT INTO PEDIDO_KDS_TEMP(CDFILIAL, CDCAIXA, NRSEQVENDA, TP_PEDIDO, STATUS)
					VALUES (@VN_CDFILIAL, @VN_CDCAIXA, @VN_NRSEQVENDA, 'VEN', 'E');
				ELSE IF (@VN_NRCOMANDAVND IS NOT NULL)
					INSERT INTO PEDIDO_KDS_TEMP(CDFILIAL, CDCAIXA, NRCOMANDA, TP_PEDIDO, STATUS)
					VALUES (@VN_CDFILIAL, @VN_CDCAIXA, @VN_NRCOMANDAVND, 'COM', 'E');
		END
    ";

	const UPDATE_STATUS_UPDATE_PEDIDO_KDS_TEMP = "
		UPDATE UPDATE_PEDIDO_KDS_TEMP
	       SET STATUS = 'P'
	       WHERE DTHREXIBIT <= GETDATE()
	";
	const DELETE_TREATED_UPDATE_PEDIDO_KDS_TEMP = "
		DELETE UPDATE_PEDIDO_KDS_TEMP
	     WHERE STATUS = 'P'
	";

// UPDATE_PEDIDO_FOS_KDS_TEMP

	const CREATE_UPDATE_PEDIDO_KDS_TEMP = "
		CREATE TABLE UPDATE_PEDIDO_KDS_TEMP
		(
			COD_UPDATE_PEDIDO_KDS_TEMP INT IDENTITY(1,1) PRIMARY KEY,
			CDFILIAL VARCHAR(4) NOT NULL,
			TABELA VARCHAR(50),
			NRPEDIDOFOS VARCHAR(50),
			NRITPEDIDOFOS VARCHAR(50),
			NRSEQITPEDREL VARCHAR(50),
			CDSETOR VARCHAR(4),
			DTHREXIBIT DATETIME DEFAULT GETDATE(),
			STATUS VARCHAR(1) not null DEFAULT 'E'
		)
	";

	const GET_UPDATE_PEDIDO_KDS_TEMP = "
		select * from sysobjects where name = 'UPDATE_PEDIDO_KDS_TEMP' AND XTYPE = 'U'
	";

	const DELETE_UPDATE_PEDIDO_KDS_TEMP_BY_ID = "
		DELETE FROM UPDATE_PEDIDO_KDS_TEMP WHERE COD_UPDATE_PEDIDO_KDS_TEMP = :COD_UPDATE_PEDIDO_KDS_TEMP
	";

	const UPDATE_STATUS_UPDATE_PEDIDO_KDS_TEMP_BY_ID = "
		UPDATE UPDATE_PEDIDO_KDS_TEMP SET STATUS = 'P' WHERE COD_UPDATE_PEDIDO_KDS_TEMP = :COD_UPDATE_PEDIDO_KDS_TEMP
	";

	const SELECT_UPDATE_PEDIDO_KDS_TEMP = "
		SELECT * FROM UPDATE_PEDIDO_KDS_TEMP WHERE STATUS = 'E' AND DTHREXIBIT <= GETDATE()
	";

	//TRIGGER TGR_FIU_PEDIDOFOS_INS_UPD_PED_KDS_TMP

    const TGR_FIU_PEDIDOFOS_INS_UPD_PED_KDS_TMP = "
		CREATE TRIGGER TGR_FIU_PEDIDOFOS_INS_UPD_PED_KDS_TMP
		   ON  PEDIDOFOS
		   FOR INSERT, UPDATE
		AS
		BEGIN
			SET NOCOUNT ON;

			DECLARE
			@PF_CDFILIAL VARCHAR(4),
			@PF_NRPEDIDOFOS VARCHAR(50)

			SELECT
				@PF_CDFILIAL = CDFILIAL,
				@PF_NRPEDIDOFOS = NRPEDIDOFOS

			FROM INSERTED

			IF ( @PF_CDFILIAL IS NOT NULL AND @PF_NRPEDIDOFOS IS NOT NULL)
				IF NOT EXISTS
					(	SELECT * FROM UPDATE_PEDIDO_KDS_TEMP
						WHERE CDFILIAL = @PF_CDFILIAL
						AND NRPEDIDOFOS = @PF_NRPEDIDOFOS
					)
					INSERT INTO UPDATE_PEDIDO_KDS_TEMP(TABELA, CDFILIAL, NRPEDIDOFOS, STATUS)
					VALUES ('PEDIDOFOS', @PF_CDFILIAL, @PF_NRPEDIDOFOS, 'E')
		END
    ";

	const GET_TRIGGER_FIU_PEDIDOFOS_INS_UPD_PED_KDS_TMP = "
		SELECT NAME, object_name(parent_obj) TABLENAME
			FROM SYS.SYSOBJECTS
		WHERE XTYPE = 'TR'
		AND NAME = 'TGR_FIU_PEDIDOFOS_INS_UPD_PED_KDS_TMP'
	";

	//TRIGGER TGR_FIU_ITPEDIDOFOS_INS_UPD_PED_KDS_TMP

    const TGR_FIU_ITPEDIDOFOS_INS_UPD_PED_KDS_TMP = "
     CREATE TRIGGER TGR_FIU_ITPEDIDOFOS_INS_UPD_PED_KDS_TMP
           ON  ITPEDIDOFOS
           FOR INSERT, UPDATE
        AS
        BEGIN
            INSERT INTO UPDATE_PEDIDO_KDS_TEMP(TABELA, CDFILIAL, NRPEDIDOFOS, NRITPEDIDOFOS, STATUS)
            SELECT 'ITPEDIDOFOS',
                   I.CDFILIAL,
                   I.NRPEDIDOFOS,
                   I.NRITPEDIDOFOS,
                   'E'
            FROM INSERTED I LEFT JOIN UPDATE_PEDIDO_KDS_TEMP U ON U.CDFILIAL       = I.CDFILIAL
											                  AND U.NRPEDIDOFOS    = I.NRPEDIDOFOS
											                  AND U.NRITPEDIDOFOS  = I.NRITPEDIDOFOS
											                  AND U.DTHREXIBIT <= GETDATE()
		   WHERE U.COD_UPDATE_PEDIDO_KDS_TEMP IS NULL
-------------------------------------------------------------------------------------------------------------------------
                                     --Pedidos em espera--
			INSERT INTO UPDATE_PEDIDO_KDS_TEMP(TABELA, CDFILIAL, NRPEDIDOFOS, NRITPEDIDOFOS, DTHREXIBIT, STATUS)
			SELECT 'ITPEDIDOFOS',
               I.CDFILIAL,
               I.NRPEDIDOFOS,
               I.NRITPEDIDOFOS,
               I.DTHREXIBICAOPROD,
               'E'
            FROM INSERTED I LEFT JOIN UPDATE_PEDIDO_KDS_TEMP U ON U.CDFILIAL       = I.CDFILIAL
										                  AND U.NRPEDIDOFOS    = I.NRPEDIDOFOS
										                  AND U.NRITPEDIDOFOS  = I.NRITPEDIDOFOS
	        WHERE U.COD_UPDATE_PEDIDO_KDS_TEMP IS NULL
	          AND I.NRATRAPRODITPE IS NOT NULL
              AND U.DTHREXIBIT > I.DTHREXIBICAOPROD
              AND GETDATE() < I.DTHREXIBICAOPROD
		END
    ";

	const GET_TRIGGER_FIU_ITPEDIDOFOS_INS_UPD_PED_KDS_TMP = "
		SELECT NAME, object_name(parent_obj) TABLENAME
			FROM SYS.SYSOBJECTS
		WHERE XTYPE = 'TR'
		AND NAME = 'TGR_FIU_ITPEDIDOFOS_INS_UPD_PED_KDS_TMP'
	";

	//TRIGGER TGR_FIU_ITPEDIDOFOSREL_INS_UPD_PED_KDS_TMP

    const TGR_FIU_ITPEDIDOFOSREL_INS_UPD_PED_KDS_TMP = "
       CREATE TRIGGER TGR_FIU_ITPEDIDOFOSREL_INS_UPD_PED_KDS_TMP
           ON  ITPEDIDOFOSREL
           FOR INSERT, UPDATE
        AS
        BEGIN
            IF NOT EXISTS
                (   SELECT * FROM UPDATE_PEDIDO_KDS_TEMP U JOIN INSERTED I ON U.CDFILIAL      = I.CDFILIAL
                    AND U.NRPEDIDOFOS    = I.NRPEDIDOFOS
                    AND U.NRITPEDIDOFOS   = I.NRITPEDIDOFOS
                    AND U.NRSEQITPEDREL  = I.NRSEQITPEDREL
                )
                INSERT INTO UPDATE_PEDIDO_KDS_TEMP(TABELA, CDFILIAL, NRPEDIDOFOS, NRITPEDIDOFOS, NRSEQITPEDREL, STATUS)
                SELECT 'ITPEDIDOFOSREL',
                       I.CDFILIAL,
                       I.NRPEDIDOFOS,
                       I.NRITPEDIDOFOS,
                       I.NRSEQITPEDREL,
                       'E'
                FROM INSERTED I LEFT JOIN UPDATE_PEDIDO_KDS_TEMP U ON U.CDFILIAL       = I.CDFILIAL
												                  AND U.NRPEDIDOFOS    = I.NRPEDIDOFOS
												                  AND U.NRITPEDIDOFOS  = I.NRITPEDIDOFOS
												                  AND U.NRSEQITPEDREL  = I.NRSEQITPEDREL
												                  AND U.DTHREXIBIT <= GETDATE()
			   WHERE U.COD_UPDATE_PEDIDO_KDS_TEMP IS NULL
		END
    ";

	const GET_TRIGGER_FIU_ITPEDIDOFOSREL_INS_UPD_PED_KDS_TMP = "
		SELECT NAME, object_name(parent_obj) TABLENAME
			FROM SYS.SYSOBJECTS
		WHERE XTYPE = 'TR'
		AND NAME = 'TGR_FIU_ITPEDIDOFOSREL_INS_UPD_PED_KDS_TMP'
	";

	//TRIGGER TGR_FIU_ITPEDIDOFOSEST_INS_UPD_PED_KDS_TMP

    const TGR_FIU_ITPEDIDOFOSEST_INS_UPD_PED_KDS_TMP = "
		CREATE TRIGGER TGR_FIU_ITPEDIDOFOSEST_INS_UPD_PED_KDS_TMP
		   ON  ITPEDIDOFOSEST
		   FOR INSERT, UPDATE
		AS
		BEGIN
			SET NOCOUNT ON;

			DECLARE
			@IPFE_CDFILIAL VARCHAR(4),
			@IPFE_CDSETOR VARCHAR(50)

			SELECT
				@IPFE_CDFILIAL = CDFILIAL,
				@IPFE_CDSETOR = CDSETOR

			FROM INSERTED
			IF ( @IPFE_CDFILIAL IS NOT NULL AND @IPFE_CDSETOR IS NOT NULL)
				IF NOT EXISTS
					(	SELECT * FROM UPDATE_PEDIDO_KDS_TEMP
						WHERE CDFILIAL = @IPFE_CDFILIAL
						AND CDSETOR = @IPFE_CDSETOR
					)
					INSERT INTO UPDATE_PEDIDO_KDS_TEMP(TABELA, CDFILIAL, CDSETOR, STATUS)
					VALUES ('ITPEDIDOFOSEST', @IPFE_CDFILIAL, @IPFE_CDSETOR, 'E')
		END
    ";

	const GET_TRIGGER_FIU_ITPEDIDOFOSEST_INS_UPD_PED_KDS_TMP = "
		SELECT NAME, object_name(parent_obj) TABLENAME
			FROM SYS.SYSOBJECTS
		WHERE XTYPE = 'TR'
		AND NAME = 'TGR_FIU_ITPEDIDOFOSEST_INS_UPD_PED_KDS_TMP'
	";

	const UPDATE_ITPEDIDOFOS_TO_SHOW_ON_FRONT = "
		UPDATE ITPEDIDOFOS
		   SET DTULTATU = GETDATE()
         WHERE DTHREXIBICAOPROD IS NOT NULL
           AND GETDATE() >= CONVERT(DATETIME, DTHREXIBICAOPROD, 121)
           AND (CONVERT(DATETIME, :OLDDATE,121) <= CONVERT(DATETIME, DTHREXIBICAOPROD, 121) OR :OLDDATE IS NULL)
	";

    // unico update que seta DTHRPRIEXPED é esse
	const UPDATE_ORDER_DTHRPRIEXPED = "
		UPDATE ITPEDIDOFOS
		   SET DTHRPRIEXPED = GETDATE()
         WHERE DTHRPRIEXPED IS NULL
           AND CDFILIAL = :CDFILIAL
		   AND NRPEDIDOFOS = :NRPEDIDOFOS
		   AND 'E' = (SELECT IDTIPOSETOR FROM SETOR WHERE ITPEDIDOFOS.CDSETOR = SETOR.CDSETOR)
	";

	const GET_ANY_CDCAIXA_BY_NRCOMANDA = "
		SELECT TOP 1 CDCAIXA FROM CAIXA WHERE CDLOJA IN (SELECT CDLOJA FROM COMANDAVEN WHERE NRCOMANDA = :NRCOMANDA)
	";

	const GET_ANY_CDCAIXA_BY_NRCOMANDAVND = "
		SELECT CDCAIXA FROM VENDA WHERE NRCOMANDAVND = :NRCOMANDAVND
	";

    const GET_DTULTATU_ITPEDIDOFOS_BY_NRPEDIDOFOS = "
        SELECT CDFILIAL, NRPEDIDOFOS, NRITPEDIDOFOS
        FROM ITPEDIDOFOS
        WHERE CDFILIAL = :CDFILIAL
        AND NRPEDIDOFOS = :NRPEDIDOFOS
    ";

	const UPDATE_DTULTATU_ITPEDIDOFOS_BY_NRPEDIDOFOS = "
			UPDATE ITPEDIDOFOS
				SET DTULTATU = GETDATE()
					WHERE CDFILIAL = :CDFILIAL
					  AND NRPEDIDOFOS = :NRPEDIDOFOS
                      AND NRITPEDIDOFOS = :NRITPEDIDOFOS
	";

	const GET_FIELD_NRTEMPOATRASOEXP = "
		SELECT NAME, c.name
		  FROM SYS.SYSCOLUMNS c
		 WHERE NAME = 'NRTEMPOATRASOEXP'
	";

	const ALTERS_VERSION_350 = "
		ALTER TABLE ITPEDIDOFOS ADD DTHRPRIEXPED DATETIME
		ALTER TABLE SETORFILIAL ADD NRTEMPOATRASOEXP FLOAT 
		ALTER TABLE SETORFILIAL ADD CDARQUIVOBEEPEXP VARCHAR(20) 
		ALTER TABLE SETORFILIAL ADD NRMULTIPULO INTEGER DEFAULT 1
	";

	const UPDATE_DTULTATU_ITPEDIDOFOS_BY_NRCOMANDA = "
			UPDATE ITPEDIDOFOS SET DTULTATU = GETDATE() WHERE NRCOMANDA = :NRCOMANDA
	";

	const CHECK_NRPEDIDOFOS_NRSEQVENDA_BY_NRCOMANDA = "
		SELECT VE.NRSEQVENDA, MCD.NRSEQMOVDLV, PF.NRPEDIDOFOS, PF.CDLOJA FROM PEDIDOFOS PF
		LEFT JOIN VENDA VE ON (PF.CDFILIAL = VE.CDFILIAL AND PF.CDLOJA = VE.CDLOJA AND VE.NRCOMANDAVND = PF.NRCOMANDA)
		LEFT JOIN COMANDAVEN CV ON (PF.NRCOMANDA = CV.NRCOMANDA AND PF.CDFILIAL = CV.CDFILIAL)
		LEFT JOIN MOVCAIXADLV MCD ON (MCD.NRVENDAREST = CV.NRVENDAREST AND MCD.CDFILIAL = CV.CDFILIAL AND MCD.NRSEQMOVDLV = '0000000001')
		WHERE PF.NRCOMANDA = :NRCOMANDA
	";

	const GET_IDCONDPEDPAG_BY_LOJA = "
		SELECT IDCONDPEDPAG FROM LOJA 
		WHERE CDLOJA = :CDLOJA
	";

	const UPDATE_DTHREXIBICAOPROD_BY_NRPEDIDOFOS = "
		UPDATE ITPEDIDOFOS 
		SET DTHREXIBICAOPROD = GETDATE()
		WHERE NRPEDIDOFOS = :NRPEDIDOFOS
	";

	const GET_CDSETOR_PRIORM_BY_NRPEDIDOFOS = "
		SELECT DISTINCT TOP 1 IT.CDSETOR, SF.IDPRIORM
		FROM 
			ITPEDIDOFOS IT 
			JOIN SETOR SE ON (SE.CDSETOR = IT.CDSETOR)
			JOIN SETORFILIAL SF ON (SF.CDSETOR = IT.CDSETOR)
		WHERE SE.IDTIPOSETOR = 'M'
			AND IT.IDSITITPEDFOS <> 'X'
			AND IT.NRPEDIDOFOS = :NRPEDIDOFOS
			ORDER BY SF.IDPRIORM ASC
	";

	const SQL_INSERT_STATISTICS_ON_PLAY = "
		INSERT INTO ITPEDIDOFOSEST
		(CDFILIAL, CDSETOR, VRTMPMEDINI, QTINICIADO)
		VALUES
		(:CDFILIAL, :CDSETOR, :TIMETOSTART, :QTPRODPEFOS)
	";

    // essa é a query que retornava null onde nao deveria (no TIMETOPRODUCE)
	const SQL_GET_ITEM_DATA = "
        SELECT CDSETOR, DATEDIFF(SECOND, DTHREXIBICAOPROD, DTHRINIPRODUCAO) AS TIMETOSTART,
            DATEDIFF(SECOND, DTHREXIBICAOPROD, ISNULL(ISNULL(DTHRPRIEXPED, DTHRFINPRODUCAO), GETDATE())) AS TIMETOPRODUCE, 
            NRTEMPOPRODIT,
            ISNULL(QTPRODPEFOS, 1) AS QTPRODPEFOS,
            DTHREXIBICAOPROD, DTHRPRIEXPED, DTHRFINPRODUCAO,  CDFILIAL, CDPRODUTO, NRVENDAREST, NRCOMANDA, NRPEDIDOFOS, NRITPEDIDOFOS
        FROM ITPEDIDOFOS
        WHERE CDFILIAL = :CDFILIAL
            AND NRPEDIDOFOS = :NRPEDIDOFOS
            AND NRITPEDIDOFOS = :NRITPEDIDOFOS
	";

	const SQL_UPDATE_STATISTICS_PLAY = "
		UPDATE ITPEDIDOFOSEST
		   SET VRTMPMEDINI = ((ISNULL(VRTMPMEDINI, 0) * ISNULL(QTINICIADO, 0)) + (:TIMETOSTART * :QTPRODPEFOS)) / CASE (ISNULL(QTINICIADO, 0) + :QTPRODPEFOS) WHEN 0 THEN 1 ELSE ISNULL(QTINICIADO, 0) + :QTPRODPEFOS END,
		       QTINICIADO = ISNULL(QTINICIADO, 0) + :QTPRODPEFOS, DTULTATU = GETDATE()
		 WHERE CDFILIAL = :CDFILIAL
		   AND CDSETOR = :CDSETOR
	";

	const SQL_GET_STATISTICS_EXISTS = "
	SELECT CDFILIAL, CDSETOR, IDDIA, IDHORA, QTDIA, QTHORA, QTHORAANT, MEDIADIA,
		MEDIAHORA, MEDIAHORAANT
		  FROM ITPEDIDOFOSEST
		 WHERE CDFILIAL = :CDFILIAL
		   AND CDSETOR = :CDSETOR
	";

    // Inclusao de dados no front, 3 semanas atrás
	const SQL_UPDATE_NEW_STATISTICS = "
	UPDATE ITPEDIDOFOSEST SET 
		IDDIA = :IDDIA, 
		IDHORA = :IDHORA, 
		MEDIADIA = :MEDIADIA, 
		MEDIAHORA = :MEDIAHORA, 
		MEDIAHORAANT = :MEDIAHORAANT, 
		QTDIA = :QTDIA, 
		QTHORA = :QTHORA,
		QTHORAANT = :QTHORAANT, 
        DTULTATU = GETDATE()
	WHERE CDFILIAL = :CDFILIAL AND CDSETOR = :CDSETOR
	";
	
            // Esta query não é executada porque a chamada está comentada

    const SQL_UDATE_STATISTICS_AVG = "
        UPDATE ITPEDIDOFOSEST SET 
            MEDIADIA = (
                SELECT 
                    (DATEDIFF(SECOND, DTHREXIBICAOPROD, ISNULL(DTHRFINPRODUCAO, GETDATE())) + ( :MEDIADIA * (:QTDIA - 1))/:QTDIA)  AS TEMPOPRODUCAO
                FROM 
                    ITPEDIDOFOS 
                WHERE 
                    CDSETOR = :CDSETOR 
                    AND CDFILIAL = :CDFILIAL
                    AND NRPEDIDOFOS = :NRPEDIDOFOS
            ),		 
            MEDIAHORA = (
                SELECT 
                    (:MEDIAHORA * (:QTHORA-1)) + (DATEDIFF(SECOND, DTHREXIBICAOPROD, ISNULL(DTHRFINPRODUCAO, GETDATE())) / CASE :QTHORA WHEN 0 THEN 1 ELSE :QTHORA END) AS TEMPOPRODUCAO
                FROM 
                    ITPEDIDOFOS 
                WHERE 
                    CDSETOR = :CDSETOR 
                    AND CDFILIAL = :CDFILIAL
                    AND NRPEDIDOFOS = :NRPEDIDOFOS
            ),
            MEDIAHORAANT = :MEDIAHORAANT,
            DTULTATU = GETDATE()
    ";


	const SQL_INSERT_STATISTICS = "
		INSERT INTO ITPEDIDOFOSEST
			(CDFILIAL, CDSETOR)
			VALUES
			(:CDFILIAL, :CDSETOR)
	";

	const DELETE_OLD_STATISTICS = "
		DELETE
			FROM ITPEDIDOFOSEST
		WHERE CDFILIAL + CDSETOR IN 
		( -- EVERYTHING ELSE BEFORE TODAY
			SELECT CDFILIAL + CDSETOR
			FROM ITPEDIDOFOSEST
		WHERE CAST(DTINICIOEST AS DATE) <= CAST((GETDATE() -1) AS DATE))
	";

	const DELETE_TWO_DAYS_STATISTICS = "
		DELETE
			FROM ITPEDIDOFOSEST
		WHERE CDFILIAL + CDSETOR IN (SELECT CDFILIAL + CDSETOR
			FROM ITPEDIDOFOSEST
		WHERE CAST(DTINICIOEST AS DATE) <= (GETDATE() -2))
	";

	const SQL_INSERT_STATISTICS_ON_CONCLUSION = "
		INSERT INTO ITPEDIDOFOSEST
		(CDFILIAL, CDSETOR, VRTMPMEDPROD, VRTMPMEDATRA, QTCONCLUIDO, QTATRASADO, VRPORCCOMANATRA)
		VALUES
		(:CDFILIAL, :CDSETOR, :TIMETOPRODUCE, :DELAYTIME, :QTPRODPEFOS, :QTATRASADO, (:QTATRASADO/:QTPRODPEFOS)*100)
	";

        // Esta query não é executada porque a chamada está comentada

	const SQL_UPDATE_DIAHORA_QT_STATISTICS = "
        UPDATE ITPEDIDOFOSEST SET 
            IDDIA = :IDDIA, 
            IDHORA = :IDHORA, 
            QTDIA = :QTDIA, 
            QTHORA = :QTHORA,
            QTHORAANT = :QTHORAANT,
            DTULTATU = GETDATE()
        WHERE CDFILIAL = :CDFILIAL AND CDSETOR = :CDSETOR
	";

	const SQL_UPDATE_STATISTICS_CONCLUSION = "
		UPDATE ITPEDIDOFOSEST
		SET VRTMPMEDPROD = ((ISNULL(VRTMPMEDPROD, 0) * ISNULL(QTCONCLUIDO, 0)) + (:TIMETOPRODUCE * :QTPRODPEFOS)) / CASE ISNULL(QTCONCLUIDO, 0) + :QTPRODPEFOS WHEN 0 THEN 1 ELSE ISNULL(QTCONCLUIDO, 0) + :QTPRODPEFOS END,
			VRTMPMEDATRA = CASE WHEN :QTATRASADO = 0 THEN VRTMPMEDATRA ELSE ((ISNULL(VRTMPMEDATRA, 0) * (ISNULL(QTCONCLUIDO, 0)) + (:DELAYTIME * :QTATRASADO)) / (ISNULL(QTCONCLUIDO, 0) + :QTATRASADO)) END,
			QTCONCLUIDO = ISNULL(QTCONCLUIDO, 0) + :QTPRODPEFOS,
			QTATRASADO = ISNULL(QTATRASADO, 0) + :QTATRASADO,
			VRPORCCOMANATRA = (((ISNULL(QTATRASADO, 0) + :QTATRASADO)/(ISNULL(QTCONCLUIDO, 0) + :QTPRODPEFOS)) * 100),
            DTULTATU = GETDATE()
		WHERE CDFILIAL = :CDFILIAL
		AND CDSETOR = :CDSETOR
	";	

	const GET_EXPEDITIONS_BY_NRPEDIDOFOS = "
		SELECT 
			DISTINCT SE.CDSETOR, IT.NRITPEDIDOFOS 
		FROM 
			ITPEDIDOFOS IT 
			JOIN SETOR SE ON (SE.CDSETOR = IT.CDSETOR) 
		WHERE 
			IT.CDFILIAL = :CDFILIAL AND NRPEDIDOFOS = :NRPEDIDOFOS
	";

	const GET_NRVENDAREST_COUNT_PEDCONC_TOP = "
        SELECT COUNT(CONTEMPEDIDO) CONTEMPEDIDO
          FROM (SELECT 1 AS CONTEMPEDIDO
                  FROM COMANDAVEN C, ITPEDIDOFOS IT, SETOR SE
                 WHERE IT.CDSETOR = SE.CDSETOR
                   AND SE.IDTIPOSETOR = 'E'
                   AND C.NRVENDAREST= IT.NRVENDAREST
                   AND C.NRCOMANDA = IT.NRCOMANDA
                   AND C.CDFILIAL = IT.CDFILIAL
                   AND IT.IDSITITPEDFOS = 'X'
                   AND C.IDIMPCUPEXP IN ('1','0')
                 UNION ALL
                SELECT 1 AS CONTEMPEDIDO
                  FROM COMANDAVEN C, ITCOMANDAVEN (nolock)
                 WHERE ITCOMANDAVEN.NRPEDIDOFOS IS NOT NULL
                   AND C.NRVENDAREST= ITCOMANDAVEN.NRVENDAREST
                   AND C.NRCOMANDA = ITCOMANDAVEN.NRCOMANDA
                   AND C.CDFILIAL = ITCOMANDAVEN.CDFILIAL
                   AND NOT EXISTS (SELECT 1
                                     FROM ITPEDIDOFOS ITF
                                    WHERE ITF.CDFILIAL = ITCOMANDAVEN.CDFILIAL
                                      AND ITF.NRPEDIDOFOS = ITCOMANDAVEN.NRPEDIDOFOS)
                   AND C.IDIMPCUPEXP IN ('1','0')) X OPTION (MAXDOP 8)
	";

	const GET_NRVENDAREST_COUNT_PEDCONC = "
        SELECT DISTINCT C.NRVENDAREST, C.NRCOMANDA, C.CDFILIAL
          FROM (SELECT C.NRVENDAREST, C.NRCOMANDA, C.CDFILIAL
                  FROM COMANDAVEN C, ITPEDIDOFOS IT, SETOR SE
                 WHERE IT.CDSETOR = SE.CDSETOR
                   AND SE.IDTIPOSETOR = 'E'
                   AND C.NRVENDAREST= IT.NRVENDAREST
                   AND C.NRCOMANDA = IT.NRCOMANDA
                   AND C.CDFILIAL = IT.CDFILIAL
                   AND IT.IDSITITPEDFOS = 'X'
                   AND C.IDIMPCUPEXP IN ('1','0')
                 UNION ALL
                SELECT C.NRVENDAREST, C.NRCOMANDA, C.CDFILIAL
                  FROM COMANDAVEN C, ITCOMANDAVEN (nolock)
                 WHERE ITCOMANDAVEN.NRPEDIDOFOS IS NOT NULL
                   AND C.NRVENDAREST= ITCOMANDAVEN.NRVENDAREST
                   AND C.NRCOMANDA = ITCOMANDAVEN.NRCOMANDA
                   AND C.CDFILIAL = ITCOMANDAVEN.CDFILIAL
                   AND NOT EXISTS (SELECT 1
                                     FROM ITPEDIDOFOS ITF
                                    WHERE ITF.CDFILIAL = ITCOMANDAVEN.CDFILIAL
                                      AND ITF.NRPEDIDOFOS = ITCOMANDAVEN.NRPEDIDOFOS)
                   AND C.IDIMPCUPEXP IN ('1','0')) C
        OPTION (MAXDOP 8)
	";

	const UPDATE_IDIMPCUPEXP_PEDCONC = "
        UPDATE COMANDAVEN
        SET IDIMPCUPEXP = 2
        WHERE CDFILIAL = :CDFILIAL
        AND NRVENDAREST = :NRVENDAREST
        AND NRCOMANDA = :NRCOMANDA
	";

    const SQL_VAL_IMPR_LOJA = "
        SELECT I.IDMODEIMPRES, L.CDPORTAIMPR, L.NRSEQIMPRLOJA, M.DSENDPORTA,
               L.DSIPIMPR, L.DSIPPONTE, L.NMIMPRLOJA
          FROM IMPRESSORA I,
               IMPRLOJA L LEFT JOIN MAPIMPRLOJA M
                                 ON L.CDFILIAL = M.CDFILIAL
                                AND L.CDLOJA = M.CDLOJA
                                AND L.CDPORTAIMPR = M.CDPORTAIMPR
						INNER JOIN CAIXA C
						ON C.CDFILIAL = L.CDFILIAL
         WHERE L.CDFILIAL = :CDFILIAL
           AND L.CDLOJA = :CDLOJA
		   AND C.CDCAIXA = :CDCAIXA
           AND L.NMIMPRLOJA = 'PICKLIST'
           AND L.CDIMPRESSORA = I.CDIMPRESSORA
    ";

    const BUSCA_DADOS_IMPRESSORA = "
			SELECT  P.NRSEQIMPRLOJA, I.IDMODEIMPRES, P.CDPORTAIMPR, L.CDLOJA,
					UPPER(L.NMLOJA) AS NMLOJA, UPPER(C.NMCAIXA) AS NMCAIXA,
					P.DSIPIMPR, P.DSIPPONTE, C.CDCAIXA, C.NMCAIXA, P.NMIMPRLOJA
			FROM CAIXA C JOIN IMPRLOJA P
					ON C.CDFILIAL = P.CDFILIAL
				AND C.CDLOJA = P.CDLOJA
				AND P.NRSEQIMPRLOJA = C.NRSEQIMPRLOJA6			  
				JOIN IMPRESSORA I
					ON P.CDIMPRESSORA = I.CDIMPRESSORA
				JOIN LOJA L
					ON L.CDLOJA = C.CDLOJA
					AND L.CDFILIAL = C.CDFILIAL
			WHERE C.CDFILIAL = :CDFILIAL
			AND C.CDCAIXA = :CDCAIXA
		";

		const GET_CDCAIXA_BY_CDSETOR = "
				SELECT CDCAIXA FROM CAIXA WHERE CDSETOR = :CDSETOR
		";
		
		const BUSCA_DADOS_IMPRESSORA_ETIQUETAS = "
			SELECT  P.NRSEQIMPRLOJA, I.IDMODEIMPRES, P.CDPORTAIMPR, L.CDLOJA,
					UPPER(L.NMLOJA) AS NMLOJA, UPPER(C.NMCAIXA) AS NMCAIXA,
					P.DSIPIMPR, P.DSIPPONTE, C.CDCAIXA, C.NMCAIXA, P.NMIMPRLOJA
			FROM CAIXA C JOIN IMPRLOJA P
					ON C.CDFILIAL = P.CDFILIAL
				AND C.CDLOJA = P.CDLOJA
				AND P.NRSEQIMPRLOJA = C.NRSEQIMPRLOJA6			  
				JOIN IMPRESSORA I
					ON P.CDIMPRESSORA = I.CDIMPRESSORA
				JOIN LOJA L
					ON L.CDLOJA = C.CDLOJA
					AND L.CDFILIAL = C.CDFILIAL
			WHERE C.CDFILIAL = :CDFILIAL
			AND C.CDCAIXA = :CDCAIXA
    ";

    const SQL_GET_PRODUCT_INFO = "
        SELECT P.NMPRODUTO, P.CDARVPROD, P.CDBARPRODUTO
          FROM PRODUTO P
          WHERE P.CDPRODUTO = :CDPRODUTO
    ";

    const SQL_GET_CMDINFO = "
		SELECT DISTINCT ITC.CDCAIXACOLETOR CDCAIXA, C.NMCAIXA, L.NMLOJA, L.CDLOJA
  		FROM ITCOMANDAVEN ITC, ITPEDIDOFOS ITP, CAIXA C, LOJA L
		WHERE ITC.NRVENDAREST = ITP.NRVENDAREST
		  AND ITC.NRVENDAREST = :NRVENDAREST
		  AND C.CDCAIXA = ITC.CDCAIXACOLETOR 
		  AND L.CDLOJA = C.CDLOJA
		  AND ITC.CDLOJA = L.CDLOJA
    ";

    const SQL_GET_VNDINFO = "	   
    	SELECT DISTINCT ITV.CDCAIXA, C.NMCAIXA, L.NMLOJA, L.CDLOJA
  		 FROM ITEMVENDA ITV, CAIXA C, LOJA L, VENDA V
		WHERE V.NRSEQVENDA = ITV.NRSEQVENDA
		  AND V.NRSEQVENDA = :NRSEQVENDA
		  AND C.CDCAIXA = ITV.CDCAIXA 
		  AND L.CDLOJA = C.CDLOJA
		  AND ITV.CDLOJA = L.CDLOJA
    ";

    const SQL_GET_TXPRODPED = "
        SELECT TXPRODPED
          FROM ITPEDIDOFOS
         WHERE CDFILIAL = :CDFILIAL
           AND NRPEDIDOFOS = :NRPEDIDOFOS
           AND NRITPEDIDOFOS = :NRITPEDIDOFOS
    ";

    const SQL_GET_SENHAPED = "
    	SELECT CDSENHAPED 
    	FROM PEDIDOFOS
    	WHERE NRPEDIDOFOS = :NRPEDIDOFOS 
    ";

    const GET_PICKLIST_SECTOR = "
    	SELECT IDIMPRPICKLIST
    	FROM SETORFILIAL
    	WHERE CDSETOR = :CDSETOR
	";

    CONST GET_PICKLIST_PRODUTO = "
        SELECT IDIMPRPRODPICK, IDIMPPRODAPETIC
            FROM SETORPRODUTO
            WHERE CDPRODUTO = :CDPRODUTO
                AND CDSETOR = :CDSETOR
";
	const GET_IDHABPICKLISTIMPBTN_BY_CDSETOR = "
    	SELECT IDHABPICKLISTIMPBTN
    	FROM SETORFILIAL
    	WHERE CDSETOR = :CDSETOR
	";

	const GET_ORDER_BY_URL = "
		SELECT CDFILIAL, NRVENDAREST, NRCOMANDAVND, NRSEQVENDA FROM VENDA
		WHERE DSQRCODENFCE = :DSQRCODENFCE
	";

	const UPDATE_STATE_SCANCODE = "
		UPDATE SETORFILIAL 
		set IDHABSCANCODE = :IDHABSCANCODE
		WHERE CDSETOR = :CDSETOR
	";

	const GET_LINHAPROD = "
					SELECT 
						* 
					FROM 
						LINHAPROD 
					WHERE 
					  IDATIVO = 'S'
						AND CDFILIAL = :CDFILIAL						
	";

	const GET_LINHAPRODSETOR = "
					SELECT
					 *
					FROM 
						LINHAPRODSETOR 
					WHERE 
						CDFILIAL = :CDFILIAL
						AND CDSETOR = :CDSETOR
					ORDER BY CDLINHAPROD
	";

	const GET_STATUS_LINHAPROD = "
		SELECT IDATIVO 
		FROM LINHAPROD 
		WHERE CDLINHAPROD IN (SELECT DISTINCT CDLINHAPROD FROM LINHAPRODSETOR WHERE CDSETOR = :CDSETOR)
	";

	const UPDATE_STATUS_LINHAPROD = "
		UPDATE LINHAPROD 
			SET IDATIVO = CASE WHEN IDATIVO = 'S' THEN 'N' ELSE 'S' END
			WHERE CDLINHAPROD IN (SELECT DISTINCT CDLINHAPROD FROM LINHAPRODSETOR WHERE CDSETOR = :CDSETOR AND CDFILIAL = :CDFILIAL)
			
	";

	const UPDATE_PERCENT_DEMAND = "
		UPDATE LINHAPROD SET NRPERCDEMANDA = :NRPERCDEMANDA
		WHERE CDFILIAL = :CDFILIAL AND CDLINHAPROD = (
			SELECT DISTINCT CDLINHAPROD FROM LINHAPRODSETOR WHERE CDSETOR = :CDSETOR
		)
	";

	const UPDATE_SHOW_OVERALL_STATISTICS = "
		UPDATE SETORFILIAL SET IDHABESTGERAL = CASE WHEN IDHABESTGERAL = 'S' THEN 'N' ELSE 'S' END 
			WHERE CDFILIAL = :CDFILIAL AND CDSETOR = :CDSETOR
";

	const GET_CORRELATIONATED_SECTORS = "
		SELECT ISNULL((
			SELECT SUM(QTPRODPEFOS) FROM ITPEDIDOFOS 
			WHERE CDSETOR = LPS.CDSETOR
			AND IDSITITPEDFOS NOT IN ('F','X')
		),0) AS TOTALQTPRODPEFOS, 
		LPS.*,
		LP.NRPERCDEMANDA,
		LP.NMLINHAPROD,
		LP.IDLINHAPRINCIPAL
		FROM LINHAPRODSETOR LPS
		INNER JOIN LINHAPROD LP
		ON ( LP.CDFILIAL = LPS.CDFILIAL 
			AND LP.CDLINHAPROD = LPS.CDLINHAPROD
			AND LP.IDATIVO = 'S'
		)
	";

	const GET_CDSETORCORRESP = "
		SELECT DISTINCT CDSETOR FROM LINHAPRODSETOR LPS, LINHAPROD LP 
		WHERE LPS.CDLINHAPROD = LP.CDLINHAPROD
		AND LP.IDATIVO = 'S'
		AND CDSETOR IN (
			SELECT CDSETORCORRESP
			FROM LINHAPRODSETOR
			WHERE CDSETOR = :CDSETOR
			AND CDFILIAL = :CDFILIAL
		) OR CDSETOR IN (
			SELECT CDSETOR
			FROM LINHAPRODSETOR 
			WHERE CDSETORCORRESP = :CDSETOR
			AND CDFILIAL = :CDFILIAL
		)
	";

	const CONCLUDE_ITPEDIDOFOS_BY_KEYS = "
		UPDATE ITPEDIDOFOS 
			   SET IDSITITPEDFOS   = 'X' 
			   , 

			   DTHRFINPRODUCAO = DATEADD(second,ISNULL((SELECT NRROLLBTIME
		       													  FROM SETORFILIAL
		       													 WHERE CDFILIAL = :CDFILIAL
		       													   AND IDHABROLLBKDS = 'S'
		       													   AND CDSETOR = (SELECT CDSETOR
		       													                    FROM ITPEDIDOFOS
		       													                   WHERE CDFILIAL      = :CDFILIAL
																	       		     AND NRPEDIDOFOS   = :NRPEDIDOFOS
																		     		 AND NRITPEDIDOFOS = :NRITPEDIDOFOS))
								                 , 0) *(-1), GETDATE()),
			   DTHRINIPRODUCAO = ISNULL(DTHRINIPRODUCAO, DTHREXIBICAOPROD) 
			 WHERE CDFILIAL  = :CDFILIAL
			 AND NRPEDIDOFOS = :NRPEDIDOFOS
			 AND NRITPEDIDOFOS = :NRITPEDIDOFOS
	";

	// const DELETE_FROM_KDS_TEMP_SETOREST = "
	// 	DELETE FROM KDS_TEMP_SETOREST WHERE DTHRFIMPRODUCAO < ( SELECT DATEADD(MINUTE,ISNULL(NRTEMPOESTMIN, 30) * -1, GETDATE()) FROM FILIAL )
	// 	AND CDFILIAL = :CDFILIAL
	// 	AND CDSETOR = :CDSETOR
	// ";

	const INSERT_INTO_KDS_TEMP_SETOREST = "
		INSERT INTO KDS_TEMP_SETOREST (CDFILIAL, CDSETOR, NRPEDIDOFOS, NRTEMPOTOTAL, DTHRFIMPRODUCAO)
		VALUES(
				:CDFILIAL,
				:CDSETOR,
				:NRPEDIDOFOS,
				:NRTEMPOTOTAL,
				GETDATE()
			)
	";

	// const GET_EXPEDITIONS_INFO_BY_NRPEDIDOFOS = "
	// 	SELECT 
	// 		IT.CDFILIAL, 
	// 		IT.CDSETOR, 
	// 		IT.NRPEDIDOFOS, 
	// 		CAST((CAST((ISNULL(IT.DTHRPRIEXPED, IT.DTHRFINPRODUCAO) - ISNULL(DTHRINIPRODUCAO, DTHREXIBICAOPROD)) AS FLOAT) * (24*60*60)) AS INT) AS NRTEMPOTOTAL,
	// 		ISNULL(IT.DTHRPRIEXPED, IT.DTHRFINPRODUCAO) AS DTHRFIMPRODUCAO
	// 	FROM ITPEDIDOFOS IT 
	// 		JOIN SETOR SE 
	// 		ON ( SE.IDTIPOSETOR = 'E' AND SE.CDSETOR = IT.CDSETOR )

	// 	WHERE CAST((CAST((ISNULL(IT.DTHRPRIEXPED, IT.DTHRFINPRODUCAO) - ISNULL(DTHRINIPRODUCAO, DTHREXIBICAOPROD)) AS FLOAT) * (24*60*60)) AS INT) > 0
	// 			AND CDFILIAL = :CDFILIAL
	// 			AND NRPEDIDOFOS = :NRPEDIDOFOS
	// ";

	const CREATE_KDS_TEMP_SETOREST = "
		-- CRIAR TABELA TEMPORARIA PARA INSERIR OS REGISTROS QUE SERÃO USADOS NO CALCULO DA ESTATÍSTICA
		CREATE TABLE KDS_TEMP_SETOREST
		(
			CDFILIAL VARCHAR(4) NOT NULL,
			CDSETOR VARCHAR(4) NOT NULL,
			NRPEDIDOFOS VARCHAR(10) NOT NULL,
			NRTEMPOTOTAL INT NOT NULL,
			DTHRFIMPRODUCAO DATETIME NOT NULL,
			--PRIMARY KEY (CDFILIAL, CDSETOR, NRPEDIDOFOS) 
		)	
	";

	const GET_KDS_TEMP_SETOREST = "
		select * from sysobjects where name = 'KDS_TEMP_SETOREST' AND XTYPE = 'U'
	";

	const GET_SECTOR_TYPE = "
		SELECT IDTIPOSETOR FROM SETOR WHERE CDSETOR = :CDSETOR
	";

    	/** END OF EXTENDED STATISTICS SECTION - GENERAL*/

	const GET_WAITING_TIME_GENERAL_DAY = "
		/** parametros :CDFILIAL, :CDLOJA */
		SELECT 		
			TOTAL,
			VRTMPMEDPROD
		FROM
		  (SELECT 
		  		  COUNT(NRPEDIDOFOS) AS TOTAL,
		  		  SUM(KSE.NRTEMPOTOTAL) / COUNT(KSE.NRPEDIDOFOS) / 60 AS VRTMPMEDPROD ,
                  SL.CDLOJA,
                  SL.CDFILIAL
           FROM KDS_TEMP_SETOREST KSE
           JOIN SETORLOJA SL ON (SL.CDSETOR = KSE.CDSETOR)
           JOIN SETOR SE ON (SE.CDSETOR = SL.CDSETOR
                             AND SE.IDTIPOSETOR = 'E')
           JOIN FILIAL FL ON (FL.CDFILIAL = KSE.CDFILIAL)
		   WHERE 
		   --GENERAL_DAY INCLUDE ALL DAY, SO WE DONT NEED TO USE LIMITATION CAUSE THE RECORDS ARE DELETED ALL DAY BETWEEN 01:00 AND 02:00
		   --KSE.DTHRFIMPRODUCAO >= DATEADD(MINUTE, FL.NRTEMPOESTMIN * -1, GETDATE()) AND
		     --(KSE.NRTEMPOTOTAL >= FL.NRTEMPOESTMIN * 60) AND
             KSE.CDFILIAL = :CDFILIAL
             AND SL.CDLOJA = :CDLOJA
           GROUP BY SL.CDFILIAL,
                    SL.CDLOJA) AS PROD
        RIGHT JOIN LOJA LJ 
          ON (LJ.CDFILIAL = PROD.CDFILIAL
          AND LJ.CDLOJA = PROD.CDLOJA)
        WHERE LJ.CDFILIAL = :CDFILIAL
        AND LJ.CDLOJA = :CDLOJA
	";
	
	const GET_WAITING_TIME_GENERAL_LAST_HOUR = "
		/** parametros :CDFILIAL, :CDLOJA */
		SELECT 		
			TOTAL,
			VRTMPMEDPROD
		FROM
			(SELECT 
					COUNT(NRPEDIDOFOS) AS TOTAL,
					SUM(KSE.NRTEMPOTOTAL) / COUNT(KSE.NRPEDIDOFOS) / 60 AS VRTMPMEDPROD ,
					SL.CDLOJA,
					SL.CDFILIAL
			FROM KDS_TEMP_SETOREST KSE
			JOIN SETORLOJA SL ON (SL.CDSETOR = KSE.CDSETOR)
			JOIN SETOR SE ON (SE.CDSETOR = SL.CDSETOR
							AND SE.IDTIPOSETOR = 'E')
			JOIN FILIAL FL ON (FL.CDFILIAL = KSE.CDFILIAL)
			WHERE 
			--GENERAL_DAY INCLUDE ALL DAY, SO WE DONT NEED TO USE LIMITATION CAUSE THE RECORDS ARE DELETED ALL DAY BETWEEN 01:00 AND 02:00
			KSE.DTHRFIMPRODUCAO >= DATEADD(MINUTE, 120 * -1, GETDATE()) AND
			--(KSE.NRTEMPOTOTAL >= FL.NRTEMPOESTMIN * 60) AND
			KSE.CDFILIAL = :CDFILIAL
			AND SL.CDLOJA = :CDLOJA
			GROUP BY SL.CDFILIAL,
					SL.CDLOJA) AS PROD
		RIGHT JOIN LOJA LJ 
			ON (LJ.CDFILIAL = PROD.CDFILIAL
			AND LJ.CDLOJA = PROD.CDLOJA)
		WHERE LJ.CDFILIAL = :CDFILIAL
		AND LJ.CDLOJA = :CDLOJA
  ";

  const GET_WAITING_TIME_GENERAL_CURRENT_HOUR = "
		/** parametros :CDFILIAL, :CDLOJA */
		SELECT 
			TOTAL,
			VRTMPMEDPROD
		FROM
			(SELECT 
					COUNT(NRPEDIDOFOS) AS TOTAL,
					SUM(KSE.NRTEMPOTOTAL) / COUNT(KSE.NRPEDIDOFOS) / 60 AS VRTMPMEDPROD ,
					SL.CDLOJA,
					SL.CDFILIAL
			FROM KDS_TEMP_SETOREST KSE
			JOIN SETORLOJA SL ON (SL.CDSETOR = KSE.CDSETOR)
			JOIN SETOR SE ON (SE.CDSETOR = SL.CDSETOR
							AND SE.IDTIPOSETOR = 'E')
			JOIN FILIAL FL ON (FL.CDFILIAL = KSE.CDFILIAL)
			WHERE 
			--GENERAL_DAY INCLUDE ALL DAY, SO WE DONT NEED TO USE LIMITATION CAUSE THE RECORDS ARE DELETED ALL DAY BETWEEN 01:00 AND 02:00
			KSE.DTHRFIMPRODUCAO >= DATEADD(MINUTE, 60 * -1, GETDATE()) AND
			--(KSE.NRTEMPOTOTAL >= FL.NRTEMPOESTMIN * 60) AND
			KSE.CDFILIAL = :CDFILIAL
			AND SL.CDLOJA = :CDLOJA
			GROUP BY SL.CDFILIAL,
					SL.CDLOJA) AS PROD
		RIGHT JOIN LOJA LJ 
			ON (LJ.CDFILIAL = PROD.CDFILIAL
			AND LJ.CDLOJA = PROD.CDLOJA)
		WHERE LJ.CDFILIAL = :CDFILIAL
			AND LJ.CDLOJA = :CDLOJA
	";

	/** END OF EXTENDED STATISTICS SECTION - GENERAL*/

	/** EXTENDED STATISTICS SECTION - BY CDSETOR*/

	const GET_WAITING_TIME_GENERAL_DAY_BY_CDSETOR = "
		/** parametros :CDFILIAL, :CDLOJA */
		SELECT 		
			TOTAL,
			VRTMPMEDPROD
		FROM
		  (SELECT 
		  		  COUNT(NRPEDIDOFOS) AS TOTAL,
		  		  SUM(KSE.NRTEMPOTOTAL) / COUNT(KSE.NRPEDIDOFOS) / 60 AS VRTMPMEDPROD ,
                  SL.CDLOJA,
                  SL.CDFILIAL
           FROM KDS_TEMP_SETOREST KSE
           JOIN SETORLOJA SL ON (SL.CDSETOR = KSE.CDSETOR)
           JOIN SETOR SE ON (SE.CDSETOR = SL.CDSETOR
                             AND SE.CDSETOR = :CDSETOR)
           JOIN FILIAL FL ON (FL.CDFILIAL = KSE.CDFILIAL)
		   WHERE 
		   --GENERAL_DAY INCLUDE ALL DAY, SO WE DONT NEED TO USE LIMITATION CAUSE THE RECORDS ARE DELETED ALL DAY BETWEEN 01:00 AND 02:00
		   --KSE.DTHRFIMPRODUCAO >= DATEADD(MINUTE, FL.NRTEMPOESTMIN * -1, GETDATE()) AND
		     --(KSE.NRTEMPOTOTAL >= FL.NRTEMPOESTMIN * 60) AND
             KSE.CDFILIAL = :CDFILIAL
             AND SL.CDLOJA = :CDLOJA
           GROUP BY SL.CDFILIAL,
                    SL.CDLOJA) AS PROD
        RIGHT JOIN LOJA LJ 
          ON (LJ.CDFILIAL = PROD.CDFILIAL
          AND LJ.CDLOJA = PROD.CDLOJA)
        WHERE LJ.CDFILIAL = :CDFILIAL
        AND LJ.CDLOJA = :CDLOJA
	";
	
	const GET_WAITING_TIME_GENERAL_LAST_HOUR_BY_CDSETOR = "
		/** parametros :CDFILIAL, :CDLOJA, :CDSETOR */
		SELECT 		
			TOTAL,
			VRTMPMEDPROD
		FROM
			(SELECT 
					COUNT(NRPEDIDOFOS) AS TOTAL,
					SUM(KSE.NRTEMPOTOTAL) / COUNT(KSE.NRPEDIDOFOS) / 60 AS VRTMPMEDPROD ,
					SL.CDLOJA,
					SL.CDFILIAL
			FROM KDS_TEMP_SETOREST KSE
			JOIN SETORLOJA SL ON (SL.CDSETOR = KSE.CDSETOR)
			JOIN SETOR SE ON (SE.CDSETOR = SL.CDSETOR
					AND SE.CDSETOR = :CDSETOR)
			JOIN FILIAL FL ON (FL.CDFILIAL = KSE.CDFILIAL)
			WHERE 
			--GENERAL_DAY INCLUDE ALL DAY, SO WE DONT NEED TO USE LIMITATION CAUSE THE RECORDS ARE DELETED ALL DAY BETWEEN 01:00 AND 02:00
			KSE.DTHRFIMPRODUCAO >= DATEADD(MINUTE, 120 * -1, GETDATE()) AND
			--(KSE.NRTEMPOTOTAL >= FL.NRTEMPOESTMIN * 60) AND
			KSE.CDFILIAL = :CDFILIAL
			AND SL.CDLOJA = :CDLOJA
			GROUP BY SL.CDFILIAL,
					SL.CDLOJA) AS PROD
		RIGHT JOIN LOJA LJ 
			ON (LJ.CDFILIAL = PROD.CDFILIAL
			AND LJ.CDLOJA = PROD.CDLOJA)
		WHERE LJ.CDFILIAL = :CDFILIAL
		AND LJ.CDLOJA = :CDLOJA
  ";

  const GET_WAITING_TIME_GENERAL_CURRENT_HOUR_BY_CDSETOR = "
		/** parametros :CDFILIAL, :CDLOJA, :CDSETOR */
		SELECT 
			TOTAL,
			VRTMPMEDPROD
		FROM
			(SELECT 
					COUNT(NRPEDIDOFOS) AS TOTAL,
					SUM(KSE.NRTEMPOTOTAL) / COUNT(KSE.NRPEDIDOFOS) / 60 AS VRTMPMEDPROD ,
					SL.CDLOJA,
					SL.CDFILIAL
			FROM KDS_TEMP_SETOREST KSE
			JOIN SETORLOJA SL ON (SL.CDSETOR = KSE.CDSETOR)
			JOIN SETOR SE ON (SE.CDSETOR = SL.CDSETOR
					AND SE.CDSETOR = :CDSETOR)
			JOIN FILIAL FL ON (FL.CDFILIAL = KSE.CDFILIAL)
			WHERE 
			--GENERAL_DAY INCLUDE ALL DAY, SO WE DONT NEED TO USE LIMITATION CAUSE THE RECORDS ARE DELETED ALL DAY BETWEEN 01:00 AND 02:00
			KSE.DTHRFIMPRODUCAO >= DATEADD(MINUTE, 60 * -1, GETDATE()) AND
			--(KSE.NRTEMPOTOTAL >= FL.NRTEMPOESTMIN * 60) AND
			KSE.CDFILIAL = :CDFILIAL
			AND SL.CDLOJA = :CDLOJA
			GROUP BY SL.CDFILIAL,
					SL.CDLOJA) AS PROD
		RIGHT JOIN LOJA LJ 
			ON (LJ.CDFILIAL = PROD.CDFILIAL
			AND LJ.CDLOJA = PROD.CDLOJA)
		WHERE LJ.CDFILIAL = :CDFILIAL
			AND LJ.CDLOJA = :CDLOJA
	";
	/** END OF EXTENDED STATISTIC SECTION - BY CDSETOR*/

	const GET_PRODUCTION_STATISTICS = "
		SELECT MDTOTAL.CDSETOR, MEDIATOTAL, MEDIAHORAATUAL, MEDIAHORAANTERIOR FROM 

		(
			SELECT KTS.CDSETOR, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIATOTAL FROM KDS_TEMP_SETOREST
			KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR AND SE.IDTIPOSETOR <> 'E')
			WHERE KTS.CDSETOR IS NOT NULL
			GROUP BY KTS.CDSETOR
		) MDTOTAL
		
		LEFT JOIN 
		(
			SELECT KTS.CDSETOR, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIAHORAATUAL FROM KDS_TEMP_SETOREST
			KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR AND SE.IDTIPOSETOR <> 'E')
			WHERE KTS.CDSETOR IS NOT NULL
			AND DTHRFIMPRODUCAO >= DATEADD(HOUR, -1, DTHRFIMPRODUCAO)
			GROUP BY KTS.CDSETOR
		) MDHRATUAL ON (MDHRATUAL.CDSETOR = MDTOTAL.CDSETOR)
		
		LEFT JOIN (
			SELECT KTS.CDSETOR, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIAHORAANTERIOR FROM KDS_TEMP_SETOREST
			KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR AND SE.IDTIPOSETOR <> 'E')
			WHERE KTS.CDSETOR IS NOT NULL
			AND DTHRFIMPRODUCAO >= DATEADD(HOUR, -2, DTHRFIMPRODUCAO) AND DTHRFIMPRODUCAO < DATEADD(HOUR, -1, DTHRFIMPRODUCAO)
			GROUP BY KTS.CDSETOR
		) MDHRANT ON (MDTOTAL.CDSETOR = MDHRANT.CDSETOR)	
	";

	const GET_PRODUCTION_STATISTICS_BY_CDSETOR = " -- P[ :CDSETOR ]
		SELECT MDTOTAL.CDSETOR, MEDIATOTAL, MEDIAHORAATUAL, MEDIAHORAANTERIOR FROM 

		(
			SELECT KTS.CDSETOR, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIATOTAL FROM KDS_TEMP_SETOREST
			KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR AND SE.IDTIPOSETOR <> 'E')
			WHERE KTS.CDSETOR = :CDSETOR
			GROUP BY KTS.CDSETOR
		) MDTOTAL
		
		LEFT JOIN 
		(
			SELECT KTS.CDSETOR, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIAHORAATUAL FROM KDS_TEMP_SETOREST
			KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR AND SE.IDTIPOSETOR <> 'E')
			WHERE KTS.CDSETOR = :CDSETOR
			AND DTHRFIMPRODUCAO >= DATEADD(HOUR, -1, DTHRFIMPRODUCAO)
			GROUP BY KTS.CDSETOR
		) MDHRATUAL ON (MDHRATUAL.CDSETOR = MDTOTAL.CDSETOR)
		
		LEFT JOIN (
			SELECT KTS.CDSETOR, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIAHORAANTERIOR FROM KDS_TEMP_SETOREST
			KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR AND SE.IDTIPOSETOR <> 'E')
			WHERE KTS.CDSETOR = :CDSETOR
			AND DTHRFIMPRODUCAO >= DATEADD(HOUR, -2, DTHRFIMPRODUCAO) AND DTHRFIMPRODUCAO < DATEADD(HOUR, -1, DTHRFIMPRODUCAO)
			GROUP BY KTS.CDSETOR
		) MDHRANT ON (MDTOTAL.CDSETOR = MDHRANT.CDSETOR)	
	";

	const GET_EXPEDITION_STATISTICS = "
		SELECT MDTOTAL.CDSETOR, MEDIAGERAL, MEDIAGERALHRANT, MEDIAGERALHRATUAL, MEDIATOTAL, MEDIAHORAANTERIOR, MEDIAHORAATUAL FROM 

		(
			SELECT KTS.CDSETOR, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIATOTAL FROM KDS_TEMP_SETOREST 
			KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR AND SE.IDTIPOSETOR = 'E')
			WHERE KTS.CDSETOR IS NOT NULL
			GROUP BY KTS.CDSETOR
		) MDTOTAL
		
		LEFT JOIN 

		(
			SELECT KTS.CDSETOR, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIAHORAATUAL FROM KDS_TEMP_SETOREST 
			KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR AND SE.IDTIPOSETOR = 'E')
			WHERE KTS.CDSETOR IS NOT NULL
			AND DTHRFIMPRODUCAO >= DATEADD(HOUR, -1, DTHRFIMPRODUCAO)
			GROUP BY KTS.CDSETOR
		) MDHRATUAL ON (MDHRATUAL.CDSETOR = MDTOTAL.CDSETOR)
		
		LEFT JOIN (
			SELECT KTS.CDSETOR, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIAHORAANTERIOR FROM KDS_TEMP_SETOREST 
			KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR AND SE.IDTIPOSETOR = 'E')
			WHERE KTS.CDSETOR IS NOT NULL
			AND DTHRFIMPRODUCAO >= DATEADD(HOUR, -2, DTHRFIMPRODUCAO) AND DTHRFIMPRODUCAO < DATEADD(HOUR, -1, DTHRFIMPRODUCAO)
			GROUP BY KTS.CDSETOR
		) MDHRANT ON (MDHRANT.CDSETOR = MDTOTAL.CDSETOR)

		LEFT JOIN 

		(
			SELECT KTS.CDSETOR, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIAGERAL FROM KDS_TEMP_SETOREST 
			KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR AND SE.IDTIPOSETOR = 'E')
			WHERE KTS.CDSETOR IS NOT NULL
			GROUP BY KTS.CDSETOR
		) MDGERAL ON (MDGERAL.CDSETOR IS NOT NULL)	

		LEFT JOIN 

		(
			SELECT KTS.CDSETOR, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIAGERALHRANT FROM KDS_TEMP_SETOREST 
			KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR AND SE.IDTIPOSETOR = 'E')
			WHERE KTS.CDSETOR IS NOT NULL
			AND DTHRFIMPRODUCAO >= DATEADD(HOUR, -2, DTHRFIMPRODUCAO) AND DTHRFIMPRODUCAO < DATEADD(HOUR, -1, DTHRFIMPRODUCAO)
			GROUP BY KTS.CDSETOR
		) MDGERALHRANT ON (MDGERALHRANT.CDSETOR IS NOT NULL)
		
		LEFT JOIN 

		(
			SELECT KTS.CDSETOR, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIAGERALHRATUAL FROM KDS_TEMP_SETOREST 
			KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR AND SE.IDTIPOSETOR = 'E')
			WHERE KTS.CDSETOR IS NOT NULL
			AND DTHRFIMPRODUCAO >= DATEADD(HOUR, -1, DTHRFIMPRODUCAO)
			GROUP BY KTS.CDSETOR
		) MEDIAGERALHRATUAL ON (MEDIAGERALHRATUAL.CDSETOR IS NOT NULL)
	";

	const GET_EXPEDITION_STATISTICS_BY_CDSETOR = "
		SELECT MDTOTAL.CDSETOR, ISNULL(MEDIAGERAL, 0) AS MEDIAGERAL, ISNULL(MEDIAGERALHRANT, 0) AS MEDIAGERALHRANT, ISNULL(MEDIAGERALHRATUAL, 0) AS MEDIAGERALHRATUAL, ISNULL(MEDIATOTAL, 0) AS MEDIATOTAL, ISNULL(MEDIAHORAANTERIOR, 0) AS MEDIAHORAANTERIOR, ISNULL(QTTOTAL, 0) AS QTTOTAL, ISNULL(QTHORAATUAL, 0) AS QTHORAATUAL, ISNULL(QTHORAANTERIOR, 0) AS QTHORAANTERIOR, ISNULL(QTGERAL, 0) AS QTGERAL, ISNULL(QTGERALHRANT, 0) AS QTGERALHRANT, ISNULL(QTGERALHRATUAL, 0) AS QTGERALHRATUAL, ISNULL(MEDIAHORAATUAL, 0) AS MEDIAHORAATUAL FROM 

		(
			SELECT KTS.CDSETOR, COUNT(NRTEMPOTOTAL) AS QTTOTAL, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIATOTAL FROM KDS_TEMP_SETOREST 
			KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR AND SE.IDTIPOSETOR = 'E')
			WHERE KTS.CDSETOR = :CDSETOR
			AND NRTEMPOTOTAL IS NOT NULL
			GROUP BY KTS.CDSETOR
		) MDTOTAL
		
		LEFT JOIN 

		(
			SELECT KTS.CDSETOR, COUNT(NRTEMPOTOTAL) AS QTHORAATUAL, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIAHORAATUAL FROM KDS_TEMP_SETOREST 
			KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR AND SE.IDTIPOSETOR = 'E')
			WHERE KTS.CDSETOR = :CDSETOR
			AND DTHRFIMPRODUCAO >= DATEADD(HOUR, -1, DTHRFIMPRODUCAO)
			GROUP BY KTS.CDSETOR
		) MDHRATUAL ON (MDHRATUAL.CDSETOR = MDTOTAL.CDSETOR)
		
		LEFT JOIN (
			SELECT KTS.CDSETOR, COUNT(NRTEMPOTOTAL) AS QTHORAANTERIOR, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIAHORAANTERIOR FROM KDS_TEMP_SETOREST 
			KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR AND SE.IDTIPOSETOR = 'E')
			WHERE KTS.CDSETOR = :CDSETOR
			AND DTHRFIMPRODUCAO >= DATEADD(HOUR, -2, DTHRFIMPRODUCAO) AND DTHRFIMPRODUCAO < DATEADD(HOUR, -1, DTHRFIMPRODUCAO)
			GROUP BY KTS.CDSETOR
		) MDHRANT ON (MDHRANT.CDSETOR = MDTOTAL.CDSETOR)

		LEFT JOIN 

		(
			SELECT KTS.CDSETOR, COUNT(NRTEMPOTOTAL) AS QTGERAL, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIAGERAL FROM KDS_TEMP_SETOREST 
			KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR AND SE.IDTIPOSETOR = 'E')
			WHERE KTS.CDSETOR = :CDSETOR
			AND NRTEMPOTOTAL IS NOT NULL
			GROUP BY KTS.CDSETOR
		) MDGERAL ON (MDGERAL.CDSETOR = :CDSETOR)	

		LEFT JOIN 

		(
			SELECT KTS.CDSETOR, COUNT(NRTEMPOTOTAL) AS QTGERALHRANT, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIAGERALHRANT FROM KDS_TEMP_SETOREST 
			KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR AND SE.IDTIPOSETOR = 'E')
			WHERE KTS.CDSETOR = :CDSETOR
			AND DTHRFIMPRODUCAO >= DATEADD(HOUR, -2, DTHRFIMPRODUCAO) AND DTHRFIMPRODUCAO < DATEADD(HOUR, -1, DTHRFIMPRODUCAO)
			GROUP BY KTS.CDSETOR
		) MDGERALHRANT ON (MDGERALHRANT.CDSETOR = :CDSETOR)
		
		LEFT JOIN 

		(
			SELECT KTS.CDSETOR, COUNT(NRTEMPOTOTAL) AS QTGERALHRATUAL, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIAGERALHRATUAL FROM KDS_TEMP_SETOREST 
			KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR AND SE.IDTIPOSETOR = 'E')
			WHERE KTS.CDSETOR = :CDSETOR
			AND DTHRFIMPRODUCAO >= DATEADD(HOUR, -1, DTHRFIMPRODUCAO)
			GROUP BY KTS.CDSETOR
		) MEDIAGERALHRATUAL ON (MEDIAGERALHRATUAL.CDSETOR = :CDSETOR)	
	";

	const GET_TEMP_STATISTICS_BY_CDSETOR = "
			SELECT MDTOTAL.CDSETOR, ISNULL(MEDIAGERAL, 0) AS MEDIAGERAL, ISNULL(NRTEMPOTOTAL, 0) AS NRTEMPOTOTAL, 
			ISNULL(TEMPOTOTALGERALHRANT, 0) AS TEMPOTOTALGERALHRANT, 
			ISNULL(MEDIAGERALHRANT, 0) AS MEDIAGERALHRANT, 
			ISNULL(MEDIAGERALHRATUAL, 0) AS MEDIAGERALHRATUAL,
			ISNULL(TEMPOTOTALGERALHRAAT, 0) AS TEMPOTOTALGERALHRAAT,
			ISNULL(MEDIATOTAL, 0) AS MEDIATOTAL, 
			ISNULL(MEDIAHORAANTERIOR, 0) AS MEDIAHORAANTERIOR,
			ISNULL(TEMPOTOTALHORAANTERIOR, 0) AS TEMPOTOTALHORAANTERIOR,
			ISNULL(QTTOTAL, 0) AS QTTOTAL, 
			ISNULL(QTHORAATUAL, 0) AS QTHORAATUAL,
			ISNULL(TEMPOTOTALHORAAT, 0) AS TEMPOTOTALHORAAT,
			ISNULL(QTHORAANTERIOR, 0) AS QTHORAANTERIOR, 
			ISNULL(QTGERAL, 0) AS QTGERAL, 
			ISNULL(QTGERALHRANT, 0) AS QTGERALHRANT, 
			ISNULL(QTGERALHRATUAL, 0) AS QTGERALHRATUAL, 
			ISNULL(MEDIAHORAATUAL, 0) AS MEDIAHORAATUAL FROM 

			(
				SELECT KTS.CDSETOR, COUNT(NRTEMPOTOTAL) AS QTTOTAL, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIATOTAL, SUM(NRTEMPOTOTAL) AS NRTEMPOTOTAL FROM KDS_TEMP_SETOREST 
				KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR)
				WHERE KTS.CDSETOR = :CDSETOR
				AND NRTEMPOTOTAL IS NOT NULL
				GROUP BY KTS.CDSETOR
			) MDTOTAL
			
			LEFT JOIN 
	
			(
				SELECT KTS.CDSETOR, COUNT(NRTEMPOTOTAL) AS QTHORAATUAL, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIAHORAATUAL, SUM(NRTEMPOTOTAL) AS TEMPOTOTALHORAAT FROM KDS_TEMP_SETOREST 
				KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR)
				WHERE KTS.CDSETOR = :CDSETOR
				AND DTHRFIMPRODUCAO >= DATEADD(HOUR, -1, GETDATE())
				GROUP BY KTS.CDSETOR
			) MDHRATUAL ON (MDHRATUAL.CDSETOR = MDTOTAL.CDSETOR)
			
			LEFT JOIN (
				SELECT KTS.CDSETOR, COUNT(NRTEMPOTOTAL) AS QTHORAANTERIOR, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIAHORAANTERIOR,
				(SUM(NRTEMPOTOTAL)) AS TEMPOTOTALHORAANTERIOR
				FROM KDS_TEMP_SETOREST 
				KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR)
				WHERE KTS.CDSETOR = :CDSETOR
				AND DTHRFIMPRODUCAO >= DATEADD(HOUR, -2, GETDATE()) AND DTHRFIMPRODUCAO < DATEADD(HOUR, -1, GETDATE())
				GROUP BY KTS.CDSETOR
			) MDHRANT ON (MDHRANT.CDSETOR = MDTOTAL.CDSETOR)
	
			LEFT JOIN 
	
			(
				SELECT KTS.CDSETOR, COUNT(NRTEMPOTOTAL) AS QTGERAL, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIAGERAL FROM KDS_TEMP_SETOREST 
				KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR)
				WHERE KTS.CDSETOR = :CDSETOR
				AND NRTEMPOTOTAL IS NOT NULL
				GROUP BY KTS.CDSETOR
			) MDGERAL ON (MDGERAL.CDSETOR = :CDSETOR)	
	
			LEFT JOIN 
	
			(
				SELECT KTS.CDSETOR, COUNT(NRTEMPOTOTAL) AS QTGERALHRANT, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIAGERALHRANT, SUM(NRTEMPOTOTAL) AS TEMPOTOTALGERALHRANT FROM KDS_TEMP_SETOREST 
				KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR)
				WHERE KTS.CDSETOR = :CDSETOR
				AND DTHRFIMPRODUCAO >= DATEADD(HOUR, -2, GETDATE()) AND DTHRFIMPRODUCAO < DATEADD(HOUR, -1, GETDATE())
				GROUP BY KTS.CDSETOR
			) MDGERALHRANT ON (MDGERALHRANT.CDSETOR = :CDSETOR)
			
			LEFT JOIN 
	
			(
				SELECT KTS.CDSETOR, COUNT(NRTEMPOTOTAL) AS QTGERALHRATUAL, (SUM(NRTEMPOTOTAL) / COUNT(NRTEMPOTOTAL)) AS MEDIAGERALHRATUAL, SUM(NRTEMPOTOTAL) AS TEMPOTOTALGERALHRAAT FROM KDS_TEMP_SETOREST 
				KTS JOIN SETOR SE ON (SE.CDSETOR = KTS.CDSETOR)
				WHERE KTS.CDSETOR = :CDSETOR
				AND DTHRFIMPRODUCAO >= DATEADD(HOUR, -1, GETDATE())
				GROUP BY KTS.CDSETOR
			) MEDIAGERALHRATUAL ON (MEDIAGERALHRATUAL.CDSETOR = :CDSETOR)
	";

	const UPDATE_ITPEDIDOFOS_BY_NRVENDAREST = "
			UPDATE ITPEDIDOFOS
			SET DTULTATU = GETDATE()
			WHERE (NRVENDAREST = :NRID AND NRSEQVENDA IS NULL)
			OR (NRSEQVENDA = :NRID AND NRVENDAREST IS NULL)
	";

    // Não é chamada de nenhum lugar
	const OTHER_GET_STATISTICS = "
		SELECT * FROM (SELECT 
			CDFILIAL, IDTIPOSETOR,
			COUNT(ITE.CDSETOR) QTSETORES, 
			SUM(QTDIA) SUMQTCONCLUIDO,
			CASE SUM(QTDIA)
			   WHEN 0 THEN 1
			   ELSE
			      (SUM(MEDIADIA * QTDIA) / SUM(QTDIA))
			END AS MEDIAKDSDIA,
			SUM(QTHORAANT) SUMQTCONCLUIDOULTHR,
			CASE SUM(ISNULL(NULLIF(QTHORAANT, 0), DATEPART(HOUR, GETDATE())))
			   WHEN 0 THEN 1
			   ELSE
			      (SUM(MEDIAHORAANT * QTHORAANT) / SUM(ISNULL(NULLIF(QTHORAANT, 0), DATEPART(HOUR, GETDATE()))))
			END AS MEDIAKDSULTHR,
			SUM(QTHORA) SUMQTCONCLUIDOHR,
			CASE SUM(QTHORA) 
			   WHEN 0 THEN 1
			   ELSE
			      (SUM(MEDIAHORA * QTHORA) / SUM(QTHORA))
   			END AS MEDIAKDSHR 
		FROM 
			ITPEDIDOFOSEST ITE 
				JOIN 
					SETOR SE 
				ON 
					ITE.CDSETOR = SE.CDSETOR
		WHERE 
			CDFILIAL = :CDFILIAL
			AND SE.IDTIPOSETOR = :IDTIPOSETOR
		GROUP BY 
			CDFILIAL, 
			IDTIPOSETOR) AS GERAL

			LEFT JOIN 

			( 
			SELECT 
				IE.CDFILIAL, 
				IE.CDSETOR, 
				ISNULL(IE.VRTMPMEDPROD,  0) AS TEMPOMEDIO, 
				ISNULL(IE.VRTMPMEDINI, 0) AS TEMPOINICIO,
				ISNULL(IE.VRTMPMEDATRA,  0) AS TEMPOATRASO, 
				ISNULL(IE.VRPORCCOMANATRA, 0) AS PORCENTAGEM, 
				ISNULL(IE.IDDIA,0) AS IDDIA, 
				ISNULL(IE.QTDIA,0) AS QTDIA, 
				ISNULL(IE.IDHORA,0) AS IDHORA, 
				ISNULL(IE.QTHORAANT, 0) AS QTHORAANT, 
				ISNULL(CAST(IE.MEDIADIA AS VARCHAR), 0) AS MEDIADIA, 
				ISNULL(IE.QTHORA,0) AS QTHORA,
				ISNULL(CAST(IE.MEDIAHORA AS VARCHAR),0) AS MEDIAHORA, 
				ISNULL(CAST(IE.MEDIAHORAANT AS VARCHAR),0) AS MEDIAHORAANT
			FROM 
			ITPEDIDOFOSEST IE
				JOIN SETOR SE ON (IE.CDSETOR = SE.CDSETOR AND SE.IDTIPOSETOR = :IDTIPOSETOR)
				WHERE (IE.CDFILIAL = :CDFILIAL OR IE.CDFILIAL = 'T')
					AND (IE.CDSETOR = :CDSETOR OR :CDSETOR = 'T')
				) ESPECIFICO ON GERAL.CDFILIAL = ESPECIFICO.CDFILIAL AND GERAL.IDTIPOSETOR = ESPECIFICO.IDTIPOSETOR		
	";

	const GET_IDEXIBESTATIS = "
		SELECT IDEXIBESTATIS FROM PARAVEND
			WHERE CDFILIAL = :CDFILIAL
	";

	const GET_CLEAR_STATISTICS = "
		SELECT 
			IE.CDFILIAL, 
			IE.CDSETOR, 
			SE.IDTIPOSETOR,
			0 AS TEMPOMEDIO, 
			0 AS TEMPOINICIO,
			0 AS TEMPOATRASO, 
			0 AS PORCENTAGEM, 
			0 AS IDDIA, 
			0 AS QTDIA, 
			0 AS IDHORA, 
			0 AS QTHORAANT, 
			0 AS MEDIADIA, 
			0 AS QTHORA,
			0 AS MEDIAHORA, 
			0 AS MEDIAHORAANT ,
			0 AS QTSETORES,
			0 AS SUMQTCONCLUIDO,
			0 AS MEDIAKDSDIA,
			0 AS SUMQTCONCLUIDOULTHR,
			0 AS MEDIAKDSULTHR,
			0 AS SUMQTCONCLUIDOHR,
			0 AS MEDIAKDSHR
		FROM 
			ITPEDIDOFOSEST IE
			JOIN SETOR SE ON (IE.CDSETOR = SE.CDSETOR)
		WHERE 
			(IE.CDFILIAL = :CDFILIAL OR :CDFILIAL = 'T')
			AND (IE.CDSETOR = :CDSETOR OR :CDSETOR = 'T')
	";

	const GET_CDSETOR_BY_FILIAL = "
		SELECT CDSETOR
		FROM SETORFILIAL
		WHERE CDFILIAL = :CDFILIAL
	";

    const VERIFY_IDHABAGRUPPROD_SETORFILIAL = "
		SELECT IDHABAGRUPPROD 
			FROM SETORFILIAL 
		  WHERE CDSETOR  = :CDSETOR
	    	AND CDFILIAL = :CDFILIAL
	";

    const VERIFY_IDHABAGRUPPROD = "
		SELECT 1 AS UNEPORPEDIDO
			FROM SETORFILIAL 
		  WHERE CDFILIAL	    = :CDFILIAL
		    AND IDHABTIMERPROD  = 'N'
			AND IDCONCDIRETO	= 'S'
			AND IDHABAGRUPPROD  = 'S'
	";
}